// by paradox
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define y1 y1234567890

#define NAME ""
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define file_io freopen(NAME".in", "r", stdin); freopen(NAME".out", "w", stdout)

const int N = 2e5;
const int M = N + 7;
const double EPS = 1e-10;

const int MOD = 1e9 + 7;
const ll INF = 1e18 + 17;

const int K = 18;

int a[M], g[M][2];
int par[M][K + 2];
int tl[M], tr[M];
int h[M];

int tin[M], tout[M], timer;

void build(int v, int parent) {
    if (v != parent)
        h[v] = h[parent] + 1;
    tl[v] = tr[v] = a[v];
    tin[v] = ++timer;

    par[v][0] = parent;
    for (int k = 1; k < K; ++k)
        par[v][k] = par[par[v][k - 1]][k - 1];
    
    if (g[v][0]) {
        build(g[v][0], v);
        tl[v] = tl[g[v][0]];
    } 
    if (g[v][1]) {
        build(g[v][1], v);
        tr[v] = tr[g[v][1]];
    }
    tout[v] = ++timer;
}

int isParent(int v, int u) {
    return tin[v] <= tin[u] && tout[v] >= tout[u];
}

int lca(int v, int u) {
    if (isParent(v, u))
        return v;
    if (isParent(u, v))
        return u;

    for (int k = K - 1; k >= 0; --k) {
        if (!isParent(par[v][k], u))
            v = par[v][k];
    }
    return par[v][0];
}

map<int, int> p;

int getUp(int v, int l, int r, bool type) {
    if (!type) {
        if (tr[v] >= l)
            return v;
        for (int k = K - 1; k >= 0; --k) {
            if (tr[par[v][k]] < l)
                v = par[v][k];
        }
    } else {
        if (tl[v] <= r)
            return v;
        for (int k = K - 1; k >= 0; --k) {
            if (tl[par[v][k]] > r)
                v = par[v][k];
        }
    }
    return par[v][0];
}

void solve() {
    int n;
    scanf("%d", &n);
    set<int> s;
    for (int i = 1; i <= n; ++i) {
        scanf("%d %d %d", &g[i][0], &g[i][1], &a[i]);
        p[a[i]] = i;
        s.insert(a[i]);
    }
    build(1, 1);

    int q;
    scanf("%d", &q);
    for (int i = 1; i <= q; ++i) {
        int l, r;
        scanf("%d %d", &l, &r);

        if (l > tr[1] || r < tl[1]) {
            printf("0\n");
            continue;
        }
        if (l <= tl[1] && tr[1] <= r) {
            printf("1\n");
            continue;
        }

        auto itl = s.lower_bound(l);
        if (itl != s.begin())
            --itl;
        auto itr = s.upper_bound(r);
        if (itr == s.end())
            --itr;
        
        int vl = p[*itl];
        int vr = p[*itr];

        // cerr << l << ' ' << r << " | " << vl << ' ' << vr << "\n";

        vl = getUp(vl, l, r, 0);
        vr = getUp(vr, l, r, 1);

        int anc = lca(vl, vr);
        // cerr << vl << ' ' << vr << " | " << anc << "\n";
        int ans = h[vl] + h[vr] - h[anc] + 1;

        ans = ans * 2 + 1;

        printf("%d\n", ans);
        // cerr << "\n";
    }
}

int main() {
    int tt = 1;
    // scanf("%d", &tt);
    while (tt--) {
        solve();
    }
    return 0;
}