#include <bits/stdc++.h>

#define XA(X) X.begin(),X.end()
#define XE(A,B) for (int A = 0; A < (B); A++)
#define XI(F,V,C) V = F(V,C)
#define XL(X) #X << "=" << X << " "

#define M_PI 3.14159265358979323846

using namespace std;

typedef long long int i64;
typedef long double ld;

const int S = 1024*1024;
const i64 INF = 2e18+5;
const int MOD = 1000*1000*1000 + 7;
const ld EPS = 0.00000000001;
const i64 ENC = 1024*1024;

const bool LOCAL = false;

const int NONE = -42;

template<typename T> struct base_point {
    T x, y;

    base_point<T>() {

    }

    base_point<T>(T x, T y) {
        this->x = x;
        this->y = y;
    }

    void read() {
        cin >> x >> y;
    }

    pair<T, T> as_pair() {
        return make_pair(x, y);
    }

    base_point<T> operator+(base_point<T> &other) {
        return base_point<T>(x+other.x, y+other.y);
    }

    base_point<T> operator+(base_point<T> &&other) {
        return base_point<T>(x+other.x, y+other.y);
    }

    base_point<T> operator-(base_point<T> &other) {
        return base_point<T>(x-other.x, y-other.y);
    }

    base_point<T> operator-(base_point<T> &&other) {
        return base_point<T>(x-other.x, y-other.y);
    }


    base_point<T> operator*(T scalar) {
        return base_point<T>(x*scalar, y*scalar);
    }

    base_point<T> rotate90() {
        return base_point<T>(-y, x);
    }

    base_point<T> rotate(T angle) {
        return base_point<T>(
            cosl(angle) * x - sinl(angle) * y,
            cosl(angle) * y + sinl(angle) * x
        );
    }

    bool in_first_quadrant() {
        return (x >= 0 && y > 0);
    }

    T operator*(base_point<T> &other) {
        return x*other.x + y*other.y;
    }

    T operator%(base_point<T> &other) {
        return x*other.y - y*other.x;
    }

    T operator%(base_point<T> &&other) {
        return x*other.y - y*other.x;
    }

    bool operator<(base_point<T> &other) {
        if (x == other.x) return y < other.y;
        return x < other.x;
    }

    bool operator==(base_point<T> &other) {
        return (x == other.x) && (y == other.y);
    }

    bool operator==(base_point<T> &&other) {
        return (x == other.x) && (y == other.y);
    }

    bool operator!=(base_point<T> &other) {
        return (x != other.x) || (y != other.y);
    }

    bool operator!=(base_point<T> &&other) {
        return (x != other.x) || (y != other.y);
    }

    T norm() {
        return x*x + y*y;
    }

    T len() {
        return sqrtl(norm());
    }

};

typedef base_point<i64> point;

mt19937 mt_rand(time(0));

struct mre {
    int v;

    mre() {
        v = 0;
    }

    mre (int nv) {
        v = nv%MOD;
    }

    mre (i64 nv) {
        v = nv%MOD;
    }

    mre operator+(mre other) {
        int r = (v+other.v)%MOD;

        return mre(r);
    }

    mre operator-(mre other) {
        return mre(v) + other.neg();
    }

    mre operator*(mre other) {
        int r = (v*(i64)other.v)%MOD;

        return mre(r);
    }

    mre neg() {
        if (v == 0) return mre(0);

        return mre(MOD-v);
    }

    bool operator ==(mre& other) {
        return v == other.v;
    }

    bool operator ==(mre&& other) {
        return v == other.v;
    }

    mre bpow(int e) {
        if (e == 0) return mre(1);

        mre sq = mre(v)*mre(v);
        if (e & 1) {
            return sq.bpow(e/2) * mre(v);
        } else {
            return sq.bpow(e/2);
        }
    }

    mre inv() {
        return mre(v).bpow(MOD-2);
    }

    bool operator<(const mre& other) {
        return v < other.v;
    }

};

void fail() {
    cout << "NO" << endl;
    exit(0);
}

mre fact[2][S];

void prepare_fact() {
    fact[0][0] = mre(1);
    XE(i,S-1) fact[0][i+1] = fact[0][i] * mre(i+1);

    int last = S-1;

    fact[1][last] = fact[0][last].inv();

    for (int i = last-1; i >= 0; i--) fact[1][i] = fact[1][i+1] * mre(i+1);


    /*

    XE(i,20) {
        mre cm = fact[0][i] * fact[1][i];

        cout << XL(i) << XL(fact[0][i].v) << XL(fact[1][i].v) << XL(cm.v) << endl;
    }

    //*/
}

mre binom(int u, int d) {
    if (d < 0) return mre(0);
    if (u-d < 0) return mre(0);

    return fact[0][u] * fact[1][d] * fact[1][u-d];
}

vector<int> graph[S];
int n;
int root;

vector<int> dfs(int vx) {
    vector<int> res;

    res.push_back(vx);

    vector<int> merged_prefix;

    for (auto to : graph[vx]) {
        vector<int> toseq = dfs(to);

        vector<int> mpz;

        bool inv = false;
        for (auto e : toseq) {

            if (inv) {
                for (auto it = merged_prefix.rbegin(); it != merged_prefix.rend(); it++) {
                    mpz.push_back(*it);
                }
            } else {
                for (auto it = merged_prefix.begin(); it != merged_prefix.end(); it++) {
                    mpz.push_back(*it);
                }
            }

            inv ^= true;

            mpz.push_back(e);
        }

        /// push back last block
        if (inv) {
            for (auto it = merged_prefix.rbegin(); it != merged_prefix.rend(); it++) {
                mpz.push_back(*it);
            }
        } else {
            for (auto it = merged_prefix.begin(); it != merged_prefix.end(); it++) {
                mpz.push_back(*it);
            }
        }

        /// set new merged prefix
        merged_prefix = mpz;
    }

    for (auto e : merged_prefix) {
        res.push_back(e);
    }

    return res;
}

void solvet() {
    cin >> n;
    root = 1;

    for (int vx = 2; vx <= n; vx++) {
        int p;
        cin >> p;

        graph[p].push_back(vx);

    }

    vector<int> ans;


    ans = dfs(root);

    cout << ans.size()-1 << endl;
    for (int i = 1; i < ans.size(); i++) {
        cout << ans[i] << " ";
    }
    cout << endl;
}

void solve() {
    solvet();

}

/*

6
1 2 1 4 4

6
1 2 2 1 5

//*/

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cout << fixed;
    cout.precision(20);

    solve();
}

