#pragma comment(linker, "/STACK:128777216")
#pragma GCC optimize("fast-maths")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <bitset>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <climits>
#include <ctime>
#include <random>
#include <complex>
using namespace std;

#define forx(_name, _from, _to, _value) for (int _name = _from; _name < _to; _name += _value)
#define rforx(_name, _from, _to, _value) for (int _name = _from; _name > _to; _name -= _value)
#define all(_STL_NAME) _STL_NAME.begin(), _STL_NAME.end()
#define rall(_STL_NAME) _STL_NAME.rbegin(), _STL_NAME.rend()
#define mp(_FIRST,_SECOND) make_pair(_FIRST, _SECOND)

typedef long long ll;
typedef unsigned long long llu;
typedef long double ld;
const ld eps = 1e-8;
mt19937_64 rndm;

void start() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(10); cout.setf(ios::fixed);
	string FILENAME = "incredible";
	rndm.seed(time(0));
#ifdef _DEBUG
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	//freopen((FILENAME + ".in").c_str(), "rt", stdin);
	//freopen((FILENAME + ".out").c_str(), "wt", stdout);
#endif
}

inline bool FastIn(int& val, FILE* streamin = stdin) {
	val = 0;
	char c = ' ';
	while (!isdigit(c)) {
		c = _getchar_nolock();
		if (c == EOF)
			return false;
	}
	while (isdigit(c)) {
		val *= 10;
		val += c - '0';
		c = _getchar_nolock();
	}
	return true;
}

inline void FastOut(ll val, FILE* streamout = stdout) {
	bool fst = true;
	//const int degree = 1000000000;
	const ll degree = 1000000000000000000ll;
	for (ll i = degree; i > 0; i /= 10) {
		ll dl = val / i;
		if (dl || !fst) {
			_putchar_nolock('0' + dl);
			fst = false;
		}
		val %= i;
	}
	if (fst)
		_putchar_nolock('0');
	_putchar_nolock(' ');
}

struct state {
	int clr; // 1 green, 0 red
	int green;
	int red;
	int size;
	int cv = 1;
	int vec; // 1 - to green, 0 - to red
	vector<int> nxt;
};

const int maxn = 22;
state mt[maxn];
bool cmp(int a1, int a2) {
	state a = mt[a1];
	state b = mt[a2];
	if (a.cv != b.cv)
		return a.cv < b.cv;
	return a.nxt.size() < b.nxt.size();
}

void init_dfs(int v) {
	mt[v].clr = 1;
	mt[v].green = 1;
	mt[v].red = 0;
	mt[v].size = 1;
	int val = 1;
	for (int i = 0; i < mt[v].nxt.size(); ++i) {
		init_dfs(mt[v].nxt[i]);
		mt[v].green += mt[mt[v].nxt[i]].green;
		mt[v].size += mt[mt[v].nxt[i]].size;
		val *= mt[mt[v].nxt[i]].cv;
	}
	mt[v].cv += val;
	sort(all(mt[v].nxt), cmp);
}

bool used[1 << maxn];
int curstate = 0;
vector<int> ans;

bool chg(int v, int clr) {
	curstate ^= (1 << v);
	if (used[curstate]) {
		curstate ^= (1 << v);
		return false;
	}
	used[curstate] = 1;
	ans.emplace_back(v);
	mt[v].clr = clr;
	if (clr)
		mt[v].green++, mt[v].red--;
	else
		mt[v].green--, mt[v].red++;
	return true;
}

bool push(int v, int clr) {
	if ((!clr || mt[v].size == 1) && mt[v].clr != clr) {
		return chg(v, clr);
	}
	bool f = true;
	bool f2 = false;
	int x = 1;
	while (x < mt[v].cv) {
		++x;
		f = false;
		for (int i = 0; i < mt[v].nxt.size(); ++i) {
			if ((mt[mt[v].nxt[i]].green == mt[mt[v].nxt[i]].size && mt[mt[v].nxt[i]].vec) ||
				(mt[mt[v].nxt[i]].red == mt[mt[v].nxt[i]].size && !mt[mt[v].nxt[i]].vec)) {
				mt[mt[v].nxt[i]].vec = !mt[mt[v].nxt[i]].vec;
				continue;
			}
			mt[v].green -= mt[mt[v].nxt[i]].green;
			mt[v].red -= mt[mt[v].nxt[i]].red;
			f = push(mt[v].nxt[i], mt[mt[v].nxt[i]].vec);
			f2 |= f;
			mt[v].green += mt[mt[v].nxt[i]].green;
			mt[v].red += mt[mt[v].nxt[i]].red;
			if (f)
				break;
		}
	}
	if (clr)
		return mt[v].red == (1 - mt[v].clr) && chg(v, clr);
	return f2;
}

int main() {
	start();
	int n;
	cin >> n;
	for (int i = 2; i <= n; ++i) {
		int v;
		cin >> v;
		mt[v].nxt.emplace_back(i);
	}
	init_dfs(1);
	mt[1].green--;
	mt[1].red++;
	mt[1].clr = 0;
	mt[1].cv--;
	push(1, 0);
	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); ++i)
		cout << ans[i] << ' ';
#ifdef _DEBUG
	cout << "\nTime: " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}