#include <algorithm>
#include <queue>
#include <deque>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <bitset>
#include <cstring>
#include <cmath>
#include <stack>
#include <random>


using namespace std;
using ll = long long;
#define forn(i, n) for(ll i = 0; i < n; ++i)

const ll INF = 1e9;
const ll MOD = 1e17;
const ll MAXN = 2 * 1e5 + 100;
const ll MAXL = 20;

vector<vector<int> > graph;

vector<int> vector_union(vector<int>& from, vector<int>& add) {
    vector<int> result = add;
    vector<int> rev = add;
    reverse(rev.begin(), rev.end());
    for (int i = 0; i < from.size(); ++i) {
        result.push_back(from[i]);
        for (int j = 0; j < add.size(); ++j) {
            if (i % 2 == 0) {
                result.push_back(add[j]);
            } else {
                result.push_back(rev[j]);
            }
        }
    }
    return result;
}

vector<int> build(int vert) {
    vector<int> res;
    for (int to : graph[vert]) {
        auto to_v = build(to);
        res = vector_union(res, to_v);
    }
    vector<int> ans = {vert};
    for (int a : res) {
        ans.push_back(a);
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    graph.resize(n);
    for (int i = 1; i < n; ++i) {
        int a;
        cin >> a;
        --a;
        graph[a].push_back(i);
    }
    auto res = build(0);
    cout << res.size() - 1 << '\n';
    for (int i = 1; i < res.size(); ++i) {
        cout << res[i] + 1 << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0),cout.tie(0);
    cout << fixed << setprecision(16);
#ifdef LOCAL
    freopen("input.in", "r", stdin);
#endif
    solve();
    return 0;
}