#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <vector>
#include <string>
#include <stack>
#include <map>
#include <set>
#include <fstream>
#include <queue>
#include <assert.h>
#include <random>
#include <chrono>
#include <istream>
#include <ostream>
#include <iterator>
#include <cctype>
#include <iomanip>

using namespace std;

typedef unsigned long long ull;
typedef long double ld;

//mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
const int inf = 1000000000;


int idcount = 0;

struct node
{
    int id;
    int w;
    int lw;
    int rw;
    node* left;
    node* right;

    node(int _w)
    {
        idcount++;
        left = nullptr;
        right = nullptr;
        w = _w;
        id = idcount;
        lw = 0;
        rw = 0;
    }
};

struct res
{
    int id;
    int w;
    int leftid;
    int rightid;
};

bool comp(res a, res b)
{
    return a.id < b.id;
}


void add(node* tree, int w)
{
    node* prev = nullptr;
    node* curr = tree;

    while (curr != nullptr)
    {
        prev = curr;
        if (curr->lw == curr->rw)
        {
            curr->lw += w;
            curr = curr->left;
        }  
        else
        {
            curr->rw += w;
            curr = curr->right;
        }
    }

    node* nw = new node(w);
    if (prev->left == nullptr)
    {
        prev->left = nw;
    }
    else
    {
        prev->right = nw;
    }
}

bool is_balanced(node* tree)
{
    if (tree == nullptr)
        return true;

    if (abs(tree->lw - tree->rw) >= 2)
    {
        return false;
    }

    return is_balanced(tree->left) && is_balanced(tree->right);
}

void print_tree(node* tree, vector<res> &result)
{
    if (tree == nullptr)
        return;

    int leftid = tree->left == nullptr ? 0 : tree->left->id;
    int rightid = tree->right == nullptr ? 0 : tree->right->id;
    res r;
    r.id = tree->id;
    r.leftid = leftid;
    r.rightid = rightid;
    r.w = tree->w;
    result.push_back(r);
    print_tree(tree->left, result);
    print_tree(tree->right, result);
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    //freopen("collect.in", "r", stdin);
    //freopen("collect.out", "w", stdout);


    int a, b;
    cin >> a >> b;
   
    node* tree = nullptr;

    for (int i = 0; i < b; i++)
    {
        if (tree == nullptr)
        {
            tree = new node(2);
        }
        else
        {
            add(tree, 2);
        }
    }

    for (int i = 0; i < a; i++)
    {
        if (tree == nullptr)
        {
            tree = new node(1);
        }
        else
        {
            add(tree, 1);
        }
    }

    if (is_balanced(tree))
    {
        vector<res> result;
        print_tree(tree, result);
        sort(result.begin(), result.end(), comp);
        for (int i = 0; i < result.size(); i++)
        {
            cout << result[i].w << " " << result[i].leftid << " " << result[i].rightid << "\n";
        }
    }
    else
    {
        cout << -1 << endl;
    }

    return 0;
}