#pragma comment(linker, "/STACK:66777216")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,mmx,abm,popcnt")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <vector>
#include <string>
#include <stack>
#include <map>
#include <set>
#include <fstream>
#include <queue>
#include <assert.h>
#include <random>
#include <chrono>
#include <istream>
#include <ostream>
#include <iterator>
#include <cctype>
#include <iomanip>

using namespace std;

typedef unsigned long long ull;
typedef long double ld;
/*
20
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
*/
//mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
const int inf = 1000000000;

const int MAXN = 20;
const int MAXMASK = 1 << 20;

int parents[MAXN];
bool isvalid[MAXMASK];
bool isused[MAXMASK];
int ans[MAXMASK];
bool is_valid(int n, int mask)
{
    if (mask % 2 == 0)
        return false;

    for (int i = 1; i < n; i++)
    {
        if (((1 << i) & mask) != 0 &&
            ((1 << parents[i]) & mask) == 0)
            return false;
    }

    return true;
}

int maxsize = 0;
int valids = 0;
int iters = 0;
int maxiters = 1e8;

void dfs(int n, int current, vector<int>& result)
{
    iters++;
    if (iters > maxiters)
        return;
    //cout << maxsize << endl;
    if (maxsize == valids - 1)
        return;
    if (result.size() > maxsize)
        maxsize = result.size();

    bool found = false;
    for (int q = 1; q < n; q++)
    {
        int next = current ^ (1 << q);
        if (isvalid[next] && !isused[next])
        {
            found = true;
            result.push_back(q + 1);
            isused[next] = true;
            dfs(n, next, result);
            result.pop_back();
            isused[next] = false;
        }
    }
}

bool dfs1(int n, int current, vector<int>& result)
{
    if (result.size() == maxsize)
    {
        cout << maxsize << '\n';
        for (auto v : result)
            cout << v << ' ';
        return true;
    }

    for (int q = 1; q < n; q++)
    {
        int next = current ^ (1 << q);
        if (isvalid[next] && !isused[next])
        {
            result.push_back(q + 1);
            isused[next] = true;

            if (dfs1(n, next, result))
                return true;
            result.pop_back();
            isused[next] = false;
        }
    }

    return false;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    //freopen("collect.in", "r", stdin);
    //freopen("collect.out", "w", stdout);


    int n;
    cin >> n;

    for (int i = 1; i < n; i++)
    {
        int x;
        cin >> x;
        parents[i] = x - 1;
    }

    int lim = 1 << n;
    for (int mask = 0; mask < lim; mask++)
    {
        isvalid[mask] = false;
        if (is_valid(n, mask))
        {
            isvalid[mask] = true;
            valids++;
        }

    }

    for (int i = 0; i < MAXMASK; i++)
        isused[i] = false;

    vector<int> result;
    result.reserve(valids);

    int current = 1;
    isused[current] = true;
    dfs(n, current, result);
    //cout << maxsize;
    memset(isused, 0, sizeof isused);
    result.clear();
    result.reserve(valids);
    isused[current] = true;
    dfs1(n, current, result);

    return 0;
}