#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define rep(i, a, n) for (int i = (a); i < (n); ++i)
#define per(i, a, n) for (int i = (n)-1; i >= (a); --i)

template <typename T1, typename T2>
inline bool umin(T1& x, const T2& y) { return y < x ? x = y, true : false; }

template <typename T1, typename T2>
inline bool umax(T1& x, const T2& y) { return x < y ? x = y, true : false; }

typedef long long ll;

const int maxn = (int)1e5+5;
const int mod = (int)1e9+7;
const int inf = (int)1e9+17;
const ll llinf = (ll)1e18+17;


int n;
int cnt_ok;
string a, b;
bool available[11];
char digitOf[255];


void solve_f(const string& c, int p, int carry);
void solve_s(const string& c, int p, int carry);

void solve_f(const string& c, int p, int carry) {

  // cerr << "Solve_f " << p << "\n";
  // rep(i, 0, 10) cerr << available[i]; cerr << endl;

  if (cnt_ok > 1) return; 
  if (p == c.length()) {
    if (digitOf[a.front()] != 0 && digitOf[b.front()] != 0 
      && digitOf[c.front()] != 0) {
      cnt_ok += 1;
    }
    return;
  }
  
  char f = (p < a.length() ? a[a.length() - p - 1] : 0);
  if (f == 0 || digitOf[f] != '?') {
    solve_s(c, p, carry);
    return;
  }
  for (int fmap = 0; fmap < 10; ++fmap) {
    if (available[fmap]) {
      digitOf[f] = fmap;
      available[fmap] = false;
      // cerr << "Fixed " << f << " as " << fmap << " at pos " << p << endl;
      solve_s(c, p, carry);
      digitOf[f] = '?';
      available[fmap] = true;
    }
  }
}

void solve_s(const string& c, int p, int carry = 0) {
  if (cnt_ok > 1) return;
  char f = (p < a.length() ? a[a.length() - p - 1] : 0);
  char s = (p < b.length() ? b[b.length() - p - 1] : 0);
  if (s == 0 || digitOf[s] != '?') {
    int s_digit = (s == 0 ? 0 : digitOf[s]);
    int f_digit = (f == 0 ? 0 : digitOf[f]);
    int fs_digit = (f_digit + s_digit + carry) % 10;
    char t = c[c.length() - p - 1];
    if (digitOf[t] == '?' && available[fs_digit]) {
      digitOf[t] = fs_digit;
      available[fs_digit] = false;
      solve_f(c, p + 1, (f_digit + s_digit + carry) / 10);
      digitOf[t] = '?';
      available[fs_digit] = true;
    } else if (fs_digit == digitOf[t]) {
      solve_f(c, p + 1, (f_digit + s_digit + carry) / 10);
    }
    return; 
  }
  char t = c[c.length() - p - 1];
  for (int smap = 0; smap < 10; ++smap) {
    if (available[smap]) {
      available[smap] = false;
      digitOf[s] = smap;
      int s_digit = (s == 0 ? 0 : digitOf[s]);
      int f_digit = (f == 0 ? 0 : digitOf[f]);
      int fs_digit = (f_digit + s_digit + carry) % 10;
      if (digitOf[t] == '?' && available[fs_digit]) {
        digitOf[t] = fs_digit;
        available[fs_digit] = false;
        solve_f(c, p + 1, (f_digit + s_digit + carry) / 10);
        digitOf[t] = '?';
        available[fs_digit] = true;
      } else if (fs_digit == digitOf[t]) {
        solve_f(c, p + 1, (f_digit + s_digit + carry) / 10);
      }

      available[smap] = true;
      digitOf[s] = '?';
    }
  }
}

bool try_match(const string& s) {
  fill(available, available + 10, true);
  fill(digitOf, digitOf + 255, '?');
  cnt_ok = 0;
  solve_f(s, 0, 0);
  return (cnt_ok == 1);
}

int32_t main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
  // freopen("input.txt", "r", stdin);
  freopen("brainteaser2.in", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

  
  cin >> a >> b >> n;
  if (a.length() < b.length()) {
    swap(a, b);
  }
  vector<char> cnt(maxn);
  for(unsigned char c : a) {
    ++cnt[c];
  }
  for(unsigned char c : b) {
    ++cnt[c];
  }
  vector<string> possible;
  rep(i, 0, n) {
    string s;
    cin >> s;
    int m = max(a.length(), b.length());
    if (s.length() != m && s.length() != m + 1) {
      continue;
    }
    for(unsigned char c : s) {
      ++cnt[c];
    }
    int d = 0;
    rep(i, 'A', 'Z' + 1) {
      d += cnt[i] > 0;
    }
    for(unsigned char c : s) {
      --cnt[c];
    }
    if (d > 10) continue;
    if (try_match(s)) {
      possible.push_back(s);
    }
  } 
  cout << possible.size() << endl;
  // return 0;
  for (const string& s : possible) {
    cout << s << '\n';
  }

  return 0;
}
