#pragma GCC optimize("O3")

#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define rep(i, a, n) for (int i = (a); i < (n); ++i)
#define per(i, a, n) for (int i = (n)-1; i >= (a); --i)

template <typename T1, typename T2>
inline bool umin(T1& x, const T2& y) { return y < x ? x = y, true : false; }

template <typename T1, typename T2>
inline bool umax(T1& x, const T2& y) { return x < y ? x = y, true : false; }

typedef long long ll;

const int maxn = (int)1e5+5;
const int mod = (int)1e9+7;
const int inf = (int)1e9+17;
const ll llinf = (ll)1e18+17;


int n;
int cnt_ok;
string a, b, c;
bool available[12];
int digitOf[255];


void solve_f(int p, int carry);
void solve_s(int p, int carry);

void solve_f(int p, int carry) {
  if (cnt_ok > 1) return; 
  if (digitOf[a.front()] == 0 || digitOf[b.front()] == 0 || digitOf[c.front()] == 0) {
    return;
  }
  if (p == c.length()) {
    unsigned char ac = a.front();
    unsigned char bc = b.front();
    unsigned char cc = c.front();
    if (digitOf[ac] != 0 && digitOf[bc] != 0 
      && digitOf[cc] != 0 && carry == 0) {
      ++cnt_ok;
    }
    return;
  }
  
  unsigned char f = (p < a.length() ? a[a.length() - p - 1] : 0);
  if (f == 0 || digitOf[f] != -1) {
    solve_s(p, carry);
    return;
  }
  for (int fmap = 0; fmap < 10; ++fmap) {
    if (available[fmap]) {
      digitOf[f] = fmap;
      available[fmap] = false;
      solve_s(p, carry);
      digitOf[f] = -1;
      available[fmap] = true;
    }
  }
}

void solve_s(int p, int carry) {
  if (cnt_ok > 1) return;
  unsigned char f = (p < a.length() ? a[a.length() - p - 1] : 0);
  unsigned char s = (p < b.length() ? b[b.length() - p - 1] : 0);
  if (s == 0 || digitOf[s] != -1) {
    int s_digit = (s == 0 ? 0 : digitOf[s]);
    int f_digit = (f == 0 ? 0 : digitOf[f]);
    int fs_digit = (f_digit + s_digit + carry);
    fs_digit = (fs_digit >= 10 ? fs_digit - 10 : fs_digit);
    unsigned char t = c[c.length() - p - 1];
    if (digitOf[t] == -1 && available[fs_digit]) {
      digitOf[t] = fs_digit;
      available[fs_digit] = false;
      solve_f(p + 1, (f_digit + s_digit + carry) != fs_digit);
      digitOf[t] = -1;
      available[fs_digit] = true;
    } else if (fs_digit == digitOf[t]) {
      solve_f(p + 1, (f_digit + s_digit + carry) != fs_digit);
    }
    return; 
  }
  unsigned char t = c[c.length() - p - 1];
  for (int smap = 0; smap < 10; ++smap) {
    if (available[smap]) {
      available[smap] = false;
      digitOf[s] = smap;

      int s_digit = (s == 0 ? 0 : digitOf[s]);
      int f_digit = (f == 0 ? 0 : digitOf[f]);

      int fs_digit = (f_digit + s_digit + carry);
      fs_digit = (fs_digit >= 10 ? fs_digit - 10 : fs_digit);
      if (digitOf[t] == -1 && available[fs_digit]) {
        digitOf[t] = fs_digit;
        available[fs_digit] = false;
        
        solve_f(p + 1, (f_digit + s_digit + carry) != fs_digit);
        
        digitOf[t] = -1;
        available[fs_digit] = true;
      } else if (fs_digit == digitOf[t]) {
        solve_f(p + 1, (f_digit + s_digit + carry) != fs_digit);
      }

      available[smap] = true;
      digitOf[s] = -1;
    }
  }
}

bool try_match(const string& s) {
  fill(available, available + 11, true);
  fill(digitOf, digitOf + 255, -1);
  cnt_ok = 0;
  c = s;
  solve_f(0, 0);
  return (cnt_ok == 1);
}

int32_t main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
  // freopen("input.txt", "r", stdin);
  freopen("brainteaser2.in", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

  
  cin >> a >> b >> n;
  if (a.length() < b.length()) {
    swap(a, b);
  }
  vector<int> cnt(255);
  for(unsigned char c : a) {
    ++cnt[c];
  }
  for(unsigned char c : b) {
    ++cnt[c];
  }
  vector<string> possible;
  rep(i, 0, n) {
    string s;
    cin >> s;
    int m = max(a.length(), b.length());
    if (s.length() != m && s.length() != m + 1) {
      continue;
    }
    for(unsigned char c : s) ++cnt[c];
    int d = 0;
    rep(i, 'A', 'Z' + 1) {
      if (cnt[i] > 0) {
        ++d;
      }
    }
    for(unsigned char c : s) --cnt[c];
    if (d > 10) continue;
    if (try_match(s)) {
      possible.push_back(std::move(s));
    }
  } 
  cout << possible.size() << endl;
  // return 0;
  for (const string& s : possible) {
    cout << s << '\n';
  }

  return 0;
}
