#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x)
#define rep(i, a, n) for (int i = (a); i < (n); ++i)
#define per(i, a, n) for (int i = (n)-1; i >= (a); --i)

template <typename T1, typename T2>
inline bool umin(T1& x, const T2& y) { return y < x ? x = y, true : false; }

template <typename T1, typename T2>
inline bool umax(T1& x, const T2& y) { return x < y ? x = y, true : false; }

typedef long long ll;

const int maxn = (int)6e5+5;
const int mod = (int)1e9+7;
const int inf = (int)1e9+17;
const ll llinf = (ll)1e18+17;


int n, q;
int total;
int lf[maxn];
int rg[maxn];
int key[maxn];
int ans[maxn];
vector<int> lfs;
vector<int> rgs;
vector<tuple<int,int,int>> events;


pair<int,int> prepare(int v) {
  if (v == -1) return {inf+inf, -inf-inf};
  int l = prepare(lf[v]).first;
  int r = prepare(rg[v]).second;
  umin(l, key[v]);
  umax(r, key[v]);

  if (lf[v] != -1 || rg[v] != -1) {
    lfs.push_back(l);
    rgs.push_back(r);
    total += 2;
    events.emplace_back(0, ~r, +2);
    events.emplace_back(l + 1, ~r, -2);
  }
  return {l, r};
}

namespace fenwick {
  int f[maxn];
  void modify(int p, int x) {
    for (; p < maxn; p |= (p+1)) {
      f[p] += x;
    }
  }
  int getsum(int p) {
    int sum = 0;
    for (; p >= 0; p = (p & (p+1)) - 1) {
      sum += f[p];
    }

    return sum;
  }
}

int32_t main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr), cout.tie(nullptr);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif

  cin >> n;
  vector<int> cmp;
  rep(i, 0, n) {
    cin >> lf[i] >> rg[i] >> key[i];
    --lf[i], --rg[i];
    key[i] += inf;
    cmp.push_back(key[i]);
  }
  cin >> q;
  rep(i, 0, q) {
    int l, r;
    cin >> l >> r;
    l += inf;
    r += inf;
    cmp.push_back(l);
    cmp.push_back(r);
    events.emplace_back(l, r, i);
  }
  prepare(0);
  sort(all(events));
  sort(all(lfs));
  sort(all(rgs));
  sort(all(cmp));
  cmp.erase(unique(all(cmp)), end(cmp));
  for(auto [l, r, x] : events) {
    if (r < 0) {
      r = ~r;
      r = lower_bound(all(cmp), r) - begin(cmp);
      fenwick::modify(r, x);
    } else {
      ans[x] += 2 * (end(lfs) - upper_bound(all(lfs), r));
      ans[x] += 2 * (lower_bound(all(rgs), l) - begin(rgs));

      r = lower_bound(all(cmp), r) - begin(cmp);
      ans[x] += fenwick::getsum(r);
    }
  }
  rep(i, 0, q) cout << total - ans[i] + 1 << '\n';

  return 0;
}
