#include <bits/stdc++.h>

using namespace std;

const int maxn = 1000500;

using ll = long long;

struct pt {
    ll x, y;
};

struct line {
    ll A, B, C;
    int side;
    line(pt p, pt q, pt z) {
        A = q.y - p.y;
        B = p.x - q.x;
        C = -A * p.x - B * p.y;
        side = getside(z);
    }

    int getside(const pt& p) const {
        ll v = A * p.x + B * p.y + C;
        if (v < 0) return -1;
        if (v > 0) return 1;
        return 0;
    }
    int getside(double x, double y) const {
        double v = A * x + B * y + C;
        if (v < 0) return -1;
        if (v > 0) return 1;
        return 0;
    }
};

ll area(const pt& A, const pt& B, const pt& C) {
    ll val = (A.x + B.x) * (A.y - B.y) + (B.x + C.x) * (B.y - C.y) + (C.x + A.x) * (C.y - A.y);
    if (val < 0) return -val;
    return val;
}

double area(const pt& A, const pt& B, double x, double y) {
    double val = (A.x + B.x) * (A.y - B.y) + (B.x + x) * (B.y - y) + (x + A.x) * (y - A.y);
    if (val < 0) return -val;
    return val;
}

ll are;
pt A, B, C;
const double kEps = 1e-7;

bool IsZero(const double x) {
    return fabs(x) < kEps;
}

bool inside(pt D) {
    return area(A, B, D) + area(B, C, D) + area(C, A, D) == are;
}
bool inside(double x, double y) {
    auto p = area(A, B, x, y) + area(B, C, x, y) + area(C, A, x, y);
    return IsZero(p - are);
}

const int mod = 1e9 + 7;

int fact[2 * maxn];
int factinv[2 * maxn];
int inv[2 * maxn];

int mul(int x, int y) {
    return x * 1LL * y % mod;
}

int c(int n, int k) {
    if (n < k || k < 0 || n < 0) return 0;
    return mul(fact[n], mul(factinv[k], factinv[n - k]));
}

int calc(int n, int k) {
    int res = c(n, k);
    res = mul(res, n + 1);
    res = mul(res, inv[k + 1]);
    return res;
}

int calc(int k, int l, int r) {
    l += k;
    r += k;
    int res = calc(r, k);
    if (l > 0) res -= calc(l - 1, k);
    if (res < 0) res += mod;
    return res;
//    int res = 0;
//    for (int n = l; n <= r; ++n) {
//        res += c(n, k);
//        cout << n << ' ' << k << ' ' << c(n, k) << endl;
//        if (res >= mod) res -= mod;
//    }
//    return res;
}

void solve() {
    cin >> A.x >> A.y >> B.x >> B.y >> C.x >> C.y;
//    A.x = -1000000;
//    A.y = 1000000;
//    B.x = 1000000;
//    B.y = 1000000;
//    C.x = 0;
//    C.y = 0;
//
    are = area(A, B, C);
    line L1(A, B, C);
    line L2(B, C, A);
    line L3(C, A, B);
    int res = 0;
    for (int k = 0; k < maxn; ++k) {
        pt O{-k, k};
//        pt dir{1, 1};

        bool is_inside = inside(O);

        double tmin = 0;
        double tmax = 1e9;
        for (const auto& l : {L1, L2, L3}) {
            if (l.A + l.B != 0) {
                double t = -(l.C + l.A * O.x + l.B * O.y) / 1.0 / (l.A + l.B);
//                bool is = l.getside(O.x + t + kEps, O.y + t + kEps) == l.side;
//                cerr << k << ' ' << t << ' ' << is_inside << ' ' << is << endl;
//                std::cerr << "t = " << t << std::endl;
                if (!inside(O.x + t + kEps, O.y + t + kEps)) {
//                if (!is) {
                    tmax = std::min(tmax, t);
                } else {
                    tmin = std::max(tmin, t);
                }
            } else {
//                assert(false);
            }
        }

//        std::cerr << tmin << ' ' << tmax << std::endl;

        int nl = tmin - 2;
        int nr = tmax + 2;
        while (nl <= nr && !inside(O.x + nl, O.y + nl)) nl++;
        while (nl <= nr && !inside(O.x + nr, O.y + nr)) nr--;
        if (nr > maxn) {
            assert(false);
        }
        if (nl > nr) {
            continue;
        }
//        cerr << k << ' ' << tmin << ' ' << tmax << ' ' << nl << ' ' << nr << endl;
        res += calc(k, nl, nr);
        if (res >= mod) res -= mod;
//        for (int n = k; n < maxn; ++n) {
//            if (tmin <= n && n <= tmax) {
//                std::cout << n << ' ' << k << endl;
//            }
//        }

    }
    cout << res << endl;
}

int main() {
//    freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    fact[0] = fact[1] = inv[0] = inv[1] = 1;
    factinv[0] = factinv[1] = 1;
    for (int i = 2; i < 2 * maxn; ++i) {
        fact[i] = mul(fact[i - 1], i);
        inv[i] = mul(inv[mod % i], mod - mod / i);
        factinv[i] = mul(factinv[i - 1], inv[i]);
    }

    int t;
    cin >> t;
//t = 5;
    while (t--) {
        solve();
    }

    return 0;
}
