// template text {{{1
#include <bits/stdc++.h>
using namespace std;

typedef long long llint;

#define fir first
#define sec second

#define len(v) (int)((v).size())

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937_64 rnd64(chrono::steady_clock::now().time_since_epoch().count());

#ifdef LOCAL

string to_string(string s);
string to_string(const char* s);
string to_string(char c);
string to_string(bool b);
template<class C>
string to_string(C c);
template<class A, class B>
string to_string(pair<A, B> p);
template<size_t N>
string to_string(bitset<N> b);
template<class A>
string to_string(A* a, int begin, int end);

string to_string(string s) {
  return string("\"") + s + "\"";
}

string to_string(const char* s) {
  return string("\"") + s + "\"";
}

string to_string(char c) {
  return string("\'") + c + "\'";
}

string to_string(bool b) {
  return b ? "True" : "False";
}

template<class C>
string to_string(C c) {
  bool f = false;
  stringstream s;
  s << "{";
  for (auto i: c) {
    if (f) s << ", ";
    f = true;
    s << to_string(i);
  }
  s << "}";
  return s.str();
}

template<class A, class B>
string to_string(pair<A, B> p) {
  return "(" + to_string(p.fir) + ", " + to_string(p.sec) + ")";
}

template<size_t N>
string to_string(bitset<N> b) {
  return b.to_string();
}

template<class A>
string to_string(A* a, int begin, int end) {
  bool f = false;
  stringstream s;
  s << "{";
  for (int i = begin; i < end; i++) {
    if (f) s << ", ";
    f = true;
    s << to_string(a[i]);
  }
  s << "}";
  return s.str();
}


template<class T>
void watch_output(T v) {
  cerr << "    " << to_string(v) << endl;
}

template<class T>
void watch_output(T* a, int begin, int end) {
  cerr << "    " << to_string(a, begin, end) << endl;
}

template<class T, class... Args>
void watch_output(T v, Args... args) {
  cerr << "    " << to_string(v) << ",\n";
  watch_output(args...);
}

#define watch(...) cerr << "[" << __func__ << ":"<< __LINE__ << "]: " #__VA_ARGS__ ":\n", watch_output(__VA_ARGS__)

#else 
#define watch(...) 
#endif
//}}}1

int n, m;
struct Node {
  int l;
  int r;
  int sz;
  int w;
  Node() : l(-1), r(-1), sz(0) {}
};
vector<Node> g;

void PutB(int i) {
  if (g.empty()) {
    g.emplace_back();
    g.back().sz = 2;
    g.back().w = 2;
    return;
  }
  g[i].sz += 2;
  if (g[i].l == -1) {
    g[i].l = len(g);
    g.emplace_back();
    g.back().sz = 2;
    g.back().w = 2;
    return;
  }
  if (g[i].r == -1) {
    g[i].r = len(g);
    g.emplace_back();
    g.back().sz = 2;
    g.back().w = 2;
    return;
  }
  if (g[g[i].l].sz > g[g[i].r].sz) {
    PutB(g[i].r);
  } else {
    PutB(g[i].l);
  }
}

void PutA(int i) {
  if (g.empty()) {
    g.emplace_back();
    g.back().sz = 1;
    g.back().w = 1;
    return;
  }
  g[i].sz += 1;
  if (g[i].l == -1) {
    g[i].l = len(g);
    g.emplace_back();
    g.back().sz = 1;
    g.back().w = 1;
    return;
  }
  if (g[i].r == -1) {
    g[i].r = len(g);
    g.emplace_back();
    g.back().sz = 1;
    g.back().w = 1;
    return;
  }
  if (g[g[i].l].sz > g[g[i].r].sz) {
    PutA(g[i].r);
  } else {
    PutA(g[i].l);
  }
}

bool Check(int i) {
  if (g[i].l != -1) {
    if (g[i].r != -1) {
      if (abs(g[g[i].l].sz - g[g[i].r].sz) > 1) {
        return false;
      }
    } else if (g[g[i].l].sz > 1) {
      return false;
    }
  }
  if (g[i].l != -1 && !Check(g[i].l)) {
    return false;
  }
  if (g[i].r != -1 && !Check(g[i].r)) {
    return false;
  }
  return true;
}

int main() {
#ifdef LOCAL
  freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#endif
  ios_base::sync_with_stdio(false); cin.tie(nullptr);
  cin >> n >> m;
  while (m--) {
    PutB(0);
  }
  while (n--) {
    PutA(0);
  }
  if (!Check(0)) {
    cout << "-1\n";
    return 0;
  }
  for (int i = 0; i < len(g); ++i) {
    cout << g[i].w << " " << g[i].l+1 << " " << g[i].r+1 << "\n";
  }
  return 0;
}
