#include <bits/stdc++.h>

using namespace std;

typedef pair<int,int> pii;

struct Node {
	int LSon, RSon;
	int L, R;
	int val;
	int cnt;
};

const int INF = 1e9 + 100;

const int MX = 2e5 + 100;
const int LOG = 20;
Node Tree[MX];
int dep[MX];

int jumps[MX][LOG];

void dfs_calc(int v, int d, int p = -1) {
	if (v == 0) return;

	if (p == -1) p = v;
	jumps[v][0] = p;
	for (int i = 1; i < LOG; i++) jumps[v][i] = jumps[jumps[v][i-1]][i - 1];

	dep[v] = d;
	Tree[v].L = Tree[v].val;
	Tree[v].R = Tree[v].val;
	Tree[v].cnt = 1;

	if (Tree[v].LSon > 0) {
		dfs_calc(Tree[v].LSon, d + 1, v);
		Tree[v].L = Tree[ Tree[v].LSon ].L;
		Tree[v].cnt += Tree[ Tree[v].LSon ].cnt;
	}
	if (Tree[v].RSon > 0) {
		dfs_calc(Tree[v].RSon, d + 1, v);
		Tree[v].R = Tree[ Tree[v].RSon ].R;
		Tree[v].cnt += Tree[ Tree[v].RSon ].cnt;
	}
}

int lookup(int v, int LB, int RB) {
	if (v == 0) return 1;
	if (LB <= Tree[v].L and Tree[v].R <= RB) return 1;
	if (Tree[v].R < LB or RB < Tree[v].L) return 1;

	int res = 1;
	res += lookup(Tree[v].LSon, LB, RB);
	res += lookup(Tree[v].RSon, LB, RB);
	return res;
}

const int ADD = 0;
const int QUERY = 1;
const int DELETE = 2;

struct Event {
	int time;
	int tupe;
	int p;

	Event(int a, int b, int c) {
		tupe = a;
		time = b;
		p = c;
	}

	inline bool operator < (const Event& foo) const {
		if (time != foo.time) return time < foo.time;
		if (tupe != foo.tupe) return tupe < foo.tupe;
		return p < foo.p;
	}
};

int qq[MX][2];
int q_lca[MX];

int main() {
	int n;
	ignore = scanf("%d", &n);

	map<int,int> where_val;

	for (int i = 1; i <= n; i++) {
		ignore = scanf("%d %d %d", &Tree[i].LSon, &Tree[i].RSon, &Tree[i].val);
		where_val[ Tree[i].val ] = i;
	}

	where_val[INF] = -1;
	where_val[-INF] = -1;

	int q;
	ignore = scanf("%d", &q);
	for (int i = 1; i <= n; i++) {
		ignore = scanf("%d %d", &qq[i][0], &qq[i][1]);
	}

	dfs_calc(1, 1);
	
	{
		vector<Event> ev;
		for (int i = 1; i <= n; i++) {
			ev.emplace_back(QUERY, qq[i][0], i);
		}
		for (int i = 1; i <= n; i++) {
			ev.emplace_back(ADD, Tree[i].L, i);
			ev.emplace_back(DELETE, Tree[i].R, i);
		}
	
		sort(ev.begin(), ev.end());

		set<pii> open_segm;
		for (auto& e : ev) {
			if (e.tupe == ADD) {
				open_segm.emplace(Tree[e.p].R, e.p);
			}
			else if (e.tupe == QUERY) {

				if (open_segm.size() == 0u) {
					q_lca[ e.p ] = -1;
				}
				else {
					const int in_segm = open_segm.rbegin()->second;
					q_lca[ e.p ] = in_segm;
				}
			}
			else if (e.tupe == DELETE) {
				open_segm.erase( {e.time, e.p} );
			}
		}
	}

	for (int i = 1; i <= q; i++) {
		int cur_ans;
		const int lca = q_lca[i];
		const int LB = qq[i][0];
		const int RB = qq[i][1];

		if (lca == -1) {
			cur_ans = 1;
		}
		else {
			//printf("lookup(%d..%d)\n", LB, RB);
			cur_ans = 2 * (dep[lca]) - 1;
			//printf("\tROOT .. LCA = %d\n", cur_ans);
			//printf("\tLCA = %d [%d..%d]\n", lca, Tree[lca].L, Tree[lca].R);

			if (Tree[lca].L == LB and Tree[lca].R == RB) {
				// DONE!
			}
			else {
				if (Tree[lca].LSon == 0) cur_ans++;
				else {
					auto it = where_val.lower_bound(LB);

					assert(it != where_val.end());

					int actual_v = it->second;
					//printf("\tLSON actual_v = %d\n", actual_v);

					if (actual_v == -1 or Tree[actual_v].L < LB) {
						//printf("\t\tALREADY TOO HIGH\n");
						cur_ans += 2 * (dep[actual_v] - dep[lca]) + 1;
					}
					else {
						int pv = actual_v;
						for (int pw = LOG - 1; pw >= 0; pw--) {
							const int jump_to = jumps[pv][pw];
							if (dep[jump_to] <= dep[lca]) continue;

							if (Tree[jump_to].L >= LB) pv = jump_to;
						}
						assert(Tree[pv].L >= LB);

						cur_ans += 2 * (dep[pv] - dep[lca]) - 1;
					}

				}

				//printf("\tWITH LSON = %d\n", cur_ans);

				if (Tree[lca].RSon == 0) cur_ans++;
				else {
					auto it = where_val.lower_bound(RB);
					if (it->first > RB) it--;

					assert(it != where_val.end());

					int actual_v = it->second;
					//printf("\tRSON actual_v = %d\n", actual_v);

					if (actual_v == -1 or Tree[actual_v].R > RB) {
						//printf("\t\tALREADY TOO HIGH\n");
						cur_ans += 2 * (dep[actual_v] - dep[lca]) + 1;
					}
					else {
						int pv = actual_v;
						for (int pw = LOG - 1; pw >= 0; pw--) {
							const int jump_to = jumps[pv][pw];
							if (dep[jump_to] <= dep[lca]) continue;

							//printf("\t\t [%d] jump_to = %d\n", pw, jump_to);
							if (Tree[jump_to].R <= RB) pv = jump_to;
						}
						assert(Tree[pv].R <= RB);
						
						//printf("\tSTOP AT %d [%d..%d]\n", pv, Tree[pv].L, Tree[pv].R);

						cur_ans += 2 * (dep[pv] - dep[lca]) - 1;
					}
				} // RSon
				
				//printf("\tWITH RSON = %d\n", cur_ans);
			}
		}

/*
		int slow_ans = lookup(1, qq[i][0], qq[i][1]);
		if (cur_ans != slow_ans) {
			printf("%d vs %d\n", cur_ans, slow_ans);
			return 1;
		}
		else
*/
			printf("%d\n", cur_ans);
	}


	return 0;
}
