#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>

using namespace std;

int64_t gcd (int64_t a, int64_t b, int64_t & x, int64_t & y) {
  if (a == 0) {
    x = 0; y = 1;
    return b;
  }
  int64_t x1, y1;
  int64_t d = gcd (b%a, a, x1, y1);
  x = y1 - (b / a) * x1;
  y = x1;
  return d;
}

bool find_any_solution (int64_t a, int64_t b, int64_t c, int64_t & x0, int64_t & y0, int64_t & g) {
  g = gcd (abs(a), abs(b), x0, y0);
  if (c % g != 0)
    return false;
  x0 *= c / g;
  y0 *= c / g;
  if (a < 0)   x0 *= -1;
  if (b < 0)   y0 *= -1;
  return true;
}

void shift_solution (int64_t & x, int64_t & y, int64_t a, int64_t b, int64_t cnt) {
  x += cnt * b;
  y -= cnt * a;
}

int64_t find_all_solutions (int64_t a, int64_t b, int64_t c, int64_t minx, int64_t maxx, int64_t miny, int64_t maxy) {
  int64_t x, y, g;
  if (! find_any_solution (a, b, c, x, y, g))
    return 0;
  a /= g;  b /= g; c /= g;

  int64_t sign_a = a>0 ? +1 : -1;
  int64_t sign_b = b>0 ? +1 : -1;

  shift_solution (x, y, a, b, (minx - x) / b);
  if (x < minx)
    shift_solution (x, y, a, b, sign_b);
  if (x > maxx)
    return 0;
  int64_t lx1 = x;

  shift_solution (x, y, a, b, (maxx - x) / b);
  if (x > maxx)
    shift_solution (x, y, a, b, -sign_b);
  int64_t rx1 = x;

  shift_solution (x, y, a, b, - (miny - y) / a);
  if (y < miny)
    shift_solution (x, y, a, b, -sign_a);
  if (y > maxy)
    return 0;
  int64_t lx2 = x;

  shift_solution (x, y, a, b, - (maxy - y) / a);
  if (y > maxy)
    shift_solution (x, y, a, b, sign_a);
  int64_t rx2 = x;



  if (lx2 > rx2)
    swap (lx2, rx2);
  int64_t lx = max (lx1, lx2);
  int64_t rx = min (rx1, rx2);

  return (rx - lx) / abs(b) + 1;
}

int main() {
  int64_t n;
  cin >> n;
  while (n--) {
    int64_t b, d;
    cin >> b >> d;
    cout << find_all_solutions(d, b, b * b, 1, 1e18 + 111, 1, 1e9 + 111) << "\n";
  }

  return 0;
}
