#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp> // Общий файл.
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

ll BinPow(ll a, ll b, ll mod) {
    ll result = 1;

    while (b) {
        if (b & 1) {
            result *= a;
            result %= mod;
        }

        a *= a;
        a %= mod;
        b >>= 1;
    }

    return result;
}

ll MulMod(ll a, ll b, ll mod) {
    ll result = 0;

    while (b) {
        if (b & 1) {
            result += a;
            result %= mod;
        }

        a *= 2;
        a %= mod;
        b >>= 1;
    }

    return result;
}

ll RevElement(ll a, ll mod) {
    return BinPow(a, mod - 2, mod);
}

ll calc(ll x, ll y) {
    return -x * y;
}

ll nextInt() {
    char c = getchar();
    ll res = 0;

    do {
        res *= 10;
        res += c - '0';
        c = getchar();
    } while (c >= '0' && c <= '9');

    return res;
}

const int INF = 1e9;

void Solve() {
    int n;
    unordered_map<int, int> q;
    cin >> n;

    int state = 0;
    vector<int> guests;

    int res = 0;

    for (int i = 0; i < n; ++i) {
        int k;
        int change = 0;

        cin >> k;
        guests.resize(k);

        for (auto &x : guests) {
            cin >> x;
            change = max(change, q[x] + 1);
        }

        if (change > state) {
            res++;
            state = change;
        }

        for (auto &x : guests) {
            q[x] = change;
        }
    }

    cout << res;
}

int main() {
    //    freopen("flow.in", "r", stdin);
    //    freopen("flow.out", "w", stdout);
    //freopen("../in", "r", stdin);
    //freopen("../out.txt", "w", stdout);
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    Solve();
    return 0;
}