///#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
///#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,avx,avx2,tune=native")

#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/rope>

/*
    zet:
        find_by_order(k): k-stat [k > 0]
        order_of_key(k) : {el < k}

    gp_hash_table<key, val, custom_hash>

    rope<T>:
        iterators: mutable_begin, ..
        methods  : erase, insert, substr, ..
*/

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())
#define em_back emplace_back
#define sqrt(x) sqrt(abs(x))
#define makeunique(x) sort(all(x)), x.erase(unique(all(x)), x.end())

using namespace std;
//using namespace __gnu_cxx;
//using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

//template<typename T>
//using zet = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct custom_hash {
    static uint64_t splitmix64(uint64_t x) {
        // http://xorshift.di.unimi.it/splitmix64.c
        x += 0x9e3779b97f4a7c15;
        x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9;
        x = (x ^ (x >> 27)) * 0x94d049bb133111eb;
        return x ^ (x >> 31);
    }

    size_t operator()(uint64_t x) const {
        static const uint64_t FIXED_RANDOM = chrono::steady_clock::now().time_since_epoch().count();
        return splitmix64(x + FIXED_RANDOM);
    }
};

mt19937 eng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 2e5 + 4;
const int LOG = 20;

int weight[N], n;
pii spars[N][LOG];
vector<int> g[N];
int h[N], I[N];
vector<pii> vx, prior;
int logtab[N];
int depth[N];
int tree[N][2];
int jumps[N][2][LOG];

int getLca(int u, int v) {
    if (I[u] > I[v]) {
        swap(u, v);
    }

    u = I[u];
    v = I[v];
    int pw = logtab[v - u + 1];
    return min(spars[u][pw], spars[v - (1 << pw) + 1][pw]).second;
}

struct Node {
    int l, r;
    int lca;

    Node* lc;
    Node* rc;

    Node(int l_, int r_) : l(l_), r(r_) {
        if (l == r) {
            lca = prior[l].second;
            lc = rc = nullptr;
            return;
        }
        int m = (l + r) >> 1;
        lc = new Node(l, m);
        rc = new Node(m + 1, r);
        lca = getLca(lc->lca, rc->lca);
    }

    int compute(int l_, int r_) {
        if (l == l_ && r == r_) {
            return lca;
        }

        int m = (l + r) >> 1;
        if (r_ <= m) {
            return lc->compute(l_, r_);
        } else if (m + 1 <= l_) {
            return rc->compute(l_, r_);
        } else {
            return getLca(lc->compute(l_, m), rc->compute(m + 1, r_));
        }
    }
};

void dfs(int u, int par) {
    vx.em_back(h[u], u);

    spars[sz(vx) - 1][0] = pii(h[u], u);
    I[u] = sz(vx) - 1;

    prior.em_back(weight[u], u);

    for (int to : g[u]) if (to != par) {
        h[to] = h[u] + 1;
        dfs(to, u);
        vx.em_back(h[u], u);
    }
}

Node* segTree;

void prepare() {
    for (int i = 2; i < N; ++i) {
        logtab[i] = 1 + logtab[i / 2];
    }

    dfs(1, -1);
    for (int j = 1; j < LOG; ++j) {
        for (int i = 0; i + (1 << j) - 1 < sz(vx); ++i) {
            spars[i][j] = min(spars[i][j - 1], spars[i + (1 << (j - 1))][j - 1]);
        }
    }
    sort(all(prior));
    segTree = new Node(0, n - 1);

    depth[1] = 1;
    for (int u = 1; u <= n; ++u) {
        for (int k = 0; k <= 1; ++k) {
            int v = tree[u][k];
            if (v != 0) {
                depth[v] = depth[u] + 1;
            }
        }
    }

    for (int u = n; u >= 1; --u) {
        for (int k = 0; k <= 1; ++k) {
            jumps[u][k][0] = tree[u][k];
            for (int l = 1; l < LOG; ++l) {
                int v = jumps[u][k][l - 1];
                if (v != 0) {
                    v = jumps[v][k][l - 1];
                }
                jumps[u][k][l] = v;
            }
        }
    }
}

int getRootQuery(int L, int R) {
    auto fi = lower_bound(all(prior), pii(L, 0));
    if (fi == prior.end()) {
        return -1;
    }
    auto se = upper_bound(all(prior), pii(R, 1e9));
    if (se == prior.begin()) {
        return -1;
    }
    int l = fi - prior.begin();
    int r = se - prior.begin() - 1;

    if (l > r) {
        int lc = 0, rc = 0;
        if (l != 0) {
            lc = prior[l].second;
        }
        if (r != n - 1) {
            rc = prior[r].second;
        }

        if (lc + rc == 0) {
            return -1;
        }

        if (lc && rc) {
            if (h[lc] < h[rc]) {
                return rc;
            } else {
                return lc;
            }
        } else if (lc) {
            return lc;
        }
        return rc;
    }

    return segTree->compute(l, r);
}

int findEdge(int u, int k, int lt, int rt) {
    for (int l = LOG - 1; l >= 0; --l) {
        int v = jumps[u][k][l];
        if (v == 0) {
            continue;
        }
        if (lt <= weight[v] && weight[v] <= rt) {
            u = v;
        }
    }
    return u;
}

void read() {
    cin >> n;
    for (int u = 1; u <= n; ++u) {
        cin >> tree[u][0] >> tree[u][1] >> weight[u];
        if (tree[u][0]) {
            g[u].em_back(tree[u][0]);
        }
        if (tree[u][1]) {
            g[u].em_back(tree[u][1]);
        }
    }
}

void solve() {
    read();
    prepare();

    int q;
    cin >> q;
    while (q--) {
        int l, r;
        cin >> l >> r;
        int u = getRootQuery(l, r);
        if (u == -1) {
            cout << "1\n";
            continue;
        }

        int res = (depth[u] - 1) * 2 + 1;
        int lc = findEdge(u, 0, l, r);
        int rc = findEdge(u, 1, l, r);

        bool leftIsNotLast = (tree[lc][0] != 0);
        bool rightIsNotLast = (tree[rc][1] != 0);

        if (leftIsNotLast) {
            res += (depth[lc] - depth[u] + 1) * 2;
        }

        if (rightIsNotLast) {
            res += (depth[rc] - depth[u] + 1) * 2;
        }

        cout << res << "\n";
    }
}

int main() {
#ifndef ONLY_HERE
    ///freopen("", "r", stdin);
    ///freopen("", "w", stdout);
#endif // ONLY_HERE
    ios::sync_with_stdio(0);
    cout.tie(0), cin.tie(0);

    int z = 1;
    /// cin >> z;

    while (z--) {
        solve();
    }

    return 0;
}

