#include <iostream>
#include <bitset>

int n;
std::bitset<8> steps[300000];

bool willWin[256];
bool nextWillWin[256];

char desc[9];

inline bool canMove(int from, int to) {
	if (from < 0) {
		return false;
	}
	return to - from <= (8 - (steps[from] ^ steps[to]).count());
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n;
	std::cin >> std::ws;

	for (int i = 0; i < n; i++) {
		std::cin.getline(desc, 9);

		for (int j = 0; j < 8; j++) {
			steps[i][j] = desc[j] == 'W';
		}
	}

	for (int i = 0; i < 256; i++) {
		willWin[i] = (i & 1) == 1;
	}

	std::cout << '2';

	for (int i = 1; i < n; i++) {
		int from = i - 8;
		for (int state = 0; state < 256; state++) {
			// Need to calculate last one
			bool hasLoss = false;
			for (int k = 0; k < 8; k++) {
				bool isWin = ((state >> k) & 1) != 0;
				if (canMove(from, i - k)) {
					if (!isWin) {
						hasLoss = true;
						break;
					}
				}
			}
			int result = state / 2 + (hasLoss ? 128 : 0);
			nextWillWin[state] = willWin[result];
		}

		for (int j = 0; j < 256; j++) {
			willWin[j] = nextWillWin[j];
		}

		int deterministicState = 0;
		// Bottom to top
		for (int k = i - 1; k > i - 8; k--) {
			bool hasLoss = false;
			for (int l = i; l > k; l--) {
				if (canMove(k, l) && !((deterministicState >> (i - l)) & 1)) {
					hasLoss = true;
					break;
				}
			}
			if (hasLoss) {
				deterministicState |= 1 << (i - k);
			}
		}
		if (willWin[deterministicState]) {
			std::cout << '1';
		} else {
			std::cout << '2';
		}
	}
	std::cout << std::endl;

	return 0;
}
