#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define E 0.000000001
using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef pair <ll, ll> pll;

const ll INF = INT_MAX;
set <pll> st;
vector <pll> q;
vector <ll> ans;

typedef tree<
pll,
null_type,
less<pll>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

ll count_more(auto &a, ll val) {
    auto it = a.upper_bound(make_pair(val, INF));
    if(it == a.end()) return 0;
    else return (ll)a.size() - a.order_of_key(*it);
}

ll count_less(auto &a, ll val) {
    auto it = a.lower_bound(make_pair(val, -INF));
    if(it == a.end()) return a.size();
    else return a.order_of_key(*it);
}

pll swp(pll a) {
    return {a.second, a.first};
}
void part1() {
    ordered_set for_left;//!
    ordered_set for_right;//!
    for(auto i:st) {
        for_left.insert(i);
        for_right.insert(swp(i));
    }
    for(ll i = 0; i < q.size(); i++) {
        ans[i] += count_more(for_left, q[i].second);
        ans[i] += count_less(for_right, q[i].first);
    }
}

void part2() {
    vector <pair <pll, ll> > q2(q.size());
    for(ll i = 0; i < q.size(); i++) q2[i] = {q[i], i};
    sort(q2.begin(), q2.end());
    set <pll> left_before;
    ordered_set right_align;//!
    for(auto i: st) {
        right_align.insert(swp(i));
        left_before.insert(i);
    }
    for(auto i: q2) {
        pll temp;
        while(left_before.size() && (temp = *left_before.begin()).first < i.first.first) {
            right_align.erase(swp(temp));
            left_before.erase(left_before.begin());
        }
        ans[i.second] += count_less(right_align, i.first.second + 1);
    }
}

pll dfs(ll ind, auto &g, auto &clr) {
    ll left = clr[ind], right = left;
    for(auto i: g[ind]) {
        pll temp = dfs(i, g, clr);
        left = min(left, temp.first);
        right = max(right, temp.second);
    }
    st.insert({left, right});
    return {left, right};
}

int main()
{
    ios_base:: sync_with_stdio(0);
    //ifstream cin("input.txt");
    {
        ll n;
        cin >> n;
        vector <vector <ll> > g(n);
        vector <ll> clr(n);
        for(ll i = 0; i < n; i++) {
            ll a, b;
            cin >> a >> b >> clr[i];
            if(a) {
                g[i].push_back(a - 1);
            }
            if(b) {
                g[i].push_back(b - 1);
            }
        }
        dfs(0, g, clr);
    }
    {
        ll temp;
        cin >> temp;
        q.resize(temp);
        ans.resize(temp, 0);
        for(auto &i: q) cin >> i.first >> i.second;
    }
    part1();
    //for(auto i: ans) cout << i << ' '; cout << endl;
    part2();
    for(auto i: ans) cout << ((ll)st.size() - i) * 2 + 1 << endl;
}
