#include <bits/stdc++.h>

#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();

int main() {
#ifdef VRI
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

ll gcd (ll a, ll b, ll & x, ll & y) {
    if (a == 0) {
        x = 0; y = 1;
        return b;
    }
    ll x1, y1;
    ll d = gcd (b%a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}

bool find_any_solution (ll a, ll b, ll c, ll & x0, ll & y0, ll & g) {
    g = gcd (abs(a), abs(b), x0, y0);
    if (c % g != 0)
        return false;
    x0 *= c / g;
    y0 *= c / g;
    if (a < 0)   x0 *= -1;
    if (b < 0)   y0 *= -1;
    return true;
}

void solve() {
    int T;
    cin >> T;
    while (T--) {
        ll d, b;
        cin >> b >> d;

        ll x0, y0, g;
        if (!find_any_solution(b, d, b * b, x0, y0, g)) {
            cout << "0\n";
        } else {

            ll stepX = d / g;
            ll stepY = -b / g;

            ll xK;
            if (x0 < 0) {
                xK = (-x0 / stepX) + 1;
            } else {
                xK = (x0 - 1) / stepX;
            }

            ll yK;
            if (y0 < 0) {
                yK = (y0 / stepY) + 1;
            } else {
                yK = ((y0 - 1) / (-stepY));
            }

            if (xK > yK) swap(xK, yK);
            cout << yK - xK + 1 << "\n";
        }

    }

}