#include <bits/stdc++.h>

#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();

int main() {
#ifdef VRI
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

ll gcd(ll a, ll b, ll &x, ll &y) {
    if (a == 0) {
        x = 0;
        y = 1;
        return b;
    }
    ll x1, y1;
    ll d = gcd(b % a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}

bool find_any_solution(ll a, ll b, ll c, ll &x0, ll &y0, ll &g) {
    g = gcd(abs(a), abs(b), x0, y0);
    if (c % g != 0)
        return false;
    x0 *= c / g;
    y0 *= c / g;
    if (a < 0) x0 *= -1;
    if (b < 0) y0 *= -1;
    return true;
}

ll solve(ll b, ll d) {
    ll x0, y0, g;
    if (!find_any_solution(b, d, b * b, x0, y0, g)) {
        return 0;
    } else {
        ll stepX = d / g;
        ll stepY = b / g;

        ll xK;
        if (x0 <= 0) {
            xK = (-x0) / stepX + 1;
        } else {
            xK = -((x0 - 1) / stepX);
        }

        ll x = x0 + stepX * xK;
        ll y = y0 - stepY * xK;

        ll cnt = (y <= 0 ? 0 : (y - 1) / stepY + 1);
//        if (xK > yK) swap(xK, yK);
        return cnt;
    }
}

ll solve_slow(ll b, ll d) {
    int cnt = 0;
    for (int x = 1; x < 1000; x++) {
        for (int y = 1; y < 1000; y++) {
            if (x * b + y * d == b * b) {
                cnt++;
            }
        }
    }
    return cnt;
}

void solve() {
    int T;
    cin >> T;
//    T = 10;

    while (T--) {
        ll d, b;
        cin >> b >> d;
        cout << solve(b, d) << "\n";
//        mt19937 rnd(T);

//        b = rnd() % 10 + 1;
//        d = rnd() % 10 + 1;

//        if (solve(b, d) != solve_slow(b, d)) {
//            err("b = %d, d = %d\n", b, d);
//            err("s = %d, slow = %d\n", solve(b, d), solve_slow(b, d));
//            return;
//        }
    }
}