// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
typedef pair<double, double> pdd;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

struct point {
	int x, y;
	point(int _x, int _y) : x(_x), y(_y) {}
	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}

	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}

	bool operator<(point const& other) const {
		return x < other.x || (x == other.x && y < other.y);
	}
};

ll cross(point const& p1, point const& p2) {
	return (ll) p1.x * p2.y - (ll) p1.y * p2.x;
}

int sign(ll num) {
	return num < 0 ? -1 : (num > 0 ? 1 : 0);
}

bool is_intersecting(point const& a, point const& b, point const& c, point const& d) {
	if (!cross(b - a, d - c)) {
		return false;
	}
	return sign(cross(c - a, b - a)) * sign(cross(b - a, d - a)) >= 0 &&
		sign(cross(a - c, d - c)) * sign(cross(d - c, b - c)) >= 0;
}

struct line {
	double a, b, c;
	line(point const& p1, point const& p2) {
		a = p2.y - p1.y;
		b = p1.x - p2.x;
		c = -(p1.x * a + p1.y * b);
	}
};

pdd intersection(line const& l1, line const& l2) {
	double d = l1.a * l2.b - l1.b * l2.a;
	double d1 = -l1.c * l2.b + l1.b * l2.c;
	double d2 = -l1.a * l2.c + l1.c * l2.a;
	return {d1 / d, d2 / d};
}

bool is_inside(vector<point> const& poly, point const& p) {
	ll minval = INFL, maxval = -INFL;
	for (int i = 0; i < szof(poly); ++i) {
		int next = (i + 1) % szof(poly);
		ll val = cross(poly[next] - poly[i], p - poly[i]);
		minval = min(minval, val);
		maxval = max(maxval, val);
	}
	if (minval < 0 && 0 < maxval) {
		return false;
	}
	return true;
}

const int MAXC = 1e6 + 5;
const double eps = 1e-6;

const int MOD = 1'000'000'007;

void add(int& a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

int sum(int a, int b) {
	add(a, b);
	return a;
}

int mult(int a, int b) {
	return (ll) a * b % MOD;
}

int mpow(int a, int b) {
	int ret = 1;
	while (b) {
		if (b & 1) {
			ret = mult(ret, a);
		}
		a = mult(a, a);
		b /= 2;
	}
	return ret;
}

int inv(int a) {
	return mpow(a, MOD - 2);
}


vector<int> factrorial, inv_factorial;

int cnk(int n, int k) {
	if (k < 0 || k > n) {
		return 0;
	}
	return mult(factrorial[n], mult(inv_factorial[n - k], inv_factorial[k]));
}

void solve() {
	vector<point> triangle;
	for (int i = 0; i < 3; ++i) {
		int x, y;
		cin >> x >> y;
		triangle.push_back(point(x, y));
	}

	int ans = 0;

	for (int i = 0; ; ++i) {
		bool ok = false;
		point p1 = point(-i - MAXC, i - MAXC);
		point p2 = point(-i + MAXC, i + MAXC);
		for (int j = 0; j < 3; ++j) {
			if (cross(p2 - p1, triangle[j] - p1) >= 0) {
				ok = true;
				break;
			}
		}
		if (!ok) {
			break;
		}

		pdd minp = {INF, 0}, maxp = {-INF, 0};

		for (int j = 0; j < 3; ++j) {
			int next = (j + 1) % 3;
			if (is_intersecting(p1, p2, triangle[j], triangle[next])) {
				pdd tmp = intersection(line(p1, p2), line(triangle[j], triangle[next]));
				minp = min(minp, tmp);
				maxp = max(maxp, tmp);
			}
		}

		if (minp.ff > MAXC * 2) {
			continue;
		}

		point a(ceil(minp.ff - eps), ceil(minp.ss - eps));
		if (!is_inside(triangle, a)) {
			a.x++;
			a.y++;
		}
		point b(floor(maxp.ff + eps), floor(maxp.ss + eps));
		if (!is_inside(triangle, b)) {
			b.x--;
			b.y--;
		}
		if (a.x < -i) {
			a = point(-i, i);
		}
		if (b < a) {
			continue;
		}

		int n1 = a.y;
		int n2 = b.y;
		add(ans, cnk(n2 + 1, i + 1));
		add(ans, MOD - cnk(n1, i + 1));
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	factrorial = {1};
	for (int i = 1; i < MAXC; ++i) {
		factrorial.push_back(mult(factrorial.back(), i));
	}
	inv_factorial = {inv(factrorial.back())};
	for (int i = MAXC - 1; i >= 1; --i) {
		inv_factorial.push_back(mult(inv_factorial.back(), i));
	}
	reverse(inv_factorial.begin(), inv_factorial.end());

	int test_count = 1;
	cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}