#include <bits/stdc++.h>

#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();

int main() {
    solve();
    return 0;
}

const int LOCAL = 0;
mt19937 rnd;

map<pair<int, int>, int> used;

int N;

int dx[] = {1, 0, -1, -1, 0, 1};
int dy[] = {0, 1, 1, 0, -1, -1};

bool valid(int x, int y) {
    if (x < -N || x > N) return false;
    int l = -N;
    int r = N;

    if (x > 0) r -= x;
    if (x < 0) l -= x;

    return l <= y && y <= r;
}

bool check(int x, int y) {
    return valid(x, y) && used.find({x, y}) == used.end();
}

void add(int x, int y, int tp) {
    used[{x, y}] = tp + 1;
}

void init(int &t, int &n) {
    if (LOCAL) {
        t = 100000;
        n = 20;
    } else {
        cin >> t >> n;
    }
}

bool win = false;
pair<int, int> myPos;
pair<int, int> otherPos;

int get_tp(int a, int b) {
    auto it = used.find({ a, b });
    if (it != used.end()) return it->second;
    return -1;
}

bool neighb(int x, int y) {
    for (int gg = 0; gg < 6; gg++) {
        if (get_tp(x + dx[gg], y + dy[gg]) == 2) return true;
        continue;
//        if (get_tp(x + dx[gg], y + dy[gg]) == 1) continue;

        for (int hh = 0; hh < 6; hh++) {
            int ni = x + dx[gg] + dx[hh];
            int nj = y + dy[gg] + dy[hh];
            if (get_tp(ni, nj) == 2) {
                return true;
            }
        }
    }
    return false;
}

void out(int x, int y) {
//    err("i %d, %d\n", x, y);
    if (win) {
        return;
    }
    if (!check(myPos.first + x, myPos.second + y)) {
        return;
    }
//    if (neighb(myPos.first + x, myPos.second + y)) {
//        return;
//    }



    myPos.first += x;
    myPos.second += y;

//    err("to = (%d, %d)\n", myPos.first, myPos.second);
//    assert(valid(myPos.first, myPos.second));

    assert(check(myPos.first, myPos.second));
    add(myPos.first, myPos.second, 0);

    if (LOCAL) {
        vector<pair<int, int>> can;
        for (int gg = 0; gg < 6; gg++) {
            int ni = otherPos.first + dx[gg];
            int nj = otherPos.second + dy[gg];
            if (check(ni, nj)) {
                can.emplace_back(dx[gg], dy[gg]);
            }
        }
        if (can.empty()) {
            win = true;
            return;
        }
        int ind = rnd() % (int)can.size();

        otherPos.first += can[ind].first;
        otherPos.second += can[ind].second;
        add(otherPos.first, otherPos.second, 1);

//        err("myPos = (%d, %d), otherPos = (%d, %d)\n", myPos.first, myPos.second, otherPos.first, otherPos.second);
        return;
    } else {
        cout << x << " " << y << endl;
        string s; cin >> s;
        if (s == "move") {
            int a, b;
            cin >> a >> b;

            otherPos.first += a;
            otherPos.second += b;
            add(otherPos.first, otherPos.second, 1);
            return;
        }
        if (s == "lose") {
            exit(0);
        }
        if (s == "win") {
            win = true;
        }
        return;
    }
}

map<pair<int, int>, int> bfs() {
    queue<pair<int, int>> q;
    map<pair<int, int>, int> d;

    for (auto c : used) {
        if (c.second != 2) continue;

        q.push(c.first);
        d[c.first] = 0;
    }

    while (!q.empty()) {
        auto c = q.front();
        q.pop();
        for (int gg = 0; gg < 6; gg++) {
            int ni = c.first + dx[gg];
            int nj = c.second + dy[gg];
            if (!check(ni, nj)) continue;
            if (d.find({ ni, nj}) == d.end()) {
                d[{ni, nj}] = d[{c.first, c.second}] + 1;
            }
        }
    }
    return d;
}

int play() {
    for (int it = 0; it < N / 4 && !win; it++) {
        out(1, 0);
    }

    if (otherPos.second > 0) {
        while (true) {
            auto cur = myPos;
            for (int it = 0; it < N; it++) {
                out(1, -1);
            }
            for (int it = 0; it < N; it++) {
                out(-1, 0);
            }
            for (int it = 0; it < N && myPos.second < -1; it++) {
                out(-1, +1);
            }
            for (int it = 0; it < N; it++) {
                out(1, 0);
            }
            if (myPos == cur) {
                break;
            }
        }
    } else {
        while (true) {
            auto cur = myPos;
            for (int it = 0; it < N; it++) {
                out(0, 1);
            }
            for (int it = 0; it < N; it++) {
                out(-1, 0);
            }
            for (int it = 0; it < N && myPos.second > 1; it++) {
                out(0, -1);
            }
            for (int it = 0; it < N; it++) {
                out(1, 0);
            }
            if (myPos == cur) {
                break;
            }
        }
    }

    while (true) {
        auto cur = myPos;
        auto dist = bfs();

        vector<pair<int, int>> t;
        for (int gg = 0; gg < 6; gg++) {
            int nx = myPos.first + dx[gg];
            int ny = myPos.second + dy[gg];
            if (check(nx, ny)) {
                auto it = dist.find({ nx, ny});
                if (it == dist.end()) {
                    t.emplace_back((int)1e9, gg);
                } else {
                    t.emplace_back(it->second, gg);
                }
            }
        }
        sort(t.rbegin(), t.rend());
        if (!t.empty()) {
            out(dx[t[0].second], dy[t[0].second]);
        }

        if (cur == myPos) {
            break;
        }
    }

//    if (!win) {
//        vector<vector<int>> T(2 * N + 1, vector<int>(2 * N + 1));
//        int ADD = N;
//        for (auto c : used) {
//            T[c.first.first + ADD][c.first.second + ADD] = c.second;
//        }
//        for (int i = -N; i <= N; i++) {
//            for (int j = -N; j <= N; j++) {
//                if (!valid(i, j)) cout << '#';
//                else cout << T[i + ADD][j + ADD];
//            }
//            cout << "\n";
//        }
//        exit(0);
//    }


//    assert(win);
    return win;
}

void solve() {
    int t, n;
    init(t, n);

    N = n;

    int cnt = 0;

    for (int it = 0; it < t; it++) {
        rnd = mt19937(it);
        if (it % 1000 == 0) {
//            err("it = %d\n", it);
        }

        win = false;
        myPos = {-n / 2, 0};
        otherPos = {n / 2, 0};

        add(myPos.first, myPos.second, 0);
        add(otherPos.first, otherPos.second, 1);
        used.clear();

        int w = play();
//        if (!w) err("%d fail\n", it);
        cnt += w;
    }
    long double p = cnt * 1.0 / t;
//    err("cnt = %d, lose = %.5f, win prob %.10f\n", cnt, (double)(1 - p), (double)pow(p, 5000));
}