#include <random>
#include<vector>
#include<iostream>
#include<fstream>
#include<string>
#include<cassert>
#include<algorithm>
#include<random>
#include<map>
#include<set>
#include <bitset>
#include<queue>
#include<ctime>
#include<unordered_map>

using namespace std;


using ll = long long;
using ull = unsigned long long;

using ld = long double;

const int mod = 1e9 + 7;

int sum(int a, int b) {
    int c = a + b;
    if (c >= mod) {
        c -= mod;
    }
    return c;
}

int dif(int a, int b) {
    int c = a - b;
    if (c < 0) {
        c += mod;
    }
    return c;
}

int mlt(int a, int b) {
    ll c = a * 1LL * b;
    return c % mod;
}


int bp(int x, int y) {
    if (y == 0) {
        return 1;
    }
    int a = 0;
    if (!(y % 2)) {
        a = bp(x, y / 2);
    }
    return (y % 2) ? mlt(bp(x, y - 1), x) : mlt(a, a);
}

int obr(int x) {
    return bp(x, mod - 2);
}

const int maxn = 1e2 + 2;
int fact[maxn], ofact[maxn];

void prec() {
    fact[0] = 1;
    ofact[0] = 1;
    for (int i = 1; i < maxn; i++) {
        fact[i] = mlt(fact[i - 1], i);
    }
    //cerr << "sdsds" << endl;
    ofact[maxn - 1] = obr(fact[maxn - 1]);
    for (int i = maxn - 2; i > 0; i--) {
        ofact[i] = mlt(ofact[i + 1], i + 1);
    }
}

struct point
{
    int x, y;
};

int c(int a, int b) {
    return ((a <= b) && (a >= 0)) ? mlt(fact[b], mlt(ofact[a], ofact[b - a])) : 0;
}

void add(point l, point r, const int y0, array<ld, 6> &arr, int &ptr) {
    if (l.y == r.y) {
        if (y0 != l.y)
            return;

        assert(l.x != r.x);
        arr[ptr++] = ld(l.x);
        arr[ptr++] = ld(r.x);
        return;
    }

    if (l.y > r.y)
        swap(l, r);
    if (y0 < l.y || y0 > r.y)
        return;

    arr[ptr++] = ld(r.x - l.x) * ld(y0 - l.y) / ld(r.y - l.y) + ld(l.x);
}

const ld eps = 1e-7;

pair<int, int> seg(const int y0, const vector<point> &triag) {
    array<ld, 6> res{0, 0};
    int ptr = 0;

    for (int i = 0; i < 3; i++)
        add(triag[i], triag[i == 2 ? 0 : i + 1], y0, res, ptr);

    if (ptr == 0)
        return {0, -1};
    sort(res.begin(), res.begin() + ptr);

// cerr « "here" «/* endl;
// for (int i = 0; i < ptr; i++)
// cerr « int(res[i]) « ' ';
// cerr « endl;*/

    res[0] -= eps;
    res[ptr - 1] += eps;
    return {ll(ceil(res[0])), ll(floor(res[ptr - 1]))};
}

vector<int> sl(vector<int> &v) {
    //правую не берем. посл С-шка - v[i]-1
    int n = v.size();
    vector<int> ans(n);
    ans[0] = 1;
    if (v[0] == 0)
        ans[0] = 0;
    for (int i = 1; i < n; i++) {
        int val = ans[i - 1], cur = v[i - 1];
        val = mlt(val, 2);
        val = dif(val, c(v[i - 1] - 1, i - 1));
        if (v[i] >= cur) {
            while (cur < v[i]) {
                val = sum(val, c(cur, i));
                cur++;
            }
        }
        if (v[i] < cur) {
            while (cur > v[i]) {
                cur--;
                val = dif(val, c(cur, i));
            }
        }
        ans[i] = val;
    }
    return ans;
}

int slv(vector<int> &lb, vector<int> &rb) {
    vector<int> l1 = sl(lb), r1 = sl(rb);
    int ans = 0;
    for (int i = 0; i < lb.size(); i++) {
        if (lb[i] < rb[i]) {
            ans = sum(ans, r1[i]);
            ans = dif(ans, l1[i]);
        }
    }
    return ans;
}


void solve(istream &cin = std::cin, ostream &cout = std::cout) {
    prec();
    int tests = 1;
    cin >> tests;
    for (int test = 0; test < tests; test++) {
        vector<int> lb(maxn), rb(maxn);
        int xa, ya, xb, yb, xc, yc;
        cin >> xa >> ya >> xb >> yb >> xc >> yc;
        point a = {xa, ya};
        point b = {xb, yb};
        point c = {xc, yc};
        vector<point> triag = {a, b, c};
        for (int i = 0; i < maxn; i++) {
            //   cout<<i<<endl;
            pair<int, int> sg = seg(i, triag);
            sg.first = max(sg.first, -i);
            sg.second = min(sg.second, i);
            if (sg.first > sg.second) {
                lb[i] = 0;
                rb[i] = 0;
            } else {
                //     cerr<<i<<' '<<sg.first<<' '<<sg.second<<endl;
                int lbb = sg.first + i, rbb = sg.second + i + 1;
                if (lbb % 2 != 0)
                    lbb++;
                if (rbb % 2 != 0)
                    rbb++;
                lb[i] = lbb / 2;
                rb[i] = rbb / 2;
            }
            //  cerr<<i<<' '<<lb[i]<<' '<<rb[i]<<endl;
        }
        cout << slv(lb, rb) << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    auto st = clock();

        ifstream fin("../input.txt");
        do
        {
            solve(fin);

            cout << "===" << endl;

            string str;
            while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
        } while (fin);

        cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
    solve();
#endif

    return 0;
}