#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

mt19937 mt(736);


template<class T>
T &remin(T &x, const T &y)
{
	return x = min(x, y);
}


template<class T>
T &remax(T &x, const T &y)
{
	return x = max(x, y);
}


struct node
{
	int key, l, r;
};


class bl
{
	vector<node> &arr;
	vector<vector<int>> par;
	vector<int> dep;
	vector<pair<int, int>> seg;
	map<int, int> wh;

	void build(int v, int d = 0)
	{
		dep[v] = d;
		if (!par[v].empty())
			while (par[par[v].back()].size() >= par[v].size())
				par[v].push_back(par[par[v].back()][par[v].size() - 1]);

		if (arr[v].l != -1)
		{
			par[arr[v].l] = {v};

			build(arr[v].l, d + 1);
		}

		if (arr[v].r != -1)
		{
			par[arr[v].r] = {v};

			build(arr[v].r, d + 1);
		}
	}


	int fup(int v, const function<bool(int)> &q)
	{
		assert(q(v));

		int pos = numeric_limits<int>::max();

		while (!par[v].empty() && q(par[v].front()))
		{
			remin(pos, (int) par[v].size() - 1);

			while (!q(par[v][pos]))
				pos--;

			v = par[v][pos];
		}

		return v;
	}

	int lca(int a, int b)
	{
		if (dep[a] < dep[b])
			swap(a, b);

		a = fup(a, [&](int v)
		{
			return dep[v] >= dep[b];
		});

		assert(dep[a] == dep[b]);

		int pos = numeric_limits<int>::max();

		while (a != b)
		{
			remin(pos, (int) par[a].size() - 1);

			while (pos > 0 && par[a][pos] == par[b][pos])
				pos--;

			a = par[a][pos];
			b = par[b][pos];
		}

		return a;
	}

public:
	explicit bl(vector<node> &arr) : arr(arr), par(arr.size()), dep(arr.size()), seg(arr.size())
	{
		build(0);

		for (int i = (int) seg.size() - 1; i >= 0; i--)
		{
			seg[i] = {arr[i].key, arr[i].key};

			if (arr[i].l != -1)
				remin(seg[i].first, seg[arr[i].l].first);
			if (arr[i].r != -1)
				remax(seg[i].second, seg[arr[i].r].second);
		}

		for (int i = 0; i < arr.size(); i++)
			wh[arr[i].key] = i;
	}

	int quer(int l, int r)
	{
		int sl = l;
		int sr = r + 1;

		auto ql = wh.lower_bound(sl), qr = wh.lower_bound(sr);
		int vl = 0, vr = 0;

		if (ql != wh.end())
			vl = ql->second;
		if (qr != wh.end())
			vr = qr->second;

		auto is_rec = [&](int v)
		{
			if (l <= seg[v].first && seg[v].second <= r)
				return false;
			if (seg[v].second < l || r < seg[v].first)
				return false;
			return true;
		};

		auto is_not_rec = [&](int v)
		{
			return !is_rec(v);
		};

		if (is_not_rec(vl))
			vl = fup(vl, is_not_rec);
		if (is_not_rec(vr))
			vr = fup(vr, is_not_rec);

		auto q = lca(vl, vr);

		int cnt = (dep[vl] + dep[vr] - dep[q] - 1) * 2 + 1;

		if (is_rec(vl))
			cnt += 2;
		if (is_rec(vr))
			cnt += 2;
		if (is_not_rec(q))
			cnt += 2;

		return cnt;
	}
};


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n;

	cin >> n;

	vector<node> arr(n);

	for (auto &it : arr)
	{
		cin >> it.l >> it.r >> it.key;
		it.l--;
		it.r--;
	}

	bl bup(arr);

	int q;

	cin >> q;

	for (int i = 0; i < q; i++)
	{
		int l, r;

		cin >> l >> r;

		cout << bup.quer(l, r) << '\n';
	}
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
