#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

#define pb push_back
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define forrn(i, s, n) for (int i = (int)(s); i < (int)(n); i++)
#define PYMOD(a, m) ((((a) % (m)) + (m)) % (m))
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define mp make_pair
#define ff first
#define ss second

const ld eps = 1e-8;
const ld pi = acosl(-1);

ld natan2(ld y, ld x) {
    ld v = atan2l(y, x);
    if (v < 0) return v + 2 * pi;
    return v;
}

struct pt {
    ld x, y;
};

struct radial {
    ld r, a;
    radial(pt p) {
        a = natan2(p.y, p.x);
        r = hypotl(p.x, p.y);
    }
    pt to_point() {
        return {
            r * cosl(a),
            r * sinl(a)
        };
    }
};

vector<pt> rotate_p(vector<pt> p, ld angle) {
    for (auto& pp : p) {
        radial r(pp);
        r.a += angle;
        pp = r.to_point();
    }
    return p;
}

ld y_intersect(pt p, pt q, ld x) {
    if (fabsl(q.x - p.x) < eps)
        return q.y;
    return ((q.y - p.y) / (q.x - p.x)) * (x - p.x) + p.y;
}

ld max_vert(const vector<pt>& p) {
    int n = p.size();
    ld ans = 0;
    for (const auto& pp : p) {
        ld x = pp.x;
        forn(i, n) {
            int j = (i + 1) % n;
            if ((p[i].x <= x && x <= p[j].x) || (p[j].x <= x && x <= p[i].x)) {
                ans = max(ans, fabsl(pp.y - y_intersect(p[i], p[j], x)));
            }
        }
    }
    return ans;
}


optional<pair<ld, ld>> solve_segment(const vector<pt>& p, ld la, ld ra, ld dist) {
    ld l = la, r = ra;
    forn(i, 100) {
        ld ml = (2 * l + r) / 3;
        ld mr = (l + 2 * r) / 3;
        if (max_vert(rotate_p(p, ml)) < max_vert(rotate_p(p, mr)))
            l = ml;
        else
            r = mr;
    }

    if (max_vert(rotate_p(p, l)) < dist)
        return {};

    ld ltl = la, rtl = l;
    forn(i, 100) {
        ld mid = (ltl + rtl) / 2;
        if (max_vert(rotate_p(p, mid)) < dist)
            ltl = mid;
        else
            rtl = mid;
    }
    
    ld ltr = l, rtr = ra;
    forn(i, 100) {
        ld mid = (ltr + rtr) / 2;
        if (max_vert(rotate_p(p, mid)) < dist)
            rtr = mid;
        else
            ltr = mid;
    }
    return make_pair(ltl, rtr);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // Code here:

    int n;
    pt a, b;
    cin >> n >> a.x >> a.y >> b.x >> b.y;

    vector<pt> p(n);
    forn(i, n) {
        cin >> p[i].x >> p[i].y;
    }

    vector<ld> angles;
    forn(i, n) {
        forn(j, n) {
            if (i == j)
                continue;
            angles.emplace_back(natan2(p[j].y - p[i].y, p[j].x - p[i].x));
        }
    }

    sort(all(angles));
    angles.resize(unique(all(angles)) - angles.begin());
    angles.push_back(angles[0] + 2 * pi);

    vector<pair<ld, ld>> segments;
    forn(i, angles.size() - 1) {
        auto s = solve_segment(p, angles[i], angles[i + 1], hypotl(b.x - a.x, b.y - a.y));
        if (!s.has_value())
            continue;
        segments.pb(s.value());
    }

    assert(!segments.empty());

    vector<pair<ld, ld>> nsegments = {segments[0]};
    forn(i, segments.size() - 1) {
        if (fabsl(segments[i].ss- segments[i + 1].ff) < eps)
            nsegments.back().ss = segments[i + 1].ss;
        else
            nsegments.push_back(segments[i + 1]);
    }

    if (nsegments.size() > 1 && fabsl(nsegments.back().ss - 2 * pi - nsegments[0].ff) < eps) {
        nsegments[0].ff = nsegments.back().ff - 2 * pi;
        nsegments.pop_back();
    }

    ld ans = 0;


    vector<ld> to_check = {
        natan2(b.y - a.y, b.x - a.x),
        natan2(b.y - a.y, b.x - a.x) + 2 * pi,
        natan2(a.y - b.y, a.x - b.x),
        natan2(a.y - b.y, a.x - b.x) + 2 * pi,
    };

    for (ld angle : to_check) {
        for (auto [l, r] : nsegments) {
            if (l <= angle && angle <= r) {
                if (l <= angle - pi / 2) {
                    ans = pi / 2;
                    continue;
                }
                if (r >= angle + pi / 2) {
                    ans = pi / 2;
                    continue;
                }
                ans = max(ans, angle - l);
                ans = max(ans, r - angle);
            }
        }
    }

    cout.precision(20);
    cout << fixed << ans / pi * 180 << endl;

    return 0;
}
