﻿/*
X⣿⣷⡁⢆⠈⠕⢕⢂⢕⢂⢕⢂⢔⢂⢕⢄⠂⣂⠂⠆⢂⢕⢂⢕⢂⢕⢂⢕⢂
X⣿⣿⡷⠊⡢⡹⣦⡑⢂⢕⢂⢕⢂⢕⢂⠕⠔⠌⠝⠛⠶⠶⢶⣦⣄⢂⢕⢂⢕
X⣿⠏⣠⣾⣦⡐⢌⢿⣷⣦⣅⡑⠕⠡⠐⢿⠿⣛⠟⠛⠛⠛⠛⠡⢷⡈⢂⢕⢂
X⣡⣾⣿⣿⣿⣿⣦⣑⠝⢿⣿⣿⣿⣿⣿⡵⢁⣤⣶⣶⣿⢿⢿⢿⡟⢻⣤⢑⢂
X⣿⣿⡿⢟⣛⣻⣿⣿⣿⣦⣬⣙⣻⣿⣿⣷⣿⣿⢟⢝⢕⢕⢕⢕⢽⣿⣿⣷⣔
X⣿⠵⠚⠉⢀⣀⣀⣈⣿⣿⣿⣿⣿⣿⣿⣿⣿⣗⢕⢕⢕⢕⢕⢕⣽⣿⣿⣿⣿
X⣂⣠⣴⣾⡿⡿⡻⡻⣿⣿⣴⣿⣿⣿⣿⣿⣿⣷⣵⣵⣵⣷⣿⣿⣿⣿⣿⣿⡿
X⠻⣿⡿⡫⡪⡪⡪⡪⣺⣿⣿⣿⣿⣿⠿⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⠃
X⡁⠹⡪⡪⡪⡪⣪⣾⣿⣿⣿⣿⠋⠐⢉⢍⢄⢌⠻⣿⣿⣿⣿⣿⣿⣿⣿⠏⠈
X⡘⢄⠙⣾⣾⣾⣿⣿⣿⣿⣿⣿⡀⢐⢕⢕⢕⢕⢕⡘⣿⣿⣿⣿⣿⣿⠏⠠⠈
X⢊⢂⢣⠹⣿⣿⣿⣿⣿⣿⣿⣿⣧⢐⢕⢕⢕⢕⢕⢅⣿⣿⣿⣿⡿⢋⢜⠠⠈
X⠁⠕⢝⡢⠈⠻⣿⣿⣿⣿⣿⣿⣿⣷⣕⣑⣑⣑⣵⣿⣿⣿⡿⢋⢔⢕⣿⠠⠈
X⡂⡀⢑⢕⡅⠂⠄⠉⠛⠻⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⡿⢋⢔⢕⢕⣿⣿⠠
*/

#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const ll mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;
const ll INF = 1e18;

const ll P = 1e9 + 7;
const ll Q = 150001;

mt19937 rng(228);

vector<int> rabbit_hole(int s, vector<int> &children, vector<vector<int>> &chcodes) {
	if (s == sz(children) - 1) {
		vector<int> res(1, children[s]);
		for (auto el : chcodes[s]) res.pb(el);
		return res;
	}
	else {
		vector<int> res;
		auto seq = rabbit_hole(s + 1, children, chcodes);
		for (auto el : seq) res.pb(el);
		res.pb(children[s]);
		reverse(all(seq));
		for (auto el : seq) res.pb(el);
		for (auto el1 : chcodes[s]) {
			res.pb(el1);
			reverse(all(seq));
			for (auto el : seq) res.pb(el);
		}
		return res;
	}
}

vector<int> ctree(int v, vector<int> &p) {
	vector<int> children;
	for (int i = 0; i < sz(p); i++) if (p[i] == v) children.pb(i);
	
	vector<int> seq;
	if (sz(children) == 0) return seq;

	vector<vector<int>> chcodes;
	for (auto ch : children) chcodes.pb(ctree(ch, p));

	seq = rabbit_hole(0, children, chcodes);

	return seq;
}

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int n;
	cin >> n;

	vector<bool> dp((1 << 8)); // less -> end
	for (int i = 0; i < (1 << 8); i++) {
		if (i < (1 << 7)) dp[i] = false;
		else dp[i] = true;
	}

	vector<string> moves(n + 8);
	for (int i = 0; i < n; i++) cin >> moves[8 + i];
	moves[0] = moves[8];
	for (int i = 1; i < 8; i++) moves[i] = "SSSSSSSS";

	for (int i = 0; i < 8; i++) moves.pb("TTTTTTTT");

	for (int i = 0; i < n; i++) {

		vector<bool> mesh(8);
		for (int j = 1; j <= 8; j++) {
			int diff = 8;
			for (int s = 0; s < 8; s++) if (moves[i][s] != moves[i + j][s]) diff--;
			if (diff >= j) mesh[j - 1] = true;
		}

		vector<bool> ndp((1 << 8));
		for (int j = 0; j < (1 << 8); j++) {
			int x = j;
			bool is_9 = false;
			for (int k = 0; k < 8; k++) {
				if (mesh[7 - k] && x % 2 == 0) is_9 = true;
				x /= 2;
			}
			ndp[j] = dp[j / 2 + (is_9 ? (1 << 7) : 0)];
		}

		dp = ndp;

		if (i < n) {
			vector<vector<int>> gr(8);
			vector<bool> res(8);
			for (int j = i + 1; j <= i + 8; j++) {
				for (int k = j + 1; k <= i + 8; k++) {
					int diff = 8;
					for (int s = 0; s < 8; s++) if (moves[j][s] != moves[k][s]) diff--;
					if (diff >= k - j) gr[j - i - 1].pb(k - i - 1);
				}
			}
			for (int i = 7; i >= 0; i--) {
				for (int el : gr[i]) if (!res[el]) res[i] = true;
			}
			int x = 0;
			for (int i = 0; i < 8; i++) x = 2 * x + res[i];

			if (dp[x]) cout << '2';
			else cout << '1';
		}
	}

	cout << endl;
}