﻿/*
X⣿⣷⡁⢆⠈⠕⢕⢂⢕⢂⢕⢂⢔⢂⢕⢄⠂⣂⠂⠆⢂⢕⢂⢕⢂⢕⢂⢕⢂
X⣿⣿⡷⠊⡢⡹⣦⡑⢂⢕⢂⢕⢂⢕⢂⠕⠔⠌⠝⠛⠶⠶⢶⣦⣄⢂⢕⢂⢕
X⣿⠏⣠⣾⣦⡐⢌⢿⣷⣦⣅⡑⠕⠡⠐⢿⠿⣛⠟⠛⠛⠛⠛⠡⢷⡈⢂⢕⢂
X⣡⣾⣿⣿⣿⣿⣦⣑⠝⢿⣿⣿⣿⣿⣿⡵⢁⣤⣶⣶⣿⢿⢿⢿⡟⢻⣤⢑⢂
X⣿⣿⡿⢟⣛⣻⣿⣿⣿⣦⣬⣙⣻⣿⣿⣷⣿⣿⢟⢝⢕⢕⢕⢕⢽⣿⣿⣷⣔
X⣿⠵⠚⠉⢀⣀⣀⣈⣿⣿⣿⣿⣿⣿⣿⣿⣿⣗⢕⢕⢕⢕⢕⢕⣽⣿⣿⣿⣿
X⣂⣠⣴⣾⡿⡿⡻⡻⣿⣿⣴⣿⣿⣿⣿⣿⣿⣷⣵⣵⣵⣷⣿⣿⣿⣿⣿⣿⡿
X⠻⣿⡿⡫⡪⡪⡪⡪⣺⣿⣿⣿⣿⣿⠿⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⠃
X⡁⠹⡪⡪⡪⡪⣪⣾⣿⣿⣿⣿⠋⠐⢉⢍⢄⢌⠻⣿⣿⣿⣿⣿⣿⣿⣿⠏⠈
X⡘⢄⠙⣾⣾⣾⣿⣿⣿⣿⣿⣿⡀⢐⢕⢕⢕⢕⢕⡘⣿⣿⣿⣿⣿⣿⠏⠠⠈
X⢊⢂⢣⠹⣿⣿⣿⣿⣿⣿⣿⣿⣧⢐⢕⢕⢕⢕⢕⢅⣿⣿⣿⣿⡿⢋⢜⠠⠈
X⠁⠕⢝⡢⠈⠻⣿⣿⣿⣿⣿⣿⣿⣷⣕⣑⣑⣑⣵⣿⣿⣿⡿⢋⢔⢕⣿⠠⠈
X⡂⡀⢑⢕⡅⠂⠄⠉⠛⠻⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⡿⢋⢔⢕⢕⣿⣿⠠
*/

#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4,tune=native")

#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <cassert>
#include <cstring>
#include <numeric>
#include <set>
#include <queue>
#include <deque>
#include <array>
#include <string>
#include <cmath>
#include <random>
#include <ctime>
#include <map>
#include <functional>
#include <bitset>
#include <complex>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define endl '\n'
#define mp make_pair

using namespace std;
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using ld = long double;

const ll mod = 998244353;
const ld eps = 1e-8;

const ll inf = 1e9;

const ll P = 1e9 + 7;
const ll Q = 150001;

mt19937 rng(999);

vector<int> rabbit_hole(int s, vector<int> &children, vector<vector<int>> &chcodes) {
	if (s == sz(children) - 1) {
		vector<int> res(1, children[s]);
		for (auto el : chcodes[s]) res.pb(el);
		return res;
	}
	else {
		vector<int> res;
		auto seq = rabbit_hole(s + 1, children, chcodes);
		for (auto el : seq) res.pb(el);
		res.pb(children[s]);
		reverse(all(seq));
		for (auto el : seq) res.pb(el);
		for (auto el1 : chcodes[s]) {
			res.pb(el1);
			reverse(all(seq));
			for (auto el : seq) res.pb(el);
		}
		return res;
	}
}

vector<int> ctree(int v, vector<int> &p) {
	vector<int> children;
	for (int i = 0; i < sz(p); i++) if (p[i] == v) children.pb(i);

	vector<int> seq;
	if (sz(children) == 0) return seq;

	vector<vector<int>> chcodes;
	for (auto ch : children) chcodes.pb(ctree(ch, p));

	seq = rabbit_hole(0, children, chcodes);

	return seq;
}

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

void process_all_digits(int pos, int v, vector<int> &nums, vector<char> &dir_mtch, vector<int> &rev_mtch, vector<vector<int>> &dictree, vector<int> &amt, vector<int> &lnk, vector<int> &occ_cnt) {
	if (pos == sz(nums)) {
		if (lnk[v] != -1) occ_cnt[lnk[v]]++;
	}
	else {
		if (dir_mtch[nums[pos]] != ' ') {
			if (dictree[v][dir_mtch[nums[pos]] - 'A'] != -1)
				process_all_digits(pos + 1, dictree[v][dir_mtch[nums[pos]] - 'A'], nums, dir_mtch, rev_mtch, dictree, amt, lnk, occ_cnt);
		}
		else {
			for (char ch = 'A'; ch <= 'Z'; ch++) {
				if (rev_mtch[ch - 'A'] == -1 && dictree[v][ch - 'A'] != -1) {
					dir_mtch[nums[pos]] = ch;
					rev_mtch[ch - 'A'] = nums[pos];
					process_all_digits(pos + 1, dictree[v][dir_mtch[nums[pos]] - 'A'], nums, dir_mtch, rev_mtch, dictree, amt, lnk, occ_cnt);
					dir_mtch[nums[pos]] = ' ';
					rev_mtch[ch - 'A'] = -1;
				}
			}
		}
	}
}


vector<pair<int, int>> pathto270;
int n;
int X, Y;
int pos;
const int INF = 1e9 + 7;
const int T = 25;
int used[50][50];

mt19937 rnd(228);

int dx[] = { 0, 1, 1, 0, -1, -1 };
int dy[] = { 1, 0, -1, -1, 0, 1 };

pair<int, int> my_move() {
	if (pos >= sz(pathto270)) {
		vector<pair<int, int>> moves;
		for (int i = 0; i < 6; i++) {
			int newx = X + dx[i];
			int newy = Y + dy[i];
			if (newx >= -20 && newx <= 20 && newy >= -20 && newy <= 20 && newx + newy >= -20 && newx + newy <= 20 && !used[newx + T][newy + T]) {
				moves.push_back({ newx, newy });
			}
		}
		if (sz(moves) == 0) {
			return { INF, INF };
		}
		shuffle(all(moves), rnd);
		int kek = 0;//abs((int)rnd()) % sz(moves);
		int curx = moves[kek].first, cury = moves[kek].second;
		used[curx + T][cury + T] = 1;
		pair<int, int> res = { curx - X, cury - Y };
		X = curx;
		Y = cury;
		return res;

		return { INF, INF };
	}
	X += pathto270[pos].first;
	Y += pathto270[pos].second;
	if (used[X + T][Y + T]) {
		X -= pathto270[pos].first;
		Y -= pathto270[pos].second;

		vector<pair<int, int>> moves;
		for (int i = 0; i < 6; i++) {
			int newx = X + dx[i];
			int newy = Y + dy[i];
			if (newx >= -20 && newx <= 20 && newy >= -20 && newy <= 20 && newx + newy >= -20 && newx + newy <= 20 && !used[newx + T][newy + T]) {
				moves.push_back({ newx, newy });
			}
		}
		if (sz(moves) == 0) {
			return { -INF, -INF };
		}
		shuffle(all(moves), rnd);
		int kek = 0;//abs((int)rnd()) % sz(moves);
		int curx = moves[kek].first, cury = moves[kek].second;
		used[curx + T][cury + T] = 1;
		pair<int, int> res = { curx - X, cury - Y };
		X = curx;
		Y = cury;
		return res;

		return { -INF, -INF };
	}
	used[X + T][Y + T] = 1;
	return { pathto270[pos].first, pathto270[pos].second };
}

int XX, YY;

pair<int, int> other_move() {
	vector<pair<int, int>> moves;
	for (int i = 0; i < 6; i++) {
		int newx = XX + dx[i];
		int newy = YY + dy[i];
		if (newx >= -20 && newx <= 20 && newy >= -20 && newy <= 20 && newx + newy >= -20 && newx + newy <= 20 && !used[newx + T][newy + T]) {
			moves.push_back({ newx, newy });
		}
	}
	if (sz(moves) == 0) {
		return { INF, INF };
	}
	shuffle(all(moves), rnd);
	int kek = 0;//abs((int)rnd()) % sz(moves);
	int curx = moves[kek].first, cury = moves[kek].second;
	used[curx + T][cury + T] = 1;
	XX = curx;
	YY = cury;
	return { XX, YY };
}

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	// path: (-10, 0) -> (0, 0) -> (0, 20) -> (-1, 20) -> (-1, 1) -> (-11, 1) -> (-11, 0) -> (-10, -1) -> (-6, -1) -> (13, -20) -> ...
	/*int ba = 0;
	int bp = 6;

	for (int i = 0; i < 10 - ba; i++) pathto270.pb(mp(1, 0));
	for (int i = 0; i < 20; i++) pathto270.pb(mp(0, 1));
	pathto270.pb(mp(-1, 0));
	for (int i = 0; i < 19; i++) pathto270.pb(mp(0, -1));
	for (int i = 0; i < 10 - ba; i++) pathto270.pb(mp(-1, 0));
	pathto270.pb(mp(0, -1));
	pathto270.pb(mp(1, -1));
	for (int i = 0; i < 10 - bp; i++) pathto270.pb(mp(1, 0));
	for (int i = 0; i < 19; i++) pathto270.pb(mp(1, -1));
	// 12 -> top -> 11 -> bottom -> ...
	for (int x = 18 - bp; x >= 0; x--) {
		pathto270.pb(mp(-1, 0));
		if (x % 2 == 0) for (int i = 0; i < 18; i++) pathto270.pb(mp(-1, 1));
		else for (int i = 0; i < 18; i++) pathto270.pb(mp(1, -1));
	}
	// at (-18, 2)
	pathto270.pb(mp(-1, 1));
	pathto270.pb(mp(-1, 1));
	for (int i = 0; i < 20; i++) pathto270.pb(mp(0, 1));
	// 1 -> bottom -> 2 -> top -> ...
	for (int x = 1; x < 20 - ba; x++) {
		pathto270.pb(mp(1, 0));
		if (x % 2 == 0) for (int i = 0; i < 18; i++) pathto270.pb(mp(0, 1));
		else for (int i = 0; i < 18; i++) pathto270.pb(mp(0, -1));
	}*/

	/*int lofi = 3;
	for (int i = 0; i < lofi; i++) pathto270.pb(mp(-1, 0));
	for (int i = 0; i < 20; i++) pathto270.pb(mp(0, 1));
	// 0 -> bottom -> 1 -> top -> ...
	for (int x = 0; x < 10 - lofi; x++) {
		pathto270.pb(mp(-1, 0));
		if (x % 2 == 0) {
			for (int i = 0; i < 20; i++) pathto270.pb(mp(0, -1));
			for (int i = 0; i < 20; i++) pathto270.pb(mp(1, -1));
		}
		else {
			for (int i = 0; i < 20; i++) pathto270.pb(mp(-1, 1));
			for (int i = 0; i < 20; i++) pathto270.pb(mp(0, 1));
		}
	}*/

	/*pathto270.pb(mp(1, 0));
	for (int i = 1; i < 10; i++) {
		for (int j = 0; j < i; j++) pathto270.pb(mp(-1, 1));
		for (int j = 0; j < i; j++) pathto270.pb(mp(-1, 0));
		for (int j = 0; j < i; j++) pathto270.pb(mp(0, -1));
		for (int j = 0; j < i; j++) pathto270.pb(mp(1, -1));
		for (int j = 0; j < i + 1; j++) pathto270.pb(mp(1, 0));
		for (int j = 0; j < i; j++) pathto270.pb(mp(0, 1));
	}*/

	for (int i = 0; i < 20; i++) pathto270.pb(mp(0, 1));
	// 0 -> bottom -> 1 -> top -> ...
	for (int x = 0; x < 10; x++) {
		if (x % 2 == 0) {
			pathto270.pb(mp(-1, 0));
			for (int i = 0; i < 29 - x; i++) pathto270.pb(mp(0, -1));
		}
		else {
			pathto270.pb(mp(-1, 1));
			for (int i = 0; i < 29 - x; i++) pathto270.pb(mp(0, 1));
		}
	}
	//pathto270.pb(mp(-1, 1));
	//for (int i = 0; i < 20; i++) pathto270.pb(mp(1, -1));
	//for (int i = 0; i < 20; i++) pathto270.pb(mp(1, 0));

	//for (int i = 0; i < 20; i++) pathto270.pb(mp(0, 1));
	//pathto270.pb(mp(-1, 0));
	//for (int i = 0; i < 30; i++) pathto270.pb(mp(0, -1));

	//freopen("out.txt", "w", stdout);

	int losses = 0, il = 0;
	
	int t = 100000;
	cin >> t;
	int n;
	cin >> n;
	for (int i = 0; i < t; i++) {
		X = -10;
		Y = 0;
		XX = 10;
		YY = 0;
		pos = 0;
		for (int j = 0; j < 50; j++) {
			for (int k = 0; k < 50; k++) {
				used[j][k] = 0;
			}
		}
		used[X + T][Y + T] = 1;
		used[XX + T][YY + T] = 1;
		int move_ind = 0;
		while (true) {
			move_ind++;
			auto f = my_move();
			cout << f.first << ' ' << f.second << endl;
			cout.flush();

			string token;
			cin >> token;
			if (token == "win") break;
			if (token == "lose") return 0;
			int sx, sy;
			cin >> sx >> sy;
			XX += sx; 
			YY += sy;
			used[XX + T][YY + T] = 1;
			/*//cout << X << ' ' << Y << endl;
			if (abs(f.first) == INF) {
				//cout << i << endl;
				//cout << "LOST!!! " << move_ind << endl;
				//cout << X << ' ' << Y << endl;
				//cout << XX << ' ' << YY << endl;
				//return 0;
				if (f.first == INF) il++;
				else losses++;
				break;
			}
			auto s = other_move();
			//cout << "> " << XX << ' ' << YY << endl;
			if (abs(s.first) == INF) {
				//cout << "WIN!!! " << move_ind << endl;
				if (i % 1000 == 0) cout << i << ' ' << move_ind << endl;
				break;
			}*/
			pos++;
		}
	}

	//cout << t - losses - il << " / " << losses << ' ' << il << endl;
}
