#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <unordered_set>
#include <string>
#include <map>
#include <unordered_map>
#include <queue>
#include <assert.h>
#include <cmath>
#include <sstream>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll linf = (ll)1e18 + 10;
const int iinf = (int)1e9 + 10;
const int mod = 998244353;
const int modd = 1000000007;
const ld PI = acos(-1);
#define all(x) x.begin(), x.end()

const int maxn = 5e5 + 10;
int tr[maxn], w[maxn], used[maxn];


bool dfs(vector<vector <int>> & gr, vector <int> & w, int v, int & a, int  & b, int & summ){
    bool f = true;
    a = b = summ = 0;
    if (w[v] == 1) a++;
    if (w[v] == 2) b++;
    summ += w[v];
    vector <int> sums;
    for (auto u : gr[v]){
        if (u != 0){
            int a1, b1, summ1;
            f &= dfs(gr, w, u, a1, b1, summ1);
            a += a1, b += b1, summ += summ1;
            sums.push_back(summ1);
        }
        else{
            sums.push_back(0);
        }
    }
    if (sums.size() != 2 || abs(sums[0] - sums[1]) > 1) f = false;

    return f;
}

bool check(vector<vector <int>> gr, vector <int> w, int a, int b){
    int aa, bb, summ;
    return dfs(gr, w, 1, aa, bb, summ) && (a == aa) && (b == bb);
}

void gen_tree(int root, int c2, int summ){
    if (summ == 0) return;
    tr[root] = root / 2;
    used[root]  =1;
    if (c2 == 0){
        w[root] = 1;
        gen_tree(2*root, 0, summ/2);
        gen_tree(2*root+1, 0, (summ-1)/2);
    }
    else{
        w[root] = 2;
        gen_tree(2*root, c2/2, (summ-1)/2);
        gen_tree(2*root+1, (c2-1)/2, (summ-2)/2);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int a, b;
    cin >> a >> b;
    gen_tree(1, b, a+2*b);

    int ii = 1;
    vector <int> newnum(maxn), neww(maxn);
    vector <vector <int>> gr(maxn);
    for (int i = 0; i < maxn; i++){
        if (used[i]){
            newnum[i] = ii; ii++;
            gr[newnum[tr[i]]].push_back(newnum[i]);
            neww[newnum[i]] = w[i];
        }
    }
    for (int i = 0; i < maxn; i++){
        if (used[i]){
            int ind = newnum[i];
            while (gr[ind].size() < 2) gr[ind].push_back(0);
        }
    }
    if (!check(gr, neww, a, b)){
        cout << -1;
        return 0;
    }
    for (int i = 0; i < maxn; i++){
        if (used[i]){
            int ind = newnum[i];
            cout << neww[ind] << " " << gr[ind][0] << " " << gr[ind][1] << "\n";
        }
    }

    //assert(check(gr, neww, a, b));

    return 0;
}