#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef vector<ll> vll;

#define printvi(arr) for (int x : arr) cout << x << ' '; cout << '\n';
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)

const int maxn = 2e5;
vi l(maxn), r(maxn), x(maxn);
vi minn(maxn), maxx(maxn);

struct Node {
    Node *L, *R;
    int sum = 0;

    Node(int x) {
        L = nullptr, R = nullptr;
        sum = x;
    }

    Node(Node *l, Node *r) {
        L = l;
        R = r;
        if (l != nullptr) sum += l->sum;
        if (r != nullptr) sum += r->sum;
    }

};

Node *build(int l, int r) {
    if (l == r) {
        return new Node(0);
    }
    int m = (l + r) >> 1;
    return new Node(build(l, m), build(m + 1, r));
}

Node *upd(Node *node, int vl, int vr, int i) {
    if (vl == vr) {
        return new Node(1 + node->sum);
    }
    int vm = (vl + vr) >> 1;
    if (i <= vm) {
        return new Node(upd(node->L, vl, vm, i), node->R);
    } else {
        return new Node(node->L, upd(node->R, vm + 1, vr, i));
    }
}

int query(Node *node, int vl, int vr, int l, int r) {
    if (l > vr || vl > r) return 0;
    if (vl >= l && vr <= r) return node->sum;
    int vm = (vl + vr) >> 1;
    return query(node->L, vl, vm, l, r) + query(node->R, vm + 1, vr, l, r);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vi x0(maxn);
    set<int> setx;
    forn(i, n) {
        cin >> l[i] >> r[i] >> x0[i];
        setx.insert(x0[i]);
        l[i]--, r[i]--;
    }
    int q;
    cin >> q;
    vector<pair<int, int>> lr(q);
    forn(i, q) {
        cin >> lr[i].first >> lr[i].second;
        setx.insert(lr[i].first);
        setx.insert(lr[i].second);
    }
    map<int, int> mapx;
    int I = 0;
    for (int x : setx) mapx[x] = I++;
    forn(i, n) x[i] = mapx[x0[i]];
    vector<Node *> roots(1e6);
    vvi idx(1e6);
    for (int i = n - 1; i >= 0; --i) {
        minn[i] = maxx[i] = x[i];
        if (l[i] != -1) {
            minn[i] = min(minn[i], minn[l[i]]);
            maxx[i] = max(maxx[i], maxx[l[i]]);
        }
        if (r[i] != -1) {
            minn[i] = min(minn[i], minn[r[i]]);
            maxx[i] = max(maxx[i], maxx[r[i]]);
        }
        idx[minn[i]].push_back(i);
    }
    Node *root = build(0, (1 << 20) - 1);
    forn(i, 1e6) {
        Node *node = (i == 0 ? root : roots[i - 1]);
        if (idx[i].empty()){
            roots[i] = node;
            continue;
        }
        for (int j : idx[i]) {
            node = upd(node, 0, (1 << 20) - 1, maxx[j]);
        }
        roots[i] = node;
    }
    forn(i0, q) {
        int l = lr[i0].first, r = lr[i0].second;
        l = mapx[l];
        r = mapx[r];
        int ans = 1;
        if (l > 0) {
            ans += 2 * query(roots[l - 1], 0, (1 << 20) - 1, l, 1e6);
            ans -= 2 * query(roots[l - 1], 0, (1 << 20) - 1, r + 1, 1e6);
        }
        ans += 2 * query(roots[r], 0, (1 << 20) - 1, r + 1, 1e6);
        cout << ans << '\n';
    }
}
