// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#ifdef PERVEEVM_LOCAL
    #define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl
#else
    #define debug(x) 238;
#endif

#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0)
#define NAME "File"

using ll = long long;
using ld = long double;

#ifdef PERVEEVM_LOCAL
    std::mt19937 rnd(238);
#else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;
const int N = 200100;

int a, b;
int left[N], right[N], w[N];
int curV = 0;

void fail() {
    printf("-1\n");
    exit(0);
}

void dfs(int v, int sum) {
    if (sum == 1) {
        if (a == 0) {
            fail();
        }

        w[v] = 1;
        --a;
        return;
    }

    if (b != 0) {
        w[v] = 2;
        sum -= 2;
        --b;

        int w1 = sum / 2;
        int w2 = sum - w1;

        if (w1 != 0) {
            ++curV;
            left[v] = curV;
            dfs(curV, w1);
        }
        if (w2 != 0) {
            ++curV;
            right[v] = curV;
            dfs(curV, w2);
        }
    } else {
        w[v] = 1;
        --sum;
        --a;

        int w1 = sum / 2;
        int w2 = sum - w1;

        if (w1 != 0) {
            ++curV;
            left[v] = curV;
            dfs(curV, w1);
        }
        if (w2 != 0) {
            ++curV;
            right[v] = curV;
            dfs(curV, w2);
        }
    }
}

void run() {
    scanf("%d%d", &a, &b);

    memset(left, -1, sizeof(left));
    memset(right, -1, sizeof(right));

    dfs(0, a + 2 * b);

    for (int i = 0; i <= curV; ++i) {
        printf("%d %d %d\n", w[i], left[i] + 1, right[i] + 1);
    }
}

int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);

    auto start = std::chrono::high_resolution_clock::now();
    run();
    auto end = std::chrono::high_resolution_clock::now();

    #ifdef PERVEEVM_LOCAL
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif

    return 0;
}
