#include <algorithm>
#include <bitset>
#include <iostream>
#include <iterator>
#include <random>
#include <set>
#include <vector>

// #define FAST_ALLOCATOR_MEMORY 256000000
// #include "optimization.h"
#include <bits/stdc++.h>

using namespace std;

// #define USE_INT128
#define int int64_t

// #undef _DEBUG

#define all(x) begin(x), end(x)
#define rall(x) (x).rbegin(), (x).rend()

#ifdef USE_INT128
#define lint __int128
#define ulint __int128
#else
#define lint int64_t
#define ulint int64_t
#endif

typedef long double ld;
// #define f first
// #define s second
typedef pair<int, int> pint;

const int inf = 1 << 30;

template <class T>
T mineq(T& a, const T& b) {
    return a = min(a, b);
}

template <class T>
T maxeq(T& a, const T& b) {
    return a = max(a, b);
}

mt19937 rd(533);
// end of default file

template <class T>
struct mp {
    int getnum(T x) {
        if (!m.count(x)) {
            int sz = m.size();
            m[x] = sz;
        }
        return m[x];
    }
    bool count(T x) {
        return m.count(x);
    }

    map<T, int> m;
};

vector<int> wtomask(string &s, mp<char> &topc) {
    mp<char> used;
    vector<int> res;
    for (char c : s) {
        if (topc.count(c)) {
            res.push_back(topc.getnum(c));
        } else {
            res.push_back(topc.m.size() + used.getnum(c));
        }
    }
    return res;
}

int32_t main() {
    srand(5332017);
    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    cout << fixed;
    cout.precision(1); // !!

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
#endif

    string s1, s2;
    cin >> s1 >> s2;

    mp<char> cnum;
    for (char c : (s1 + s2)) {
        cnum.getnum(c);
    }

    if (cnum.m.size() > 10) {
        cout << "0\n";
        return 0;
    }

    char numc[10] = {};
    for (auto& p : cnum.m) {
        numc[p.second] = p.first;
    }

    map<vector<int>, int> possible;

    int qcnt = 1;
    for (int i = 1; i <= 10 - cnum.m.size(); i++) {
        qcnt *= i;
    }

    int cnum_to_dig[10];
    for (int i = 0; i < 10; i++) cnum_to_dig[i] = i;
    do {
        auto c_to_dig = [&](char c) { return cnum_to_dig[cnum.m[c]]; };

        if (c_to_dig(s1[0]) == 0 || c_to_dig(s2[0]) == 0) {
            continue;
        }

        auto word_to_num = [&](string s) {
            int x = 0;
            for (char c : s) {
                x = x * 10 + c_to_dig(c);
            }
            return x;
        };
        
        vector<int> d;
        int rr;
        {
            int res = word_to_num(s1) + word_to_num(s2);
            rr = res;
            while (res > 0) {
                d.push_back(res % 10);
                res /= 10;
            }
            reverse(all(d));
        }

        int dig_to_cnum[10];
        for (int i = 0; i < 10; i++)
            dig_to_cnum[cnum_to_dig[i]] = i;

        vector<int> mask(d.size());
        for (int i = 0; i < d.size(); i++)
            mask[i] = dig_to_cnum[d[i]];
        

        possible[mask]++;

    } while (next_permutation(cnum_to_dig, cnum_to_dig + 10));

    int m;
    cin >> m;
    vector<string> ans;

    // int f[18];
    // f[0] = 1;

    for (int i = 0; i < m; i++) {
        string s;
        cin >> s;

        int used = cnum.m.size();
        for (int c : wtomask(s, cnum)) maxeq(used, c);
        int unused = 10 - used;

        int f = 1;
        for (int i = 1; i < unused; i++) f *= i;

        if (possible[wtomask(s, cnum)] == f) {
            ans.push_back(s);
        }
    }

    cout << ans.size() << '\n';
    for (auto& i : ans) cout << i << '\n';
}
