#include <iostream>

using namespace std;

const int maxN = 1e7 + 100;

const long long MOD = 1e9 + 7;
const long long INF = 1e9 + 100;

long long fact[maxN];
long long inv[maxN];

long long modexp(long long a, long long p) {
  long long ans = 1;
  while (p > 0) {
    if (p % 2 == 1) {
      ans = ans * a % MOD;
    }
    a = a * a % MOD;
    p /= 2;
  }
  return ans;
}

struct point {
  long long x, y;
};

long long left(long long h, point a, point b) {
  if (a.y > b.y) {
    swap(a, b);
  }
  if (a.y > h) {
    return INF;
  }
  if (b.y < h) {
    return INF;
  }
  if(a.y == b.y) {
    return min(a.x, b.x);
  }
  long long dx = b.x - a.x;
  long long dy = b.y - a.y;
  return a.x + ((h - a.y) * dx + dy - 1) / dy;
}

long long right(long long h, point a, point b) {
  if (a.y > b.y) {
    swap(a, b);
  }
  if (a.y > h) {
    return -INF;
  }
  if (b.y < h) {
    return -INF;
  }
  if(a.y == b.y) {
    return max(a.x, b.x);
  }
  long long dx = b.x - a.x;
  long long dy = b.y - a.y;
  return a.x + ((h - a.y) * dx) / dy;
}

long long cnk(long long n, long long k) {
  if (n == 0 && k == 0) {
    return 1;
  }
  if (k > n) {
    return 0;
  }
  return fact[n] * inv[k] % MOD * inv[n - k] % MOD;
}

int main() {
  fact[0] = 1;
  inv[0] = modexp(fact[0], MOD - 2);
  for (long long i = 1; i < maxN; i++) {
    fact[i] = i * fact[i - 1] % MOD;
    inv[i] = modexp(fact[i], MOD - 2);
  }

  int t = 0;
  cin >> t;
  for (int test = 0; test < t; test++) {
    int xa, xb, xc, ya, yb, yc;
    cin >> xa >> ya >> xb >> yb >> xc >> yc;

    point a = {ya + xa, ya - xa};
    point b = {yb + xb, yb - xb};
    point c = {yc + xc, yc - xc};

    long long ans = 0;
    for (int h = 0; h < maxN; h++) {
      long long l = min(min(left(2 * h, a, b), left(2 * h, a, c)), left(2 * h, b, c));
      long long r = max(max(right(2 * h, a, b), right(2 * h, a, c)), right(2 * h, b, c));
      //cerr << l << " " << r << "\n";
      if (l > r) {
        continue;
      }
      l = max(l, 0LL);
      l = (l + 1) / 2;
      r = r / 2;
      if (l > r) {
        continue;
      }
      //cerr << l << " " << r << "\n";

      ans = (ans + cnk(r + 1 + h, h + 1) - cnk(l + h, h + 1) + MOD) % MOD;
    }
    cout << ans << "\n";
  }
};
