#include <algorithm>
#include <bitset>
#include <iostream>
#include <iterator>
#include <random>
#include <set>
#include <vector>

// #define FAST_ALLOCATOR_MEMORY 256000000
// #include "optimization.h"
#include <bits/stdc++.h>

using namespace std;

// #define USE_INT128
// #define int int64_t

// #undef _DEBUG

#define all(x) begin(x), end(x)
#define rall(x) (x).rbegin(), (x).rend()

#ifdef USE_INT128
#define lint __int128
#define ulint __int128
#else
#define lint int64_t
#define ulint int64_t
#endif

typedef long double ld;
// #define f first
// #define s second
typedef pair<int, int> pint;

const int inf = 1 << 30;

template <class T>
T mineq(T& a, const T& b) {
    return a = min(a, b);
}

template <class T>
T maxeq(T& a, const T& b) {
    return a = max(a, b);
}

mt19937 rd(533);
// end of default file

struct myhash {
    hash<int> h = hash<int>();

    std::size_t operator()(const pair<int, int>& p) const {
        h(p.first) + h(p.second);
    }
};

const int N = 200010 * 6;
int fv[N] = {};

int fvget(int x) {
    int a = 0;
    for (int i = x; i > 0; i = (i & (i + 1)) - 1) {
        a += fv[i];
    }
    return a;
}

int fvadd(int x, int a) {
    for (int i = x; i < N; i |= i + 1) {
        fv[i] += a;
    }
}

struct node {
    int key;
    int l, r;
    int mx, mn;
};

vector<node> tree;

pair<int, int> calc(int v) {
    if (v == -1) {
        return { inf, -inf };
    }

    node& t = tree[v];

    t.mn = t.mx = t.key;
    if (t.l != -1)
        t.mn = calc(t.l).first;
    if (t.r != -1)
        t.mx = calc(t.r).second;
    return { t.mn, t.mx };
}

struct query {
    int pos;
    int type; // 0 query open, 1 left end, 2 query close
    int info;
    int info2;

    bool operator<(const query& oth) const {
        if (pos != oth.pos)
            return pos > oth.pos;
        return type > oth.type;
    }
};

int32_t main() {
    srand(5332017);
    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    cout << fixed;
    cout.precision(1); // !!

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;

    tree.resize(n);

    set<int> keys;
    for (int i = 0; i < n; i++) {
        int l, r, k;
        node& t = tree[i];
        cin >> tree[i].l >> tree[i].r >> tree[i].key;
        --tree[i].l, --tree[i].r;

        keys.insert(t.key);
        keys.insert(t.key + 1);
        keys.insert(t.key - 1);
    }

    map<int, int> key_num;
    for (auto& k : keys) {
        int sz = key_num.size();
        key_num[k] = sz;
    }
    for (auto& t : tree) {
        t.key = key_num[t.key];
    }

    calc(0);

    priority_queue<query> qq;

    for (auto& t : tree) {
        if (t.mx != t.mn)
            qq.push(query { t.mn, 1, t.mx });
        // fvadd(t.mn, t.mx, 1);

// #ifdef _DEBUG
//         cout << t.mn << ' ' << t.mx << " [-]\n";
// #endif
    }

    int q;
    cin >> q;
    for (int qi = 0; qi < q; qi++) {
        int l, r;
        cin >> l >> r;

        l = key_num.lower_bound(l)->second;
        r = key_num.lower_bound(r)->second;

        qq.push({ l, 0, r, qi });
        qq.push({ r, 2, l, qi });
    }

    int qa[q] = {};

    while (!qq.empty()) {
        query w = qq.top();
        qq.pop();

        if (w.type == 0) {
            int l = w.pos;
            int r = w.info;
            int qi = w.info2;

            qa[qi] += fvget(r) - fvget(l - 1);
#ifdef _DEBUG
            cout << l << ' ' << r << ' ' << fvget(r) - fvget(l-1) << " [->\n";
#endif
        }

        if (w.type == 2) {
            int r = w.pos;
            int l = w.info;
            int qi = w.info2;

            qa[qi] += fvget(N - 1) - fvget(r);
#ifdef _DEBUG
            cout << l << ' ' << r << ' ' << fvget(N - 1) - fvget(r) << " ]->\n";
#endif
        }

        if (w.type == 1) {
            int l = w.pos;
            int r = w.info;

            fvadd(r, 1);
#ifdef _DEBUG
            cout << l << ' ' << r << ' ' << " [-]\n";
#endif
        }
    }

    for (int i : qa) cout << 1 + 2 * i << '\n';
}
