﻿#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <cmath>
#include <iomanip>
#include <array>
#include <numeric>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <queue>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <cassert>

#define all(a) (a).begin(), (a).end()

using namespace std;
using ll = long long;
using ld = long double;

const int N = 20;

int n;
vector<int> g[N];

void read(istream& cin) {
	cin >> n;
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		--p;
		g[p].push_back(i);
	}
}

vector<int> dp[N];

void dfs(int v) {
	for (int to : g[v]) {
		dfs(to);
	}
	sort(all(g[v]), [&](int u, int v) { return dp[u].size() > dp[v].size(); });
	if (!g[v].empty()) {
		dp[v] = dp[g[v][0]];
		for (int i = 1; i < g[v].size(); i++) {
			auto kek = dp[v];
			for (int x : dp[g[v][i]]) {
				dp[v].push_back(x);
				reverse(all(kek));
				dp[v].insert(dp[v].end(), all(kek));
			}
		}
	}
	if (v) {
		dp[v].insert(dp[v].begin(), v);
	}
}

void solve(ostream& cout) {
	dfs(0);
	cout << dp[0].size() << endl;
	for (int x : dp[0]) {
		cout << x + 1 << ' ';
	}
	cout << endl;
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int tc = 1;
	// cin >> tc;
	while (tc--) {
		read(cin);
		solve(cout);
	}
}
