﻿// Author: Igor Smirnov
#ifdef DEBUG_MODE
#define _GLIBCXX_DEBUG 1
#endif
#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
typedef unsigned int ui;
typedef unsigned long long ull;

#define vin(n) vector<int>(n, 0)
#define vvin(n, m) vector<vector<int>>(n, vector<int>(m, 0))
#ifndef CERR_ON
#define cerr if (false) cerr
#endif
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rev(a) reverse(all(a))
#define csp(a) cout << a << ' '
#define f first
#define s second
#define mp make_pair
#define pb push_back
#define next next42

inline void init() {
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

int n;
const int MAXN = 20;
int par[MAXN];
int not_leaf[MAXN];
bool used[1 << MAXN];

inline bool check(int mask) {
    if ((mask & 1) == 0) {
        return false;
    }
    for (int i = 1; i < n; ++i) {
        if ((mask & (1 << i)) && !(mask & (1 << par[i]))) {
            return false;
        }
    }
    return true;
}

vector<int> hamilton_masks[19];

void compute_hamilton_masks() {
    hamilton_masks[1].push_back(0);
    hamilton_masks[1].push_back(1);

    for (int i = 2; i < 20; i++) {
        hamilton_masks[i] = hamilton_masks[i - 1];
        for (int j = hamilton_masks[i - 1].size() - 1; j >= 0; j--) {
            int new_mask = hamilton_masks[i - 1][j];
            new_mask |= (1 << (i - 1));
            hamilton_masks[i].push_back(new_mask);
        }
    }
}

int is_colored[MAXN];

vector<int> ans;

void color_parents(int a) {
    if (is_colored[a]) {
        return;
    }
    color_parents(par[a]);
    ans.push_back(a);
    is_colored[a] = true;
}

void uncolor_parents(int a) {
    if (!is_colored[a]) {
        return;
    }
    if (a == 0) return;

    for (int i = 1; i < n; i++) {
        if (is_colored[i] && par[i] == a) {
            return;
        }
    }
    is_colored[a] = false;
    ans.push_back(a);
    uncolor_parents(par[a]);
}

int main() {
    init();
    cout.precision(20);
    cin >> n;
    if (n == 1) {
        cout << 0;
        return 0;
    }
    forn(i, n - 1) {
        int p;
        cin >> p;
        --p;
        par[i + 1] = p;
    }

    compute_hamilton_masks();

    for (int i = 1; i < n; i++) {
        not_leaf[par[i]] = true;
    }
    int leaves = 0;
    map<int, int> bit_to_i;
    for (int i = 0; i < n; i++) {
        if (!not_leaf[i]) {
            bit_to_i[leaves] = i;
            leaves += 1;
        }
    }

    auto obhods = hamilton_masks[leaves];
    is_colored[0] = 1;

    int bit_num_pre[(1 << MAXN) + 1];
    for (int i = 0; i <= MAXN; i++) {
        bit_num_pre[1 << i] = i;
    }

    for (int i = 1; i < obhods.size(); i++) {
        int switched = obhods[i - 1] ^ obhods[i];
        bool colored = (switched & obhods[i]) > 0;

        int bit_num = bit_num_pre[switched];
        int node_s = bit_to_i[bit_num];

//        cout << switched << ' ' << colored << ' ' << bit_num << ' ' << node_s << '\n';

        if (colored)
            color_parents(node_s);
        else
            uncolor_parents(node_s);
    }

    cout << ans.size() << '\n';
    for (int a: ans) {
        cout << a << ' ';
    }
}