#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#define __USE_MINGW_ANSI_STDIO 0
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include <stdio.h>
#include <iomanip>
#include <set>
#include <string>
#include <map>
#include <math.h>
#include <queue>
#include <complex>
#include <ctime>
#include <list>
#include <stack>
#include <chrono>
#include <random>
#define ll long long
#define lll __int128
#define fi first
#define ld long double
#define se second
#define pb push_back
#define pii pair<int,int>
#define pll pair<ll,ll>
#define vi vector<int>
#define vll vector<ll>
#define vii vector<vector<int>>
#define vvld vector<vector<ld>>
#define vvll vector<vector<ll>>
const ll MAXN = 2e5+10;
const ll INF = 1e9+10;
const ll mod = 1e9+7;
const ld eps = 1e-5;
using namespace std;

struct Point {
    long double x, y;
    Point() {
        x = 0, y = 0;
    };
    Point(const Point& p) {
        x = p.x, y = p.y;
    }
    Point(long double _x, long double _y) {
        x = _x, y = _y;
    }
    Point operator-(const Point& b) {
        return Point(x - b.x, y - b.y);
    }
    Point& operator-=(const Point& b) {
        x -= b.x, y -= b.y;
        return *this;
    }
    Point operator+(const Point& b) {
        return Point(x + b.x, y + b.y);
    }
    Point& operator+=(const Point& b) {
        x += b.x, y += b.y;
        return *this;
    }
    Point operator*(const long double mult) {
        return Point(x * mult, y * mult);
    }
    Point& operator*=(const long double mult) {
        x *= mult, y *= mult;
        return *this;
    }
    void normalize() {
        long double len = length();
        x /= len;
        y /= len;
    }
    long double length() {
        return sqrt(x * x + y * y);
    }
    long double dist(const Point& b) {
        return (*this - b).length();
    }
    long double dot(const Point& b) {
    	return x * b.x + y * b.y;
    }
    void in(){
        cin >> x >> y;
    }
};

ll binpow(ll x, ll y){
	ll ans = 1;
	while(y){
		if(y % 2 == 1)ans = (ans * x)%mod;
		x = (x * x)%mod;
		y /= 2;
	}
	return ans;
}

struct Line{
public:
	ld A, B, C;
	Line(){
	}
	Line(Point p1, Point p2){
		A = (p1-p2).y, B = -(p1-p2).x;
		C = -p1.x * A - p1.y * B;
	}
	pair<int, Point> operator ^ (Line l){
		ld koef = A * l.B - l.A * B;
		ld CC = l.C * B - l.B * C;
		if(koef == 0 && CC == 0)return {1, Point()};
		if(koef == 0 && CC != 0)return {-1, Point()};
		if(koef != 0){
			ld x = CC/koef, y = 0;
			if(B != 0)
				y = (-C - A * x)/B;
			else
				if(l.B != 0) 
					y = (-l.C - l.A * x)/l.B;
			return {0, Point(x, y)};
		}
		assert(false);
	}
	void print(){
		cout<<A<<"x+"<<B<<"y+"<<C<<endl;
	}
};

ll fact[(int)(5e6+10)];
ll afact[(int)(5e6+10)];

ll c(ll k, ll n){
	if(k > n)return 0;
	ll temp = (((fact[n] * afact[k])%mod) * afact[n-k])%mod;
	return temp;
}

void solve(int tt){
	Point p[3];
	Line l[3];
	int n = 3;
	for(int i = 0; i < 3; i++)
		p[i].in();
	for(int i = 0; i < 3; i++){
		l[i] = Line(p[i], p[(i+1)%n]);
		//l[i].print();
	}
	int f = 0;
	ll sum = 0;
	Line t = Line(Point(0, 0), Point(1, 1));
	for(ll i = 0;i < 10;i++){
		Point pp1, pp2;
		int f = 0;
		//t.print();
		for(int j = 0; j < 3; j++){
			pair<int,Point> p1 = t ^ l[j];
			if(p1.se.x >= min(p[j].x, p[(j+1)%n].x) && p1.se.x <= max(p[j].x, p[(j+1)%n].x) && 
				p1.se.y >= min(p[j].y, p[(j+1)%n].y) && p1.se.y <= max(p[j].y, p[(j+1)%n].y)){
				if(p1.fi == 1){
					if(p[j].x < p[(j+1)%n].x){
						pp1 = p[j];
						pp2 = p[(j+1)%n];
					}else{
						pp1 = p[(j+1)%n];
						pp2 = p[j];
					}	
					f = 2;
					break;
				}
				if(p1.fi == 0){
					if(!f){
						pp1 = p1.se;
						f++;
					}
					else{
						pp2 = p1.se;
						if(pp2.x < pp1.x)swap(pp1, pp2);
						f++;
					}
				}
			} 
		}
		if(f == 0)break;
		pp1.x = ceil(pp1.x);
		pp2.x = floor(pp2.x);
		ll nach = pp1.x + i+1, kon = pp2.x + i+1;
		nach = max(1ll, nach);
		kon = max(1ll, kon);
		//cout<<i<<": "<<nach<<" "<<kon<<"|"<<c(i+1, kon+1+i-1)<<" "<<c(i+1, nach+i-1)<<endl;
		ll summ = c(i+1, kon+1+i-1)- c(i+1, nach+i-1);
		sum = (summ + sum)%mod;
		if(summ == 0)break;
		t.C -= 2;
	}
	cout<<sum<<endl;
}

int main(){
	srand(time(NULL));
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	fact[0] = afact[0] = 1;
	for(int i = 1; i < (5e6+10); i++){
		fact[i] = (fact[i-1] * i)%mod;
	}
	for(int i = 1; i < (5e6+10); i++){
		afact[i] = binpow(fact[i], mod - 2);
	}
	#ifdef LOCAL
	freopen("in","r",stdin);
	freopen("out","w",stdout);
	#endif
	int t;
	t = 1;
	cin >> t;
	for(int i =0;i < t;i++)
		solve(i+1);
	return 0;
}