#include <iostream>
#include <fstream>
#include <map>
#include <set>
#include <vector>
#include <string>
#include <algorithm>
#include <list>
#include <tuple>
#include <deque>
#include <iomanip>
#include <cmath>
#include <unordered_map>
#include <queue>
#include <unordered_set>

typedef long long ll;
typedef long double ld;
using namespace std;

map<int, char> digits;
map<char, int> chars;

struct node
{
	node(int ind, int v) : index(ind), val(v), left_sub(0), right_sub(0), left_child(nullptr), right_child(nullptr), visited(false)
	{}
	int index;
	int val;
	int left_sub;
	int right_sub;
	node* left_child;
	node* right_child;
	bool visited;

	void insert(node* other)
	{
		int diff = left_sub - right_sub;
		if (diff == 0)
		{
			left_sub += other->val;
			if (left_child == nullptr)
				left_child = other;
			else
				left_child->insert(other);
		}
		else
		{
			right_sub += other->val;
			if (right_child == nullptr)
				right_child = other;
			else
				right_child->insert(other);
		}
	}

	bool is_valid()
	{
		if (left_sub - right_sub > 1)
			return false;
		bool a = true, b = true;
		if (left_child != nullptr)
		{
			a = left_child->is_valid();
		}
		if (right_child != nullptr)
		{
			b = right_child->is_valid();
		}
		return a && b;
	}

	void print()
	{
		//cout << index << " ";
		cout << val << " ";
		if (left_child != nullptr)
		{
			cout << left_child->index << " ";
		}
		else
		{
			cout << 0 << " ";
		}
		if (right_child != nullptr)
		{
			cout << right_child->index << " ";
		}
		else
		{
			cout << 0 << " ";
		}
		cout << endl;
		/*cout << endl;
		if (left_child != nullptr)
			left_child->print();
		if (right_child != nullptr)
			right_child->print();*/
	}
	void get_tree(vector<node>& v)
	{
		v.push_back(*this);
		if (this->left_child != nullptr)
			left_child->get_tree(v);
		if (this->right_child != nullptr)
			right_child->get_tree(v);
	}
	bool operator <(const node& other)
	{
		return this->index < other.index;
	}
};

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int a, b;
	cin >> a >> b;

	int index = 1;
	if (b == 0)
	{
		node* root = new node(index, 1);
		for (int i = 1; i < a; ++i)
		{
			++index;
			node* other = new node(index, 1);
			root->insert(other);
		}
		if (root->is_valid())
		{
			vector<node> v;
			root->get_tree(v);
			sort(v.begin(), v.end());
			for (int i = 0; i < v.size(); ++i)
				v[i].print();
			//root->print();
		}
		else
			cout << -1 << endl;
	}
	else
	{
		node* root = new node(index, 2);
		for (int i = 1; i < b; ++i)
		{
			++index;
			node* other = new node(index, 2);
			root->insert(other);
		}
		for (int i = 0; i < a; ++i)
		{
			++index;
			node* other = new node(index, 1);
			root->insert(other);
		}
		if (root->is_valid())
		{
			vector<node> v;
			root->get_tree(v);
			sort(v.begin(), v.end());
			for (int i = 0; i < v.size(); ++i)
				v[i].print();
		}
		else
			cout << -1 << endl;
	}
	return 0;

}