#define _CRT_SECURE_NO_WARNINGS
#include <iostream>  
#include <functional>
#include <math.h>
#include <vector>
#include <stack>
#include <string>
#include <algorithm>	
#include <iomanip>
#include <set>
#include <map>
#include <queue>
#include <stdint.h>

#pragma comment(linker, "/STACK:255999999")	
typedef long long ll;
typedef long double ld;
using namespace std;
const ll mod = 1e+9 + 7;
string reverse(string &s) {
  string ans = "";
  for (int i = s.size() - 1; i >= 0; i--) {
    ans += s[i];
  }
  return ans;
}
int convert(char a) {
  return a - '0';
}
string unite(string &s1, string &s2) {
  string ans = "", s2rev = reverse(s2);
  ans += s2;
  for (int i = 0; i < s1.size(); i++) {
    ans += s1[i];
    if (i % 2 == 0)
      ans += s2rev;
    else
      ans += s2;
  }
  return ans;
}

string colorTree(vector<set<int>> &tree, int root) {
  if (tree[root].size() == 0) {
    return "";
  }
  else {
    multimap<int, string, greater<>> child;
    for (auto it = tree[root].begin(); it != tree[root].end(); it++) {
      string s;
      s += (*it+'1');
      s += colorTree(tree, *it);
      child.insert({ s.size(), s });
    }
    auto it = child.begin();
    string ans = it->second;
    it++;
    for (; it != child.end(); it++) {
      ans = unite(ans, it->second);
    }
    return ans;
  }
}

int main() {
  cin.tie(0);
  ios_base::sync_with_stdio(0);
  cout << fixed << setprecision(10);
  //freopen("input.txt", "r", stdin);
  //freopen("output.txt", "w", stdout);
  int n, t;
  cin >> n;
  vector<set<int>> tree(n);
  for (int i = 1; i < n; i++) {
    cin >> t;
    tree[t-1].insert(i);
  }
  string ans = "";
  ans += colorTree(tree, 0);
  cout << ans.size()<<'\n';
  for (int i = 0; i < ans.size(); i++) {
    if (i>0)
    if (ans[i] == ans[i - 1])
      continue;
    cout << ans[i]-'0' << ' ';
  }
}