#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const double eps = 1e-7;

void solve() {
    int n;
    cin >> n;
    vector<string> stairs(n);
    for (int i = 0; i < n; i++)
        cin >> stairs[i];
	
    vector<vector<int>> g(n);
    for (int i = 0; i < n; i++) {
        for (int j = 1; j <= 8; j++) {
            if (i - j < 0)
                continue;
            int x = 0;
            for (int k = 0; k < 8; k++)
                if (stairs[i][k] == stairs[i - j][k])
                    x++;
            if (j <= x)
                g[i].push_back(i - j);
        }
    }
	/*
	for (int i = 0; i < n; ++i) {
		cout << i + 1 << ": ";
		for (int v : g[i]) {
			cout << v + 1 << " ";
		}
		cout << "\n";
	}
	*/
	vector<bool> ans(n);
	ans[0] = true;
	for (int v = 1; v < n; v++) {
		bool win = false;
		for (int to : g[v])
			win |= ans[to];
		ans[v] = !win;
	}
	
    for (int i = 0; i < n; i++)
        cout << (ans[i] ? 1 : 2);
	cout << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i)
        solve();
    return 0;
}