import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.util.TreeMap;

public class M {
    static StringTokenizer st;
    static BufferedReader br;
    static PrintWriter pw;

    static String nextToken() {
        try {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(br.readLine());
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return st.nextToken();
    }

    static int nextInt() {
        return Integer.parseInt(nextToken());
    }

    static double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    static long nextLong() {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        run();
        pw.close();
    }

    private static void run() {
        int n = nextInt();
        int[][] a = new int[n][];

        for (int i = 0; i < n; i++) {
            int k = nextInt();
            a[i] = new int[k];
            for (int j = 0; j < k; j++) {
                a[i][j] = nextInt();
            }
        }
        TreeMap<Integer, Integer> map = new TreeMap<>();
        int ans = 0;
        for (int i = n - 1; i >= 0; i--) {
            int max = 0;
            for (int j = 0; j < a[i].length; j++) {
                if (!map.containsKey(a[i][j])) {
                    map.put(a[i][j], 0);
                }
                max = Math.max(max, map.get(a[i][j]));
            }
            max++;
            for (int j = 0; j < a[i].length; j++) {
                map.put(a[i][j], max);
            }
            ans = Math.max(ans, max);
        }
        pw.println(ans);
    }
}
