#include <bits/stdc++.h>

//define/typeDef
#define all(a) a.begin(), a.end()
#define double long double
#define int long long
#define NIL 0
#define INF LLONG_MAX
#define loop(n) for(int i=0;i<n; i++)
#define rloop(n) for(int i=n-1; i>=0; i--)
using namespace std;

const int N = 2e5 + 50;

map<pair<int, int>, int> memoize;
int w[N];
int l[N];
int r[N];
int nxt = 1;

pair<pair<int, int>, pair<int, int> > getTransition(int a, int b) {
    pair<int, int> left = {-1, -1};
    pair<int, int> right = {-1, -1};

    if (a % 2 == 0 && b % 2 == 0) {
        left = right = {a / 2, b / 2};
    }
    if (a % 2 == 0 && b % 2 != 0) {
        if (a > 0) {
            left = {a / 2 + 1, (b - 1) / 2};
            right = {a / 2 - 1, (b + 1) / 2};
        }
    }
    if (a % 2 != 0 && b % 2 == 0) {
        left = {(a - 1) / 2, b / 2};
        right = {(a + 1) / 2, b / 2};
    }
    if (a % 2 != 0 && b % 2 != 0) {
        if (a >= 3) {
            left = {(a - 1) / 2 + 2, (b - 1) / 2};
            right = {(a + 1) / 2 - 2, (b + 1) / 2};
        }
    }
    return make_pair(left, right);


}

bool restore(int node, int a, int b) {
    if (a == 0 && b == 0)
        return false;
    if (a == 1 && b == 0) {
        w[node] = 1;
        return true;
    }
    if (b == 1 && a == 0) {
        w[node] = 2;
        return true;
    }
    w[node] = memoize[make_pair(a, b)];
    if (w[node] == 1) {
        a--;
        pair<pair<int, int>, pair<int, int> > next = getTransition(a, b);

        l[node] = ++nxt;
        if (!restore(nxt, next.first.first, next.first.second))
            nxt--, l[node] = 0;
        r[node] = ++nxt;
        if (!restore(nxt, next.second.first, next.second.second))
            nxt--, r[node]=0;

    } else {
        b--;
        pair<pair<int, int>, pair<int, int> > next = getTransition(a, b);
        l[node] = ++nxt;
        if (!restore(nxt, next.first.first, next.first.second))
            nxt--, l[node] = 0;
        r[node] = ++nxt;
        if (!restore(nxt, next.second.first, next.second.second))
            nxt--, r[node]=0;

    }
    return true;
}


bool solve(int a, int b) {

    if (a == 0 && b == 0) {
        return true;
    }
    if (a == 1 && b == 0) {
        memoize[make_pair(a, b)] = 1;
        return true;
    }
    if (b == 1 && a == 0) {
        memoize[make_pair(a, b)] = 2;
        return true;
    }
    if (memoize.count(make_pair(a, b)) && memoize[make_pair(a, b)] != 0)
        return true;

    if (a > 0) {
        a--;
        pair<pair<int, int>, pair<int, int> > next = getTransition(a, b);
        if (next.first.first != -1
            && solve(next.first.first, next.first.second)
            && solve(next.second.first, next.second.second)) {
            memoize[make_pair(a + 1, b)] = 1;
            return true;
        }
        a++;
    }
    if (b > 0) {
        b--;
        pair<pair<int, int>, pair<int, int> > next = getTransition(a, b);
        if (next.first.first != -1
            && solve(next.first.first, next.first.second)
            && solve(next.second.first, next.second.second)) {

            memoize[make_pair(a, b + 1)] = 2;
            return true;
        }
        b++;
    }

    memoize[make_pair(a, b)] = 0;
    return false;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int a, b;
    cin >> a >> b;

    if (!solve(a, b))
        return cout << -1, 0;

    restore(1, a, b);

    for (int i = 1; i <= a + b; i++) {
        cout << w[i] << ' ' << l[i] << ' ' << r[i] << '\n';
    }
}