#include <iostream>
#include <iomanip>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <cassert>
#include <queue>
#include <array>
#include <cmath>
#include <cstring>
#include <random>
#include <stack>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define vec vector
#define all(a) (a).begin(), (a).end()
#define ll long long
#define pi pair<ll, pair<ll, ll>>
#define x first
#define y second
#define pii pair<ll, ll>
#define pdd pair<double, double>
#define pb push_back
#define mp make_pair
#define ld long double
#define pll pair<ld, ld>
#define sz(a) (int)(a.size())
#define ptt pair<pair<ld, ld>, ld>
#define pt pair<ld, ld>


template <class A, class B> ostream& operator << (ostream& out, const pair<A, B>& a) {
	return out << "(" << a.x << ", " << a.y << ")";
}
 
template <class A> ostream& operator << (ostream& out, const vector<A>& v) {
	out << "[";
	forn(i, sz(v)) {
		if (i) out << ", ";
		out << v[i];
	}
	return out << "]";
}
 
mt19937 rnd(time(NULL));

const ll INF2 = 2e18;
const ll INF = 1e9 + 7;
const long double EPS = 1e-12;
ld PI = 3.14159265358979323846264;
// const int MOD = 1e9 + 7;
int MOD = 998244353;


struct node {
    int lf = -1;
    int rg = -1;
    int w;

    node(int w): w(w){};
    node(){};
};

vec<node> tree(100100);
int t = 0;
int a, b;

void add_node2(node &nd){
    if (nd.lf == -1){
        node new_nd = node(2);
        tree[t] = new_nd;
        nd.lf = t;
        t++;
        b--;
    }
    else if (nd.rg == -1){
        node new_nd = node(2);
        tree[t] = new_nd;
        nd.rg = t;
        t++;
        b--;
    }
}

void add_node1(node& nd){
    node new_nd = node(1);
    tree[t] = new_nd;
    
    if (nd.lf == -1){
        nd.lf = t;
        t++;
        a--;
    }
    else if (nd.rg == -1){
        nd.rg = t;
        t++;
        a--;
    }
}

void add_node1_2(node& nd){
    node new_nd = node(1);
    tree[t] = new_nd;
    
    if (nd.rg == -1){
        nd.rg = t;
        t++;
        a--;
    }
    else if (nd.lf == -1){
        nd.lf = t;
        t++;
        a--;
    }
}

vec<int> last_level_poses;

void build_lvl(vec<int> last_lvl){
    if (last_lvl.size() == 0){
        node nd = node(2);
        tree[t] = nd;
        t++;
        b--;
        return;
    }
    else{
        for(int idx : last_lvl){
            if (b == 0){
                break;
            }
            add_node2(tree[idx]);
        }

        for(int idx : last_lvl){
            if (b == 0){
                break;
            }
            add_node2(tree[idx]);
        }

    }
}

void build_lvl_back(vec<int> last_lvl){
    if (!a){
        return;
    }

    if (last_lvl.size() == 0){
        node nd = node(1);
        tree[t] = nd;
        t++;
        a--;
        return;
    }
    else{
        for(int idx : last_lvl){
            if (idx < 0){
                continue;
            }
            if (a == 0){
                break;
            }
            add_node1_2(tree[idx]);
        }

        for(int idx : last_lvl){
            if (idx < 0){
                continue;
            }
            if (a == 0){
                break;
            }
            add_node1_2(tree[idx]);
        }
    }
}

vec<int> prev_last_lvl;

vec<int> build(){
    int last_lvl_size = 0;
    vec<int> last_lvl;

    int expt = 0;

    while (b){
        last_lvl = vec<int>(last_lvl_size);
        for (int i = 0; i < last_lvl_size; i++){
            last_lvl[i] = t - (last_lvl_size - i);
        }

        build_lvl(last_lvl);
        if (last_lvl_size == 0){
            last_lvl_size = 1;
            expt = 1;
            continue;
        }
        last_lvl_size *= 2;
        expt += last_lvl_size;
    }

    if (t == expt){
        // cout << t << "  A  " << expt << endl;
        last_lvl = vec<int>(last_lvl_size);
        for (int i = 0; i < last_lvl_size; i++){
            last_lvl[i] = t - (last_lvl_size - i);
        }
    }

    return last_lvl;
}

vec<int> traverse(){
    if (t == 0){
        return vec<int>();
    }

    int root = 0;

    vec<int> res;

    queue<int> q;
    vec<int> used(t);
    q.push(root);
    used[root] = 1;
    res.push_back(root);

    while(!q.empty()){
        int cur = q.front();
        q.pop();

        node& nd = tree[cur];
        if (nd.lf != -1){
            q.push(nd.lf);
            used[nd.lf] = 1;
            res.push_back(nd.lf);
        }
        if (nd.rg != -1){
            q.push(nd.rg);
            used[nd.rg] = 1;
            res.push_back(nd.rg);
        }
    }

    return res;
}


void print_tree(){
    // vec<int> idxs = traverse();
    for (int i = 0; i < t; i++){

    // for (int i : idxs){
        node nd = tree[i];
        cout << nd.w << " " << nd.lf + 1 << " " << nd.rg + 1 << endl;
    }
}


vec<int> mas(100100, 0);

bool is_ok = true;

int dfs(int v){
    node nd = tree[v];
    
    int lf_mas = 0;
    int rg_mas = 0;
    if (nd.lf != -1){
        lf_mas = dfs(nd.lf);
    }
    if (nd.rg != -1){
        rg_mas = dfs(nd.rg);
    }
    
    if (abs(lf_mas - rg_mas) > 1){
        is_ok = false;
    }
    
    mas[v] = lf_mas + rg_mas + nd.w;
    return mas[v];
}

bool check_tree(){
    dfs(0);
    return is_ok;
}

int main(){
#ifdef _DEBUG
    freopen("caravan.in", "r", stdin);
    freopen("caravan.out", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> a >> b;

    // step 1
    vec<int> last_lvl = build();

    // step 2
    vec<int> my_tree = traverse();

    int lvl = 0;
    int num = 1;
    
    int i = 0;
    while (1){
        if (i + num <= t){
            i += num;
            num *= 2;
        }
        else{
            break;
        }
    }

    int lst = i;
    i -= (num / 2);

    vec<int> last_full_lvl;
    for (int j = i; j < lst; j++){
        last_full_lvl.push_back(my_tree[j]);
    }

    int added = 0;
    if (lst != t){
        added = 1;
        for (int idx : last_full_lvl){
            if (a == 0){
                break;
            }
            add_node1(tree[idx]);
        }

        for (int idx : last_full_lvl){
            if (a == 0){
                break;
            }
            add_node1(tree[idx]);
        }
    }

    // print_tree();
    // cout << last_lvl << endl;
    // step 3
    
    if (added){
        vec<int> new_last_lvl;

        for (int i : last_lvl){
            node nd = tree[i];
            new_last_lvl.push_back(nd.lf);
        }

        for (int i : last_lvl){
            node nd = tree[i];
            new_last_lvl.push_back(nd.rg);
        }
        last_lvl = new_last_lvl;
    }

    int last_lvl_size = last_lvl.size();
    reverse(all(last_lvl));

    // cout << last_lvl_size << endl;
    while (a){
        build_lvl_back(last_lvl);
        if (last_lvl_size == 0){
            last_lvl_size = 1;
            last_lvl = vec<int>(last_lvl_size);
            for (int i = 0; i < last_lvl_size; i++){
                last_lvl[i] = t - (last_lvl_size - i);
            }
            continue;
        }

        last_lvl_size *= 2;
        
        last_lvl = vec<int>(last_lvl_size);
        for (int i = 0; i < last_lvl_size; i++){
            last_lvl[i] = t - (last_lvl_size - i);
        }
    }

    if (check_tree()){
        print_tree();
    }
    else{
        cout << -1 << endl;
    }

}
