#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")

#include <algorithm>
#include <cmath>
#include <functional>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <vector>
#include <random>

using namespace std;

using LL = long long;
using pii = pair<int, int>;

#define X first
#define Y second

void cerr_printer(bool start) {}
template<typename T, typename ... Args>
void cerr_printer(bool start, const T& x, const Args& ... args) {
    if (!start) cerr << ", ";
    cerr << x;
    cerr_printer(false, args...);
}

template<typename ... Args>
void dbg(const char * name, int line, const Args& ... args) {
    cerr << "[" << line << "] (" << name << ") = (";
    cerr_printer(true, args...);
    cerr << ")" << endl;
}

#define DBG(...) { dbg(#__VA_ARGS__, __LINE__, __VA_ARGS__); }

int bn(int b) {
    if (b == 0) {
        return 0;
    }
    int res = 0;
    while (1 << res <= b) {
        res += 1;
    }

    return res;
}

const int MAX = 4e5 + 200;
int clr[MAX];
int num[MAX];

void solve() {
    int a, b;
    cin >> a >> b;

    if ((1 << bn(b)) - 1 > a + b) {
        cout << -1 << endl;
        return;
    }

    int cols = bn(a + b);

    for (int i = 0; i < cols; ++i) {
        int fl = 1 << i;

        if (b) {
            int color = 1;
            if ((b >> i) & 1) {
                color = 2;
                b -= fl;
            } else {
                a -= fl;
            }
            for (int j = 0; j < fl; ++j) {
                clr[fl + j] = color;
            }
            continue;
        }

        for (int step = 0; step < fl && a > 0; ++step) {
            int cur = 0;
            for (int j = 0; j < i && a > 0; ++j) {
                if ((step >> j) & 1) {
                    cur += 1 << (i - 1 - j);
                }
            }

            --a;
            clr[fl + cur] = 1;
        }
    }

    int cs = 0;
    for (int i = 1; i < MAX; ++i) {
        if (clr[i]) {
            ++cs;
            num[i] = cs;
        }
    }

    for (int i = 1; i < MAX; ++i) {
        if (clr[i] == 0) {
            continue;
        }
        int left = i * 2;
        int right = i * 2 + 1;
        cout << clr[i] << ' ';
        if (clr[left]) {
            cout << num[left] << ' ';
        } else {
            cout << 0 << ' ';
        }
        if (clr[right]) {
            cout << num[right] << ' ';
        } else {
            cout << 0 << ' ';
        }
        cout << endl;
    }
}

void fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int main() {
    fast();
    //gen();
    //freopen("file.txt", "r", stdin);

    //clock_t start = clock();
    int k = 1;
    //cin >> k;
    while (k-- > 0) {
        solve();
    }
    //clock_t end = clock();
    //double seconds = (double)(end - start) / CLOCKS_PER_SEC;
    //printf("The time: %f seconds\n", seconds);
}