#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")

#include <algorithm>
#include <cmath>
#include <functional>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <vector>
#include <random>

using namespace std;

using LL = long long;
using pii = pair<int, int>;

#define X first
#define Y second

void cerr_printer(bool start) {}
template<typename T, typename ... Args>
void cerr_printer(bool start, const T& x, const Args& ... args) {
    if (!start) cerr << ", ";
    cerr << x;
    cerr_printer(false, args...);
}

template<typename ... Args>
void dbg(const char * name, int line, const Args& ... args) {
    cerr << "[" << line << "] (" << name << ") = (";
    cerr_printer(true, args...);
    cerr << ")" << endl;
}

#define DBG(...) { dbg(#__VA_ARGS__, __LINE__, __VA_ARGS__); }

void solve() {
    int n;
    cin >> n;

    int k;
    const int MAX = 1e5 + 1;

    vector<int> mass(MAX);
    for (int i = 0; i < n; ++i) {
        cin >> k;

        int mx = 0;
        vector<int> x(k);
        for (auto &it : x) {
            cin >> it;
            mx = max(mx, mass[it]);
        }

        for (auto it : x) {
            mass[it] = mx + 1;
        }
    }

    int res = 0;

    for (int i = 0; i < mass.size(); ++i) {
        res = max(res, mass[i]);
    }
    cout << res << endl;
}

void fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int main() {
    fast();
    //gen();
    //freopen("file.txt", "r", stdin);

    //clock_t start = clock();
    int k = 1;
    //cin >> k;
    while (k-- > 0) {
        solve();
    }
    //clock_t end = clock();
    //double seconds = (double)(end - start) / CLOCKS_PER_SEC;
    //printf("The time: %f seconds\n", seconds);
}