//#pragma GCC optimize("O3")
//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <random>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;
//#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)

mt19937 rnd(239);

const int MOD = 1e9 + 7;
const int BIG = 1e9 + 239;

inline int sum_mod(int a, int b) {
    if (a + b >= MOD) {
        return a + b - MOD;
    }
    return a + b;
}

inline int sum(int a, int b, int p) {
    if (a + b >= p) {
        return a + b - p;
    }
    return a + b;
}

inline int sub_mod(int a, int b) {
    if (a < b) {
        return a - b + MOD;
    }
    return a - b;
}

inline int sub(int a, int b, int p) {
    if (a < b) {
        return a - b + p;
    }
    return a - b;
}

inline int mul_mod(int a, int b) {
    return 1LL * a * b % MOD;
}

inline int mul(int a, int b, int p) {
    return 1LL * a * b % p;
}

inline int power_mod(int a, int k) {
    if (k == 0) {
        return 1;
    }
    int t = power_mod(a, k >> 1);
    t = mul_mod(t, t);
    if (k & 1) {
        t = mul_mod(t, a);
    }
    return t;
}

inline int power(int a, int k, int p) {
    if (k == 0) {
        return 1;
    }
    int t = power(a, k >> 1, p);
    t = mul(t, t, p);
    if (k & 1) {
        t = mul(t, a, p);
    }
    return t;
}

const int M = 6e5 + 239;
const int X = 1e6 + 239;

ll f[M];
ll a, b, c, n;
int ans;

bool is_prime[X];

int f1, f0, p;

inline pair<int, int> mul(pair<int, int> x, pair<int, int> y) {
    int r1 = sum(mul(x.second, y.first, p), mul(y.second, x.first, p), p);
    int r0 = mul(x.second, y.second, p);
    int ml = mul(x.first, y.first, p);
    r0 = sum(r0, mul(ml, f0, p), p);
    r1 = sum(r1, mul(ml, f1, p), p);
    return make_pair(r1, r0);
}

inline pair<int, int> power(pair<int, int> x, int k) {
    if (k == 1) {
        return x;
    }
    pair<int, int> t = power(x, k >> 1);
    t = mul(t, t);
    if (k & 1) {
        t = mul(t, x);
    }
    return t;
}

inline int get_cnt(int p) {
    int ca = a % p;
    int cb = b % p;
    int cc = c % p;
    if (ca == 0 && cb == 0 && cc != 0) {
        return 0;
    }
    if (p == 2 || (ca == 0 && cb == 0)) {
        int ans = 0;
        for (int i = 0; i < n; i++) {
            while (f[i] % (ll)p == 0) {
                f[i] /= (ll)p;
                ans++;
            }
        }
        return ans;
    }
    if (ca == 0) {
        int need = mul(sub(0, cc, p), power(cb, p - 2, p), p);
        int ans = 0;
        for (int i = need; i < n; i += p) {
            while (f[i] % (ll)p == 0) {
                f[i] /= (ll)p;
                ans++;
            }
        }
        return ans;
    }
    f1 = mul(sub(0, cb, p), power(ca, p - 2, p), p);
    f0 = mul(sub(0, cc, p), power(ca, p - 2, p), p);
    int dd = sum(mul(f1, f1, p), mul(4, f0, p), p);
    if (dd != 0 && power(dd, (p - 1) / 2, p) != 1) {
        return 0;
    }
    ::p = p;
    int some = -1;
    while (true) {
        int add = rnd() % p;
        pair<int, int> cur = power(make_pair(1, add), (p - 1) / 2);
        cur.second = sub(cur.second, 1, p);
        if (cur.first != 0) {
            some = mul(sub(0, cur.second, p), power(cur.first, p - 2, p), p);
            if (mul(some, some, p) == sum(mul(some, f1, p), f0, p)) {
                break;
            }
        }
    }
    if (some == -1) {
        return 0;
    }
    int other = sub(f1, some, p);
    int ans = 0;
    for (int i = some; i < n; i += p) {
        while (f[i] % (ll)p == 0) {
            f[i] /= (ll)p;
            ans++;
        }
    }
    if (other != some) {
        for (int i = other; i < n; i += p) {
            while (f[i] % (ll)p == 0) {
                f[i] /= (ll)p;
                ans++;
            }
        }
    }
    return ans;
}

inline void upd(int p) {
    int cnt = get_cnt(p);
    for (int i = 0; i < (cnt / 2); i++) {
        ans = mul_mod(ans, p);
    }
}

inline ll mult(ll a, ll b, ll m) {
    ll x = (ld)a * (ld)b / (ld)m;
    x = a * b - x * m;
    x %= m;
    if (x < 0) {
        x += m;
    }
    return x;
}

inline ll sumt(ll a, ll b, ll p) {
    if (a + b >= p) {
        return a + b - p;
    }
    return a + b;
}

inline ll subt(ll a, ll b, ll p) {
    if (a < b) {
        return a - b + p;
    }
    return a - b;
}

inline ll powert(ll a, ll k, ll p) {
    if (k == 0) {
        return 1;
    }
    ll t = powert(a, k >> 1LL, p);
    t = mult(t, t, p);
    if (k & 1LL) {
        t = mult(t, a, p);
    }
    return t;
}

ll lf0, lf1, lp;

inline pair<ll, ll> mult(pair<ll, ll> x, pair<ll, ll> y) {
    ll r1 = sumt(mult(x.second, y.first, lp), mult(y.second, x.first, lp), lp);
    ll r0 = mult(x.second, y.second, lp);
    ll ml = mult(x.first, y.first, lp);
    r0 = sumt(r0, mult(ml, lf0, lp), lp);
    r1 = sumt(r1, mult(ml, lf1, lp), lp);
    return make_pair(r1, r0);
}

inline pair<ll, ll> powert(pair<ll, ll> x, ll k) {
    if (k == 1) {
        return x;
    }
    pair<ll, ll> t = powert(x, k >> 1LL);
    t = mult(t, t);
    if (k & 1LL) {
        t = mult(t, x);
    }
    return t;
}

inline int get_cnt_ll(ll p) {
    lf1 = mult(subt(0, b, p), powert(a, p - 2, p), p);
    lf0 = mult(subt(0, c, p), powert(a, p - 2, p), p);
    ll dd = sumt(mult(lf1, lf1, p), mult(4LL, lf0, p), p);
    if (dd != 0 && powert(dd, (p - 1) / 2LL, p) != 1) {
        return 0;
    }
    ::lp = p;
    ll some = -1;
    while (true) {
        ll add = rnd() % p;
        pair<ll, ll> cur = powert(make_pair(1, add), (p - 1) / 2);
        cur.second = subt(cur.second, 1, p);
        if (cur.first != 0) {
            some = mult(subt(0, cur.second, p), powert(cur.first, p - 2, p), p);
            if (mult(some, some, p) == sumt(mult(some, lf1, p), lf0, p)) {
                break;
            }
        }
    }
    if (some == -1) {
        return 0;
    }
    ll other = subt(lf1, some, p);
    int ans = 0;
    for (ll i = some; i < n; i += p) {
        while (f[i] % (ll)p == 0) {
            f[i] /= (ll)p;
            ans++;
        }
    }
    if (other != some) {
        for (ll i = other; i < n; i += p) {
            while (f[i] % (ll)p == 0) {
                f[i] /= (ll)p;
                ans++;
            }
        }
    }
    return ans;
}

inline void upd_ll(ll p) {
    int cnt = get_cnt_ll(p);
    for (int i = 0; i < (cnt / 2); i++) {
        ans = mul_mod(ans, (p % (ll)MOD));
    }
}

map<ll, int> cnt;

inline void upd_poll(ll x) {
    ll t = (ll)sqrtl(x);
    while (t * t <= x) {
        t++;
    }
    while (t * t > x) {
        t--;
    }
    if (t * t == x) {
        cnt[t] += 2;
        return;
    }
}

ll r[M + M];

inline void upd_r(int p) {
    int ca = a % p;
    int cb = b % p;
    if (ca == 0 && cb == 0) {
        for (int i = 0; i < 2 * n; i++) {
            while (r[i] % (ll)p == 0) {
                r[i] /= (ll)p;
            }
        }
        return;
    }
    if (ca == 0) {
        return;
    }
    int need = mul(sub(0, cb, p), power(ca, p - 2, p), p);
    for (int i = need; i < 2 * n; i += p) {
        while (r[i] % (ll)p == 0) {
            r[i] /= (ll)p;
        }
    }
}

int main() {
#ifdef ONPC
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> a >> b >> c >> n;
    for (ll i = 0; i < 2 * n; i++) {
        r[i] = a * i + b;
    }
    for (ll i = 0; i < n; i++) {
        f[i] = a * i * i + b * i + c;
    }
    for (int i = 2; i < X; i++) {
        is_prime[i] = true;
    }
    for (int i = 2; i * i <= X; i++) {
        if (is_prime[i]) {
            for (int j = i + i; j < X; j += i) {
                is_prime[j] = false;
            }
        }
    }
    ans = 1;
    for (int i = 2; i < X; i++) {
        if (is_prime[i]) {
            upd_r(i);
            upd(i);
        }
    }
    set<ll> was;
    for (int i = 2; i < 2 * n; i++) {
        if (r[i] > 1 && r[i] < BIG && was.find(r[i]) == was.end()) {
            upd(r[i]);
            was.insert(r[i]);
        } else if (r[i] > 1 && was.find(r[i]) == was.end()) {
            upd_ll(r[i]);
            was.insert(r[i]);
        }
    }
    int bad = 0;
    for (int i = 0; i < n; i++) {
        if (f[i] > 1) {
            bad++;
            upd_poll(f[i]);
        }
    }
    for (const auto& t : cnt) {
        for (int i = 0; i < (t.second / 2); i++) {
            ans = mul_mod(ans, (t.first % MOD));
        }
    }
    cout << mul_mod(ans, ans) << "\n";
    //cerr << TIME << "\n";
    return 0;
}
