/*
    author:  Maksim1744
    created: 13.12.2020 10:25:17
*/

#include "bits/stdc++.h"
using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
// find_by_order, order_of_key


#define ll   long long
#define ld   long double

#define mp   make_pair
#define pb   push_back
#define eb   emplace_back

#define sum(a)     ( accumulate ((a).begin(), (a).end(), 0ll))
#define mine(a)    (*min_element((a).begin(), (a).end()))
#define maxe(a)    (*max_element((a).begin(), (a).end()))
#define mini(a)    ( min_element((a).begin(), (a).end()) - (a).begin())
#define maxi(a)    ( max_element((a).begin(), (a).end()) - (a).begin())
#define lowb(a, x) ( lower_bound((a).begin(), (a).end(), (x)) - (a).begin())
#define uppb(a, x) ( upper_bound((a).begin(), (a).end(), (x)) - (a).begin())

template<typename T>             vector<T>& operator--            (vector<T>& v){for (auto& i : v) --i;            return  v;}
template<typename T>             vector<T>& operator++            (vector<T>& v){for (auto& i : v) ++i;            return  v;}
template<typename T>             istream& operator>>(istream& is,  vector<T>& v){for (auto& i : v) is >> i;        return is;}
template<typename T>             ostream& operator<<(ostream& os,  vector<T>& v){for (auto& i : v) os << i << ' '; return os;}
template<typename T, typename U> istream& operator>>(istream& is, pair<T, U>& p){is >> p.first >> p.second;        return is;}
template<typename T, typename U> ostream& operator<<(ostream& os, pair<T, U>& p){os << p.first << ' ' << p.second; return os;}
template<typename T, typename U> pair<T,U> operator-(pair<T,U> a, pair<T,U> b){return mp(a.first-b.first, a.second-b.second);}
template<typename T, typename U> pair<T,U> operator+(pair<T,U> a, pair<T,U> b){return mp(a.first+b.first, a.second+b.second);}
template<typename T, typename U> void umin(T& a, U b){if (a > b) a = b;}
template<typename T, typename U> void umax(T& a, U b){if (a < b) a = b;}

#ifdef HOME
#define TAG_LENGTH       25
#define LR_LEFT          left
#define LR_RIGHT         right
#define LR_VALUE         value
#define LR_SECOND_VALUE  mn
#include "C:/C++ libs/print.cpp"
#else
#define showl            42;
#define shows            42;
#define show(...)        42;
#define showm(...)       42;
#define showt(...)       42;
#define printTree(...)   42;
#define printGraph(...)  42;
#define printLRTree(...) 42;
#define printMatrix(...) 42;
#define printWGraph(...) 42;
#define debug     if (false)
#endif

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;
    vector<int> L(n), R(n), v(n);
    for (int i = 0; i < n; ++i) {
        cin >> L[i] >> R[i] >> v[i];
        --L[i]; --R[i];
    }
    int q;
    cin >> q;
    vector<pair<pair<int, int>, int>> que(q);
    for (int i = 0; i < q; ++i) {
        cin >> que[i].first;
        que[i].second = i;
    }

    vector<int> ans(q, 0);

    vector<pair<int, int>> segs;
    vector<int> mn(n), mx(n);
    for (int i = 0; i < n; ++i) {
        mn[i] = mx[i] = v[i];
    }

    function<void(int)> dfs1 = [&](int v) {
        if (v == -1) return;
        dfs1(L[v]);
        dfs1(R[v]);
        if (L[v] != -1) mn[v] = mn[L[v]];
        if (R[v] != -1) mx[v] = mx[R[v]];
    };
    dfs1(0);

    function<void(int, int, int)> dfs2 = [&](int v, int pl, int pr) {
        if (v != 0) {
            segs.eb(pl, pr);
        }
        if (v == -1) return;
        dfs2(L[v], mn[v], mx[v]);
        dfs2(R[v], mn[v], mx[v]);
    };
    dfs2(0, -1, -1);

    ordered_set<pair<int, int>> ls, rs;
    for (int i = 0; i < segs.size(); ++i) {
        ls.insert({segs[i].first, i});
        rs.insert({segs[i].second, i});
    }

    for (int i = 0; i < q; ++i) {
        ans[i] = segs.size();
        ans[i] -= ((int)ls.size() - ls.order_of_key({que[i].first.second + 1, -1}));
        ans[i] -= rs.order_of_key({que[i].first.first, -1});
    }

    sort(que.begin(), que.end(), [&](const pair<pair<int, int>, int> &a, const pair<pair<int, int>, int> &b) {
        return a.first.second < b.first.second;
    });

    sort(segs.begin(), segs.end(), [&](const pair<int, int> &a, const pair<int, int> &b) {
        return a.second < b.second;
    });

    int seg_ind = 0;

    ordered_set<pair<int, int>> cur;

    for (auto [lr, ind] : que) {
        auto [l, r] = lr;
        while (seg_ind < segs.size() && segs[seg_ind].second <= r) {
            cur.insert({segs[seg_ind].first, seg_ind});
            ++seg_ind;
        }
        ans[ind] -= (int)cur.size() - cur.order_of_key({l, -1});
    }


    // first
    for (int i = 0; i < q; ++i) {
        ans[i] += 1;
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i] << '\n';
    }

    return 0;
}
