#pragma GCC optimize("O3", "unroll-loops")
#pragma GCC target("sse4.2")

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <sstream>
#include <deque>
#include <queue>
#include <complex>
#include <random>
#include <cassert>
#include <chrono>
#include <functional>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define FIXED cout << fixed << setprecision(12)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define f first
#define s second
#define hashmap unordered_map
#define hashset unordered_set
#define eps 1e-9
#define mod 1000000007
#define inf 3000000000000000007ll
#define sz(a) signed((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#ifdef DEBUG
    mt19937 gen(857204);
#else
    mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

void flush() { cout << flush; }
void flushln() { cout << endl; }
void println() { cout << '\n'; }
template<class T> void print(const T &x) { cout << x; }
template<class T> void read(T &x) { cin >> x; }
template<class T, class ...U> void read(T &x, U& ... u) { read(x); read(u...); }
template<class T, class ...U> void print(const T &x, const U& ... u) { print(x); print(u...); }
template<class T, class ...U> void println(const T &x, const U& ... u) { print(x); println(u...); }

#ifdef DEBUG
    template<class T> void pdbg(const T &x) { print(x); }
    template<class T, class U> void pdbg(const pair<T, U> &p) {
        print('{');
        pdbg(p.f);
        print(',');
        pdbg(p.s);
        print('}');
    }
    void pdbg(const string &s) { print("\"" + s + "\""); }
    template<class It> void pdbg(It begin, It end, string d);
    template<class T> void pdbg(const vector<T> &a) { pdbg(all(a), ""); }
    template<class T> void pdbg(const vector<vector<T>> &a) { pdbg(all(a), "\n"); }
    template<class T> void pdbg(const vector<vector<vector<T>>> &a) { pdbg(all(a), "\n\n"); }
    template<class T> void pdbg(const set<T> &a) { pdbg(all(a), ""); }
    template<class T> void pdbg(const hashset<T> &a) { pdbg(all(a), ""); }
    template<class T, class U> void pdbg(const map<T, U> &a) { pdbg(all(a), ""); }
    template<class T, class U> void pdbg(const hashmap<T, U> &a) { pdbg(all(a), ""); }
    template<class It> void pdbg(It begin, It end, string d) {
        print('{');
        if (begin != end) pdbg(*begin++);
        while (begin != end)
            print(",", d), pdbg(*begin++);
        print('}');
    }
    template<class T> void dbgout(const T &x) { pdbg(x); }
    template<class T, class... U>
    void dbgout(T const &t, const U &... u) {
        pdbg(t);
        print(", ");
        dbgout(u...);
    }
    #define dbg(...) print("[", #__VA_ARGS__, "] = "), dbgout(__VA_ARGS__), flushln()
#else
    #define dbg(...) 0
#endif

template<class T, class U> inline bool chmin(T &x, const U& y) { return y < x ? x = y, 1 : 0; }
template<class T, class U> inline bool chmax(T &x, const U& y) { return y > x ? x = y, 1 : 0; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T, class U> inline istream& operator>>(istream& str, pair<T, U> &p) { return str >> p.f >> p.s; }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }
template<class T> inline T sorted(T a) { sort(a); return a; }

set<char> used;

signed main() {
    FAST; FIXED;
    string s, t;
    read(s, t);
    for (auto i : s) used.insert(i);
    for (auto i : t) used.insert(i);
    if (sz(used) > 10) {
        println(0);
        return 0;
    }
    int n;
    read(n);
    map<string, vector<int>> pat;
    vector<string> inp;
    vector<int> need(n);
    for (int i = 0; i < n; ++i) {
        string x;
        read(x);
        inp.pb(x);
        map<char, char> was;
        char ptr = 'a';
        for (auto &i : x) {
            if (used.count(i)) continue;
            if (was.count(i)) i = was[i];
            else i = was[i] = ptr++;
        }
        if (sz(was) + sz(used) > 10) continue;
        need[i] = 1;
        for (int l = 1; l <= 10 - (sz(was) + sz(used)) + 1; ++l)
            need[i] *= l;
        pat[x].pb(i);
    }
    vector<char> c(all(used));
    dbg(c);
    map<char, int> ind;
    for (int i = 0; i < sz(c); ++i) ind[c[i]] = i;
    vector<char> perm(10);
    iota(all(perm), '0');
    auto getdig = [&](char c) {
        return perm[ind[c]];
    };
    vector<int> ans(n);
    while (true) {
        if (getdig(s[0]) != '0' && getdig(t[0]) != '0') {
            int vs = 0, vt = 0;
            for (int i = 0; i < sz(s); ++i)
                vs = vs * 10 + (getdig(s[i]) - '0');
            for (int i = 0; i < sz(s); ++i)
                vt = vt * 10 + (getdig(t[i]) - '0');
            string res = to_string(vs + vt);
            map<char, char> was;
            char ptr = 'a';
            map<char, int> digpos;
            for (int i = 0; i < sz(c); ++i)
                digpos[perm[i]] = i;
            for (auto &i : res) {
                if (digpos.count(i)) {
                    i = c[digpos[i]];
                } else {
                    if (was.count(i)) i = was[i];
                    else i = was[i] = ptr++;
                }
            }

            auto &p = pat[res];
            vector<int> newp;
            for (auto i : p) {
                ++ans[i];
                //if (ans[i] < 2)
                    newp.pb(i);
            }
            p = move(newp);
        }
        if (!next_permutation(all(perm))) break;
    }
    dbg(ans);
    vector<string> answer;
    for (int i = 0; i < n; ++i)
        if (ans[i] == need[i]) answer.pb(inp[i]);
    println(sz(answer));
    for (auto i : answer) println(i);
    #ifdef DEBUG
        cerr << "Runtime is: " << clock() * 1.0 / CLOCKS_PER_SEC << endl;
    #endif
    return 0;
}