#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int make_mask(const string& s) {
    int mask = 0;
    for (char c : s) {
        mask <<= 1;
        if (c == 'W') {
            mask |= 1;
        }
    }
    return mask;
}

inline int dst(int m1, int m2) {
    return 8 - __builtin_popcount(m1 ^ m2);
}

inline int bit(int x, int i) {
    return (x >> i) & 1;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        a[i] = make_mask(s);
    }

    vector<vector<bool>> dp(n + 1, vector<bool>(1 << 8));

    for (int mask = 0; mask < 1 << 8; ++mask) {
        dp[0][mask] = bit(mask, 0);
    }

    for (int p = 1; p <= n; ++p) {
        for (int mask = 0; mask < 1 << 8; ++mask) {
            int ok = 0;
            for (int i = 1; i <= 8 && p - 1 + i < n; ++i) {
                if (i <= dst(a[p - 1], a[p - 1 + i])) {
                    if (bit(mask, i - 1) == 0) {
                        ok = 1;
                        break;
                    }
                }
            }

            int mask1 = (mask << 1) & ((1 << 8) - 1);
            mask1 |= ok;
            dp[p][mask] = dp[p - 1][mask1];
        }
    }

    for (int pref = 1; pref <= n; ++pref) {
        vector<int> oks(min(8, pref));
        for (int i = pref - 1, j = oks.size() - 1; i >= 0 && j >= 0; --i, --j) {
            for (int d = 1; d <= 8; ++d) {
                if (i + d < pref && d <= dst(a[i], a[i + d])) {
                    if (oks[j + d] == 0) {
                        oks[j] = 1;
                        break;
                    }
                }
            }
        }

        int ans = -1;
        if (pref <= 8) {
            ans = oks[0];
        } else {
            int mask = 0;
            for (int i = oks.size() - 1; i >= 0; --i) {
                mask <<= 1;
                mask |= oks[i];
            }
            ans = dp[pref - 8][mask];
        }

        cout << 2 - ans;
    }

    cout << endl;

    return 0;
}
