#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>

using namespace std;

constexpr int N = 600500;

std::vector<tuple<int, long long, int>> term;
int term_size = 0;

int l[N];
int r[N];
int x[N];

int unx[N];

std::vector<tuple<int, int, int>> vertices;

int mn[N];
int mx[N];
int min_h = 0;
int tot_v = 0;

vector<int> lb;
vector<int> rb;

void dfs(int v, int h = 1) {
    tot_v++;

    if (v == -1) {

//        std::cerr << "TERM " << h << ' ' << min_h << '\n';
//        term.push_back({p, h - min_h, h});
//        if (term.size() > 1) {
//            get<1>(term[term.size() - 1]) += get<1>(term[term.size() - 2]);
//        } else {
//            get<1>(term[term.size() - 1]) = 0;
//        }

        return;
    }

//    if (l[v] != -1) {
    dfs(l[v], h + 1);
//    }
//    if (r[v] != -1) {
    min_h = h;
    dfs(r[v], h + 1);
//    }
    min_h = h;

    mn[v] = l[v] != -1 ? mn[l[v]] : x[v];
    mx[v] = r[v] != -1 ? mx[r[v]] : x[v];


//    std::cerr << "! " << v << ' ' << h << ' ' << x[v] << ' ' << mn[v] << ' ' << mx[v] << '\n';
}

void dfs2(int v, int plb, int prb, int p = -1) {
    lb.push_back(plb);
    rb.push_back(prb);

//    std::cerr << " > " << v + 1 << ' ' << plb << ' ' << prb << ' ' << p + 1 << '\n';

    if (v == -1) return;

//    if (l[v] == -1 && r[v] == -1) {
//        return;
//    }

//    std::cerr << " < " << v + 1 << ' ' << mn[v] << ' ' << mx[v] << ' ' << p + 1 << '\n';

    dfs2(l[v], mn[v], mx[v], v);
    dfs2(r[v], mn[v], mx[v], v);
    vertices.push_back({mn[v], mx[v], 2});
}

bool cmp(tuple<int, int, int> a, tuple<int, int, int> b) {
    return get<1>(a) < get<1>(b);
}

//bool cmp(pair<int, int> a, pair<int, int> b) {
//    return a.second < b.second;
//}

int st[N * 4];

void add(int l, int r, int v, int to, int val) {
    if (l > to || r <= to) return;
    st[v] += val;
    if (l + 1 == r) return;

    if (to < (l + r) / 2) {
        add(l, (l + r) / 2, v * 2, to, val);
    } else {
        add((l + r) / 2, r, v * 2 + 1, to, val);
    }
}

int get_res(int l, int r, int v, int lb, int rb) {
//    std::cerr << "get_res " << l << ' ' << r << ' ' << lb << ' ' << rb << '\n';
    if (l >= rb || r <= lb) return 0;
    if (l >= lb && r <= rb) {
//        std::cerr << "get_res return " << v << ' ' << l << ' ' << r << ' ' << st[v] << '\n';
        return st[v];
    }
    return get_res(l, (l + r) / 2, v * 2, lb, rb) + get_res((l + r) / 2, r, v * 2 + 1, lb, rb);
}


int ans[N];

std::vector<std::tuple<int, int, int>> queries;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef HOME
    freopen("in", "r", stdin);
#endif

    int n;
    cin >> n;
    std::vector<int> all_x;
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i] >> unx[i];
        all_x.push_back(unx[i]);
        --l[i];
        --r[i];
    }
    int q;
    cin >> q;

    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;
        all_x.push_back(l);
        all_x.push_back(r);
        queries.push_back({l, r, i});
    }

//    std::cerr << all_x.size() << '\n';

    sort(all_x.begin(), all_x.end());
    all_x.resize(unique(all_x.begin(), all_x.end()) - all_x.begin());

    for (int i = 0; i < n; i++) {
        x[i] = lower_bound(all_x.begin(), all_x.end(), unx[i]) - all_x.begin();
    }

    for (int i = 0; i < q; i++) {
        get<0>(queries[i]) = lower_bound(all_x.begin(), all_x.end(), get<0>(queries[i])) - all_x.begin();
        get<1>(queries[i]) = lower_bound(all_x.begin(), all_x.end(), get<1>(queries[i])) - all_x.begin();
    }

    sort(queries.begin(), queries.end(), cmp);

    int q_i = 0;
    int v_i = 0;


    dfs(0, 1);
    dfs2(0, 0, all_x.size());

    sort(lb.begin(), lb.end());
    sort(rb.begin(), rb.end());
    sort(vertices.begin(), vertices.end(), cmp);

    for (int x = 0; x < all_x.size(); x++) {
        while (v_i < vertices.size() && get<1>(vertices[v_i]) == x) {
            add(0, all_x.size(), 1, get<0>(vertices[v_i]), get<2>(vertices[v_i]));
            ++v_i;
        }

        while (q_i < queries.size() && get<1>(queries[q_i]) == x) {
            int res = 0;

            res = tot_v;
            res -= lb.end() - upper_bound(lb.begin(), lb.end(), x);
            res -= lower_bound(rb.begin(), rb.end(), get<0>(queries[q_i])) - rb.begin();

            res -= get_res(0, all_x.size(), 1, get<0>(queries[q_i]), x + 1);

            ans[get<2>(queries[q_i])] = res;
            q_i++;
        }
    }

    for (int i = 0; i < q; i++) {
        cout << ans[i] << '\n';
    }

    return 0;
}
