#include <bits/stdc++.h>

using namespace std;
using Graph = vector<vector<int>>;
typedef long long ll;

template<class T>
std::ostream &operator<<(std::ostream &os, const std::vector<T> &V) {
    os << "[";
    for (int i = 0; i < V.size(); ++i) {
        if (i > 0) os << ", ";
        os << V[i];
    }
    os << "]";
    return os;
}

template<class A, class B>
std::ostream &operator<<(std::ostream &os, const std::pair<A, B> &V) {
    os << "{" << V.first << ", " << V.second << "}";
    return os;
}

template<class A, class B, class C, class D>
std::ostream &operator<<(std::ostream &os, const std::map<A, B, C, D> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << it->first << ": " << it->second;
    }
    os << "}";
    return os;
}

template<class A, class B, class C, class D, class E>
std::ostream &operator<<(std::ostream &os, const std::unordered_map<A, B, C, D, E> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << it->first << ": " << it->second;
    }
    os << "}";
    return os;
}

template<class A, class B, class C>
std::ostream &operator<<(std::ostream &os, const std::set<A, B, C> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << *it;
    }
    os << "}";
    return os;
}

template<class A, class B, class C, class D>
std::ostream &operator<<(std::ostream &os, const std::unordered_set<A, B, C, D> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << *it;
    }
    os << "}";
    return os;
}

void debug_func() {}

template<class Head, class...Tail>
void debug_func(Head H, Tail... T) {
    std::cout << " " << H;
    debug_func(T...);
}

#ifdef OCHKO
#define debug(...) std::cout << "[" << #__VA_ARGS__ "]:"; debug_func(__VA_ARGS__);cout << endl;
#else
#define debug(...) 3;
#endif

unordered_map<int, int> d2c;
unordered_map<int, int> c2d;
string a, b;
unordered_map<char, int> codes;

vector<int> fcodes, scodes;

unordered_set<int64_t> good;
unordered_set<int64_t> bad;
vector<int> zhopa;

void generate(unordered_set<int>& unused, int ind) {
    if (ind == zhopa.size()) {
        long long first = 0, second = 0;
        long long pw = 1;
        for (int i = a.length() - 1; i >= 0; --i) {
            first += pw * c2d[fcodes[i]];
            pw *= 10;
        }
        pw = 1;
        for (int i = b.length() - 1; i >= 0; --i) {
            second += pw * c2d[scodes[i]];
            pw *= 10;
        }

        long long result = first + second;
        int64_t kek = 0;
        int mem = codes.size() + 1;
        vector<int> todel;
        int sdv = 0;
        while (result > 0) {
            int dig = result % 10;
            result /= 10;
            if (d2c.count(dig)) {
                kek |= int64_t(d2c[dig]) << sdv;
            }
            else {
                kek |= int64_t(mem) << sdv;
                d2c[dig] = mem++;
                todel.push_back(dig);
            }
            sdv += 4;
        }
        for (int i : todel) d2c.erase(i);


        if (!bad.count(kek) && !good.count(kek)) {
            good.insert(kek);
        } else if (good.count(kek)){
            good.erase(kek);
            bad.insert(kek);
        }
        return;
    }

    if (c2d.count(zhopa[ind])) {
        generate( unused, ind + 1);
    } else {
        auto unused2 = unused;
        for (int i : unused) {
            d2c[i] = zhopa[ind];
            c2d[zhopa[ind]] = i;
            unused2.erase(i);
            generate( unused2, ind + 1);
            unused2.insert(i);
            d2c.erase(i);
        }
        c2d.erase(zhopa[ind]);
    }

}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef OCHKO
    freopen("in", "r", stdin);
    //freopen("out", "w", stdout);
#endif

    cin >> a >> b;
    unordered_map<char, int> M;
    unordered_set<char> S;
    for (char q : a) {
        S.insert(q);
    }
    for (char q : b) {
        S.insert(q);
    }
    if (S.size() > 10) {
        cout << 0;
        return 0;
    }


    unordered_set<int> unused(10);
    for (int i = 0; i < 10; ++i) unused.insert(i);
    vector<char> order{S.begin(), S.end()};
    for (int i = 0; i < order.size(); ++i) {
        codes[order[i]] = i + 1;
        zhopa.push_back(i + 1);
    }
    fcodes.resize(a.length());
    scodes.resize(b.length());
    for (int i =0 ; i < a.length(); ++i) {
        fcodes[i] = codes[a[i]];
    }

    for (int i =0 ; i < b.length(); ++i) {
        scodes[i] = codes[b[i]];
    }
    generate( unused, 0);

    int t;
    cin >> t;
    vector<string> ans;
    while (t--) {
        string mem;
        cin >> mem;
        if (mem.length() < a.length() || mem.length() < b.length()) continue;
        int64_t encode = 0;
        unordered_map<char, int64_t> her;
        int64_t rr = codes.size() + 1;
        int sdv = 0;
        for (int i = mem.length() - 1; i >= 0; --i) {
            if (!her.count(mem[i]) && !S.count(mem[i])) {
                her[mem[i]] = rr;
                if (her.size() + S.size() > 10) {
                    encode = -1;
                    break;
                }
                encode |= int64_t(rr) << sdv;
                ++rr;
            } else if (S.count(mem[i])){
                encode |= int64_t(codes[mem[i]]) << sdv;
            } else {
                encode |= int64_t(her[mem[i]]) << sdv;
            }
            sdv += 4;
        }

        if (good.count(encode)) {
            ans.push_back(mem);
        }
    }
    cout << ans.size() << "\n";
    for (auto& i : ans) cout << i << "\n";
	return 0;
}

