#include <bits/stdc++.h>

using namespace std;
using Graph = vector<vector<int>>;
typedef long long ll;
#define all(x) (x).begin(), (x).end()

template<class T>
std::ostream &operator<<(std::ostream &os, const std::vector<T> &V) {
    os << "[";
    for (int i = 0; i < V.size(); ++i) {
        if (i > 0) os << ", ";
        os << V[i];
    }
    os << "]";
    return os;
}

template<class A, class B>
std::ostream &operator<<(std::ostream &os, const std::pair<A, B> &V) {
    os << "{" << V.first << ", " << V.second << "}";
    return os;
}

template<class A, class B, class C, class D>
std::ostream &operator<<(std::ostream &os, const std::map<A, B, C, D> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << it->first << ": " << it->second;
    }
    os << "}";
    return os;
}

template<class A, class B, class C, class D, class E>
std::ostream &operator<<(std::ostream &os, const std::unordered_map<A, B, C, D, E> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << it->first << ": " << it->second;
    }
    os << "}";
    return os;
}

template<class A, class B, class C>
std::ostream &operator<<(std::ostream &os, const std::set<A, B, C> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << *it;
    }
    os << "}";
    return os;
}

template<class A, class B, class C, class D>
std::ostream &operator<<(std::ostream &os, const std::unordered_set<A, B, C, D> &V) {
    os << "{";
    for (auto it = V.begin(); it != V.end(); ++it) {
        if (it != V.begin()) {
            os << ", ";
        }
        os << *it;
    }
    os << "}";
    return os;
}

void debug_func() {}

template<class Head, class...Tail>
void debug_func(Head H, Tail... T) {
    std::cout << " " << H;
    debug_func(T...);
}

#ifdef OCHKO
#define debug(...) std::cout << "[" << #__VA_ARGS__ "]:"; debug_func(__VA_ARGS__);cout << endl;
#else
#define debug(...) 3;
#endif

vector<int> solve(const vector<vector<int>>& G, int v, int p) {
    vector<int> result;
    for (int i : G[v]) {
        if (i == p) continue;
        auto kek = solve(G, i, v);
        vector<int> result2 = result;
        reverse(result.begin(), result.end());
        for (int j : kek) {
            result2.push_back(j);
            for (int q : result) result2.push_back(q);
            reverse(result.begin(), result.end());
        }
        result = result2;
    }
    reverse(result.begin(), result.end());
    result.push_back(v);
    reverse(result.begin(), result.end());
    return result;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef OCHKO
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<vector<int>> G(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        G[p].push_back(i);
        G[i].push_back(p);
    }
    auto result = solve(G, 0, 0);
    cout << result.size() - 1 << "\n";
    for (int i=1; i < result.size(); ++i) cout << result[i] + 1 << ' ';
	return 0;
}

