#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <array>
#include <stack>

using namespace std;
using Graph = vector<vector<int>>;
typedef long long ll;
#define all(x) (x).begin(), (x).end()

template<class T>
std::ostream &operator<<(std::ostream &os, const std::vector<T> &V) {
  os << "[";
  for (int i = 0; i < V.size(); ++i) {
    if (i > 0) os << ", ";
    os << V[i];
  }
  os << "]";
  return os;
}

template<class A, class B>
std::ostream &operator<<(std::ostream &os, const std::pair<A, B> &V) {
  os << "{" << V.first << ", " << V.second << "}";
  return os;
}

template<class A, class B, class C, class D>
std::ostream &operator<<(std::ostream &os, const std::map<A, B, C, D> &V) {
  os << "{";
  for (auto it = V.begin(); it != V.end(); ++it) {
    if (it != V.begin()) {
      os << ", ";
    }
    os << it->first << ": " << it->second;
  }
  os << "}";
  return os;
}

template<class A, class B, class C, class D, class E>
std::ostream &operator<<(std::ostream &os, const std::unordered_map<A, B, C, D, E> &V) {
  os << "{";
  for (auto it = V.begin(); it != V.end(); ++it) {
    if (it != V.begin()) {
      os << ", ";
    }
    os << it->first << ": " << it->second;
  }
  os << "}";
  return os;
}

template<class A, class B, class C>
std::ostream &operator<<(std::ostream &os, const std::set<A, B, C> &V) {
  os << "{";
  for (auto it = V.begin(); it != V.end(); ++it) {
    if (it != V.begin()) {
      os << ", ";
    }
    os << *it;
  }
  os << "}";
  return os;
}

template<class A, class B, class C, class D>
std::ostream &operator<<(std::ostream &os, const std::unordered_set<A, B, C, D> &V) {
  os << "{";
  for (auto it = V.begin(); it != V.end(); ++it) {
    if (it != V.begin()) {
      os << ", ";
    }
    os << *it;
  }
  os << "}";
  return os;
}

void debug_func() {}

template<class Head, class...Tail>
void debug_func(Head H, Tail... T) {
  std::cout << " " << H;
  debug_func(T...);
}

#ifdef OCHKO
#define debug(...) std::cout << "[" << #__VA_ARGS__ "]:"; debug_func(__VA_ARGS__);cout << endl;
#else
#define debug(...) 3;
#endif


int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n;
  cin >> n;
  int least = 100 * 1000 + 7;
  int pack = 0;
  for (int i = 0; i < n; ++i) {
    int p;
    cin >> p;
    string s;
    cin >> s;
    int c0 = 0, c1 = 0, c2 = 0;
    for (char c: s) {
      if (c == '0') {
        ++c0;
      } else if (c == '1') {
        ++c1;
      } else if (c == '2') {
        ++c2;
      }
    }
    if (c0 >= 1 && c1 >= 1 && c2 >= 2 && p < least) {
      least = p;
      pack = i + 1;
    }
  }
  cout << pack << '\n';
  return 0;
}