#include <iostream>
#include <map>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <random>
#include <time.h>
#include <string>
#include <cstring>
#include <set>
#include <cmath>
#include <cassert>

using namespace std;

map<pair<int,int>, bool> mp;

bool can(int a, int b) {
    if (a + b <= 1) {
        return true;
    }
    auto it = mp.find({a, b});
    if (it != mp.end()) {
        return it->second;
    }

    bool res = false;
    if (b % 2 == 1) {
        --b;
        int la = a / 2;
        int ra = a - la;
        int lb = b / 2;
        int rb = b - lb;
        res |= can(la, lb) && can(ra, rb);
        ++b;
        mp[{a,b}] = res;
        return res;
    }
    if (b % 2 == 0) {
        if (a == 0) {
            return false;
        } else {
            --a;
            int la = a / 2;
            int ra = a - la;
            int lb = b / 2;
            int rb = b - lb;
            res |= can(la, lb) && can(ra, rb);
            ++a;
            mp[{a,b}] = res;
            return res;
        }
    }
    if (a > 0 && !res) {
        --a;
        for (int lb = 0; lb <= b; ++lb) {
            int rb = b - lb;
            if (res) break;
            for (int la = 0; la <= a; ++la) {
                int ra = a - la;
                int diff = abs(lb * 2 + la - 2 * rb - ra);
                if (diff <= 1) {
                    res |= can(la, lb) && can(ra, rb);
                }
            }
        }
        ++a;
    }

    if (b > 0 && !res) {
        --b;
        for (int lb = 0; lb <= b; ++lb) {
            if (res) break;
            int rb = b - lb;
            for (int la = 0; la <= a; ++la) {
                int ra = a - la;
                int diff = abs(lb * 2 + la - 2 * rb - ra);
                if (diff <= 1) {
                    res |= can(la, lb) && can(ra, rb);
                }
            }
        }
        ++b;
    }
    return mp[{a,b}] = res;
}

bool fast_can(int a, int b) {
    if (a + b == 0) {
        return true;
    }
    int rstair = 1;
    int sz = 1;
    while (rstair <= b) {
        sz *= 2;
        rstair += sz;
    }
    if (rstair - sz == b) {
        return true;
    }
    int szHere = rstair - b;
    return szHere <= a;
}

map <int, pair<int,int>> G;

const int N = 1e5 + 1;
int weight[N];
int pool = 0;

int get_vertex() {
    ++pool;
    G[pool] = {0,0};
    return pool;
}

int recur(int a, int b) {
    if (a == 0 && b == 0) {
        return 0;
    }
    int me = get_vertex();
    if (b % 2 == 1) {
        --b;
        weight[me] = 2;
        int la = a / 2;
        int ra = a - la;
        int lb = b / 2;
        int rb = b - lb;

        int lv = recur(la, lb);
        int rv = recur(ra, rb);
        G[me] = {lv, rv};
        ++b;
    } else {
        if (a == 0) {
            assert(false);
        } else {
            weight[me] = 1;
            --a;
            int la = a / 2;
            int ra = a - la;
            int lb = b / 2;
            int rb = b - lb;

            int lv = recur(la, lb);
            int rv = recur(ra, rb);
            ++a;
            G[me] = {lv, rv};
        }
    }
    return me;
}

int main() {
#ifdef LOCAL_ENV
    freopen("a.in", "r", stdin);
#endif
    ::ios_base::sync_with_stdio(false);
    cin.tie(0);
    int a, b;
    cin >> a >> b;
    if (!fast_can(a, b)) {
        cout << -1 << endl;
        return 0;
    }
    recur(a, b);
    for (int i = 1; i <= pool; ++i) {
        cout << weight[i] << " " << G[i].first << " " << G[i].second << endl;
    }
    return 0;
}