#include <iostream>
#include <map>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <functional>
#include <random>
#include <time.h>
#include <string>
#include <cstring>
#include <set>
#include <cmath>
#include <cassert>

using namespace std;

const int N = 1e5 + 1;

vector <int> res;
vector <int> G[N];
vector<bool> branch_dirs[N];
int current_branch[N];
vector<pair<int, bool>> branch_order[N];
int color[N];

void Xor(int n) {
    color[n] ^= 1;
    res.push_back(n + 1);
}

int step(int v, bool forward) {
    if (forward) {
        if (color[v] == 0) {
            Xor(v);
            return 1;
        }
        if (G[v].empty()) {
            return 0;
        } else {
            while (true) {
                int branch = current_branch[v];
                bool dir = branch_dirs[v][branch];
                int to = G[v][branch];
                if (step(to, dir) == 0) {
                    if (branch + 1 == G[v].size()) {
                        break;
                    }
                    branch_dirs[v][branch] = !branch_dirs[v][branch];
                    ++current_branch[v];
                } else {
                    branch_order[v].emplace_back(branch, dir);
                    current_branch[v] = 0;
                    return 1;
                }
            }
        }
    } else {
        if (color[v] == 0) {
            return 0;
        }
        if (G[v].empty()) {
            Xor(v);
            return 1;
        }
        if (!branch_order[v].empty()) {
            int branch = branch_order[v].back().first;
            bool dir = branch_order[v].back().second;
            int to = G[v][branch];
            branch_order[v].pop_back();
            dir = !dir;
            assert(step(to, dir) == 1);
            return 1;
        }
        Xor(v);
        return 1;
    }
    return 0;
}

int main() {
#ifdef LOCAL_ENV
    freopen("a.in", "r", stdin);
#endif
    ::ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        G[p].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        branch_dirs[i] = vector<bool>(G[i].size(), true);
    }
    color[0] = 1;
    while (step(0, true) != 0);
    cout << res.size() << endl;
    for (auto x : res) {
        cout << x << " ";
    }
    return 0;
}