#include <bits/stdc++.h>
using namespace std;

// answer is 1 + 2 * {# of nodes that branch out}

const int inf = 1e9;

struct segtree {
    int lb, rb;
    int sum = 0;
    segtree *l = 0, *r = 0;
    segtree (int _lb, int _rb) {
        lb = _lb, rb = _rb;
    }
    void extend () {
        int t = (1ll * lb + rb) / 2;
        if (!l) {
            //cerr << "extend " << lb << " " << rb << " " << t << endl;
            l = new segtree(lb, t);
            r = new segtree(t+1, rb);
        }
    }
    void add (int k, int x) {
        sum += x;
        if (lb != rb) {
            extend();
            int t = (1ll * lb + rb) / 2;
            if (k <= t) l->add(k, x);
            else r->add(k, x);
        }
    }
    int get_sum (int lq, int rq) {
        //cerr << lb << " " << rb << " : " << sum << endl;
        if (lb >= lq && rb <= rq) return sum;
        if (lb > rq || rb < lq) return 0;
        extend();
        return l->get_sum(lq, rq) + r->get_sum(lq, rq);
    }
};

const int maxn = 2e5 + 5;
int l[maxn], r[maxn], k[maxn];
int _l[maxn], _r[maxn];
int results[maxn];

set<int> xs;
map<int, vector<int>> adds;

struct Query {
    int L, R;
    int result_idx;
};

map<int, vector<Query>> queries;

void add_query(int x, Query q) {
    xs.insert(x);
    queries[x].push_back(q);
}

void build_events(int v) {
    if (v == 0)
        return;
    build_events(l[v]);
    build_events(r[v]);
    _l[v] = min(k[v], _l[l[v]]);
    _r[v] = max(k[v], _r[r[v]]);
    xs.insert(_l[v]);
    adds[_l[v]].push_back(_r[v]);
}

int main() {
    int n;
    cin >> n;

    for (int i = 1; i <= n; i++)
        cin >> l[i] >> r[i] >> k[i];
    
    _l[0] = inf;
    _r[0] = -inf;
    build_events(1);

    int q;
    cin >> q;

    for (int i = 0; i < q; i++) {
        int L, R;
        cin >> L >> R;
        // everything, except:
        // v.max < L                  y < L
        // v.min > R                  x > R
        // L <= v.min && v.max <= R   L <= x, y <= R
        add_query(L - 1, {L, R, i});
        add_query(R, {R + 1, inf, i});
        /*
        add_query(-inf, {-inf, L - 1, i});
        results[i] = n;
        add_query(R, {-inf, inf, i, -1});
        add_query();
        */
    }

    segtree s(0, 2 * inf);

    /*
    for (int x : xs) {
        for (int y : adds[x]) {
            cerr << x << " " << y << endl;
        }
    }
    */

    for (int x : xs) {
        //cerr << "x " << x << endl;
        for (int y : adds[x]) {
            //cerr << "add " << y << endl;
            s.add(y + inf, 1);
        }
        for (auto q : queries[x]) {
            int res = s.get_sum(q.L + inf, q.R + inf);
            //cerr << "q " << q.L << " " << q.R << " " << q.result_idx << " " << res << endl;
            results[q.result_idx] += res;
        }
    }
    
    for (int i = 0; i < q; i++)
        cout << 1 + 2 * results[i] << endl;

    return 0;
}
