#include <bits/stdc++.h>
using namespace std;

// definitions
using ld = long double;
using ll = unsigned long long;

// other
#define endl '\n'
#define fast_io              \
    ios::sync_with_stdio(0); \
    cin.tie(0);              \
    cout.tie(0)

ll extGcd(ll a, ll b, ll &x, ll &y)
{
    bool negativeA = false;
    if (a < 0) {
        negativeA = true;
        a = -a;
    }
    bool negativeB = false;
    if (b < 0) {
        negativeB = true;
        b = -b;
    }
    x = 1;
    y = 0;
    ll xTmp = 0;
    ll yTmp = 1;
    while (b) {
        ll q = a / b;
        tie(x, xTmp) = make_tuple(xTmp, x - q * xTmp);
        tie(y, yTmp) = make_tuple(yTmp, y - q * yTmp);
        tie(a, b) = make_tuple(b, a - q * b);
    }
    if (negativeA) {
        x = -x;
    }
    if (negativeB) {
        y = -y;
    }
    return a;
}

ll linearDiophantineSolutionCount(
    ll a,
    ll b,
    const ll &c,
    ll xmin,
    ll xmax,
    ll ymin,
    ll ymax)
{
    if (xmin > xmax || ymin > ymax) {
        return 0;
    }
    ll xCount = xmax - xmin + 1;
    ll yCount = ymax - ymin + 1;
    if (!a && !b) {
        return c ? 0 : xCount * yCount;
    }
    if (!a) {
        if (c % b) {
            return 0;
        }
        ll y = c / b;
        return ymin <= y && y <= ymax ? xCount : 0;
    }
    if (!b) {
        if (c % a) {
            return 0;
        }
        ll x = c / a;
        return xmin <= x && x <= xmax ? yCount : 0;
    }
    bool negativeA = false;
    if (a < 0) {
        negativeA = true;
        a = -a;
    }
    bool negativeB = false;
    if (b < 0) {
        negativeB = true;
        b = -b;
    }
    ll x, y;
    ll gcd = extGcd(a, b, x, y);
    if (c % gcd) {
        return 0;
    }
    if (negativeA) {
        swap(xmin, xmax);
        xmin = -xmin;
        xmax = -xmax;
    }
    if (negativeB) {
        swap(ymin, ymax);
        ymin = -ymin;
        ymax = -ymax;
    }
    ll mul = c / gcd;
    x *= mul;
    y *= mul;
    ll dx = b / gcd, dy = a / gcd;
    auto shift = [&x, &y, &dx, &dy](const ll &delta) {
        x += delta * dx;
        y -= delta * dy;
    };
    if (x < xmin) {
        shift((xmin - x + dx - 1) / dx);
    }
    else {
        shift(-((x - xmin) / dx));
    }
    if (x > xmax || y < ymin) {
        return 0;
    }
    if (y > ymax) {
        shift((y - ymax + dy - 1) / dy);
    }
    if (xmax < x || y < ymin) {
        return 0;
    }
    return min((xmax - x) / dx, (y - ymin) / dy) + 1;
}

int main()
{
    fast_io;
    ll n, a, b, c, d, ans, x0, y0, g;
    cin >> n;
    while (n--) {
        cin >> b >> d;
        cout << linearDiophantineSolutionCount(d, b, b * b, 1, ULLONG_MAX, 1, ULLONG_MAX) << endl;
    }
}
